      subroutine th_timewindows(isubthe,icase,iput,iget,info)
      implicit none

      include 'comglb.for'
      include 'comthe.for'

      integer isubthe,icase,iput,iget,info
      real          c1,an_strob_order,
     &              t1_window,t2_window,amplitude_t12,
     &              t3_window,t4_window,amplitude_t34,dumc
      common/acmaps/c1,an_strob_order,
     &              t1_window,t2_window,amplitude_t12,
     &              t3_window,t4_window,amplitude_t34,
     &              dumc(icstrf-8)
      logical       b_c1,b_strob_order,
     &              b_t1_window,b_t2_window,b_amplitude_t12,
     &              b_t3_window,b_t4_window,b_amplitude_t34,b_dumc
      common/bcmaps/b_c1,b_strob_order,
     &              b_t1_window,b_t2_window,b_amplitude_t12,
     &              b_t3_window,b_t4_window,b_amplitude_t34,
     &              b_dumc(icstrf-8)
      real          v1,va12,vb12,dumv
      common/avmaps/v1,va12,vb12,dumv(ivstrf-3)
      logical       b_v1,b_va12,b_vb12,b_dumv
      common/bvmaps/b_v1,b_va12,b_vb12,b_dumv(ivstrf-3)

      integer i,nStrobo
      real    T2pT1,T2mT1,pi
      complex swin,hci 


c      write(6,'(a,4i6,a)')'th_timewindows isubthe,icase,iput,iget=',
c     &                isubthe,icase,iput,iget
c      write(6,'(a,6f12.3)')'theory12 dumc(icstrf-1...)=',
c     &                      (dumc(i),i=icstrf-6,icstrf-1)
c      write(6,'(a,10f12.3)')'theory12 c1...=',c1,an_strob_order,
c     &              t1_window,t2_window,amplitude_t12,
c     &              t3_window,t4_window,amplitude_t34

      if(isubthe.lt.0) then
       c1=an_strob_order*2+1
c      storage for this routine
c       write(6,'(a,i8)')'th_special n_strob_order=',int(an_strob_order)
       theoryname='rectangular_time_windows      v=100'
       return
      end if

       if(.not.b_c1) then
        isubthe=-abs(isubthe)
        return
       end if


      hci=(0.0,1.0)
      nStrobo=an_strob_order
      if(icase.eq.1) then
c      array_sp(iput+1)=s1
C      Calculation of the diskret frequencies     
C
c      Omega = 2.D0*PI/Tbunch
c      VOmega= Omega*h/E0*C/2.D0/PI          ! Omega in mm/s

       pi=atan(1.0)*4.0
       amplitude_t12  = 1.0/pi
       T2pT1 = (t2_window+t1_window)*pi
       T2mT1 = (t2_window-t1_window)*pi
  
       swin=amplitude_t12*cmplx(T2mT1,0.0)
       array_fr(iput+1)=swin
c       write(6,'(I4,2F10.3)')0,swin

       do i=1,nStrobo
         swin  = amplitude_t12*exp(hci*float(i)*T2pT1)
     &            *sin(float(i)*T2mT1)/float(i)
c       write(6,'(I4,2F10.3)')i,swin
        array_fr(iput+1+i)=swin
c       array_fr(iput+1+nStrobo-i)=conjg(swin)
       end do
c      else if (icase.eq.2) then
      end if

      return
C    End of calculation of the diskret frequencies     
C
      end

      subroutine th_sampleorient(isubthe,icase,iput,iget,info)
      implicit none

      include 'comglb.for'
      include 'comthe.for'

      integer isubthe,icase,iput,iget,info
      real          c1,dumc
      common/acmaps/c1,dumc(icstrf-1)

      real          v1,phi,theta,psi,ax_theta,ax_phi,omega,
     &              x_theta,x_phi,z_theta,z_phi,dumv
      common/avmaps/v1,phi,theta,psi,ax_theta,ax_phi,omega,
     &              x_theta,x_phi,z_theta,z_phi,dumv(ivstrf-11)
      logical       b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega,
     &              b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv
      common/bvmaps/b_v1,b_phi,b_theta,b_psi,b_axtheta,b_axphi,b_omega,
     &              b_xtheta,b_xphi,b_ztheta,b_zphi,b_dumv(ivstrf-11)

      real alpha,beta,gamma,rad,pi,thickness
      logical b_change,b_pc
      complex hc0
      parameter (pi=3.141592654,rad=0.017453293,hc0=(0.0,0.0))



      if(isubthe.lt.0) then
       c1=4
c      storage for this routine
       theoryname='sample_orientation'
       return
      end if
c      write(6,'(a,i2)')' enter sample_orientation icase=',icase
c     
      if(icase.eq.1) then
        array_fr(iput+2)=hc0                !  alpha,     false
        array_fr(iput+3)=hc0                !  beta,      not used
        array_fr(iput+4)=hc0                !  gamma,     not used
        array_fr(iput+1)=cmplx(1.0,1.0)     !  thickness, not used
        if(b_phi) then
         array_fr(iput+2)=cmplx(0.0,1.0)    ! alpha, true
        else
         isubthe=-abs(isubthe)              ! no change of input
        end if
       return
      end if

c       write(6,'(a,i2,i8,10f8.2)')
c     &   'icase,iput,phi,theta,psi,ax_theta,ax_phi,omega=',
c     &    icase,iput,phi,theta,psi,ax_theta,ax_phi,omega
c      write(6,'(10f12.2)')d_x2 ,x2_eta,x2_phi,x2_theta,x2_psi
      b_pc=.false.
      if(icase.eq.2.or.icase.eq.3) then
       b_change=b_phi.or.b_theta.or.b_psi.or.
     &                b_axtheta.or.b_axphi.or.b_omega
       if(b_change) then
        b_pc=.true.
        call euler_omega(ax_theta,ax_phi,omega,phi,theta,psi,
     &                    alpha,beta,gamma,thickness,icase,info)
        if(info.gt.0) return
c        write(6,'(a,g10.4,i3)')' thickness=',thickness,icase
        if(icase.eq.2) then
         array_fr(iput+1)=cmplx(1.0,1.0)
        else
         array_fr(iput+1)=cmplx(thickness,1.0)
        end if
c       write(6,'(a,i2,i8,/,10f12.2)')
c     &   'icase,iput,ax_theta,ax_phi,omega,alpha,beta,gamma=',
c     &    icase,iput,ax_theta,ax_phi,omega,alpha,beta,gamma
c       write(6,'(a,10f8.2)')
c     &   'omega,alpha,beta,gamma=',omega,alpha,beta,gamma
        array_fr(iput+2)=cmplx(alpha,1.0)
        array_fr(iput+3)=cmplx(beta,1.0)
        array_fr(iput+4)=cmplx(gamma,1.0)
       else
        alpha=real(array_fr(iput+2))
        array_fr(iput+2)=cmplx(alpha,0.0)
        isubthe=-abs(isubthe)
       end if
      else if(icase.gt.3) then
       b_change=b_xtheta.or.b_xphi.or.b_ztheta.or.b_zphi
       if(b_change) then
c       x,z unit vectors of the sample in the lab system
        b_pc=.true.

        call euler_dir(x_theta,x_phi,z_theta,z_phi,
     &                      alpha,beta,gamma,thickness,info)
        if(info.gt.0) return
        if(icase.eq.4) then
         array_fr(iput+1)=cmplx(1.0,1.0)
        else
         array_fr(iput+1)=cmplx(thickness,1.0)
        end if
        array_fr(iput+2)=cmplx(alpha,1.0)
        array_fr(iput+3)=cmplx(beta,1.0)
        array_fr(iput+4)=cmplx(gamma,1.0)
       else
        alpha=real(array_fr(iput+2))
        array_fr(iput+2)=cmplx(alpha,0.0) 
        isubthe=-abs(isubthe)
       end if
      end if
      return
      end



      
      
      
      
      
      
      
      
