c  the file hpg_neutron.f containes the following subroutines:
c      subroutine plotneutron(cmch)
c      subroutine integration(q_beg,q_end,nch_q,chrock,chrock2,
c      subroutine n_diffuse(maxl,NL,b_Cm,MAXGRP,GEOSTR,Cmatrix,VKD,
c      subroutine n_diffuse_base(maxl,NL,MAXGRP,GEOSTR,SFi_inc,SFi_fin,
c      subroutine contribution (T1,C,T2,dI)
c      subroutine correlate(Qx,ksi,sigma,both_plus,C)
c      subroutine n_field(maxl,I_DMAX,NL,b_Cm,MAXGRP,GEOSTR,SQ,K1,
c      subroutine trans(QD,KL,R,L,A,B)
c      subroutine nanalytic_fourier(z1,z2,QD,K1,KL,A,B,T)
c      subroutine n_diffuseRough(I_DMAX,maxl,Nl,b_Cm,MAXGRP,GEOSTR,
c      subroutine contributionRough(Inc1,Dif1,dhi,Inc2,Dif2,dhi1,
c      subroutine correlateRough(z1,z2,sigma1,sigma2,
c      subroutine field_in_z(I_DMAX,T_z,layer,DWBA,T_kz)
c      subroutine ket_from_bra(matrix)
c      subroutine n_depth(I_DMAX,maxll,NL,b_Cm,MAXGRP,GEOSTR,SQ,Cmatrix,
c      subroutine transRough(L,R,T)
c      subroutine n_optics(maxl,NL,b_Cm,MAXGRP,GEOSTR,SQ,Hextz,Cmatrix,
c      subroutine reflG(G,M,R)



      subroutine plotneutron(cmch)
      implicit none      
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'      
      include 'comdas.for'  
  
      integer     idumst,ndumst,istorTH
      character*4 cfill,cmch
      parameter(idumst=46+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/ndumst(idumst),istorTH,cfill(23)

c v_plotstr.h defines the extern structure: 
c#define MAXSP 16
c#define MAXSUB 8
c#define MAXN   1024
c#define MAXSUBN (MAXSUB*MAXN*8)
c#define INFPLOT (MAXSUB+6)
c#define MDBPLFT (MAXN*72)

      integer      max8subn,n_subspectra,idumplot,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,
     &             xyzdz,vtxt,vtxtp
      character*24 axesname,abscissa,ordinata,bgcolor,fgcolor,datacolor,
     &             thcolor,rescolor,auxcolor1,auxcolor2,auxcolor3,
     &             namechan*4,kform*8,chardum*4,axisformat*16,
     &             title*132,plotstrdef*80,plotstrpu*132
      parameter   (max8subn=maxsub*max8,
     &            idumplot=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-168)
      common/plot/ plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &             plotxx(max8),plotyy(max8),plotsub(max8subn),
     &             xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &             int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),
     &             npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &             n_subspectra,logx,logy,logf,
     &             namechan(infplot),kform(infplot),axisformat(3),
     &             axesname(3),title,plotstrdef,plotstrpu,
     &             bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &             auxcolor1,auxcolor2,auxcolor3,chardum(idumplot)

      real          acsp,dwba,scale,channels,anglepair,
     &              unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,dumcsp
      common/acstrf/acsp,dwba,scale,channels,anglepair,
     &              unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end,
     &              dumcsp(icstrf-11)

      real          avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs
      common/avstrf/avsp,aintensity,background,Pxsi_b,Peta_b,Pzeta_b,
     &              Pxsi_a,Peta_a,Pzeta_a,v_shift,dumvs(ivstrf-10)
      

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      integer     idumscrt
      logical     b_datf,b_12,b_34
      real        datx,errx,sym,subspectrum,daty,erry,dumsc
      parameter (idumscrt=maxscrt-6*maxn-maxn*maxsub)
      common/scrt/datx(maxn),errx(maxn),sym(maxn),
     &            subspectrum(maxn,maxsub),
     &            daty(maxn),erry(maxn),b_datf(maxn),dumsc(idumscrt)

      integer mscale,nexp,nthe,ii,i,k,j,ns,nyy,ny,nresidue
      real x_exp,dx_exp,xb_exp,dx_the,xb_the,h,x_multiplier,
     &     resmin,resmax,xmin,xmax,ymin,ymax,hd
      common/ascale/  x_exp(max8)

      logical         b_logx,b_logy
      character*1     chx,chbx,chlr,chy,chby,chbt
      character*80    CTEXT,CXTEXT,CYTEXT,frcolor*24,ch0*1 
      integer         nformx,nformy
      real            chh,chw,syw,syh

      ch0=char(0)
      if(cmch.eq.'data') then
       formdata(1)='y,dy'
       formdata(2)='y,dy,x'
       return
      end if
      if(cmch.eq.'dmod') then
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='erry'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)='*'
       plotstrdef='(xd,yd,erry) (xt,yt)'
      
       display_mode(1)='q-scale ,log(count)'
       display_mode(2)='q-scale, residual aintensity'
       display_mode(3)='channel scale, aintensity'
       display_mode(4)='channel scale,residual aintensity'
       return
      end if
      
      b_logy=.false.
      b_logx=.false.     
      b_12=.false.
      b_34=.false.
      if(ndisplay_mode.gt.4) ndisplay_mode=4
      goto(1,2,3,4), ndisplay_mode
c      display_mode(1)='q scale, log(count)'
 1    continue
      b_12=.true.
      abscissa='Q[10^-2A^-1] .........'
      axisformat(1)='%6.2f '
      ordinata='log(count) '
      axisformat(2)='%6.2f '
      b_logy=.true.
      nformx=2
      nformy=2
      goto 5
c     display_mode(2)='q-scale, residual aintensity'
 2    continue
      b_12=.true.
      abscissa='Q[10-2A-1] .........'
      axisformat(1)='%6.2f '
      ordinata='log(intensity) '
      axisformat(2)='%6.2f '
      b_logy=.true.
      nformx=2
      nformy=2   
      goto 5
c     display_mode(3)='channel scale'
 3    b_34=.true.
      abscissa='channel '
      ordinata='intensity '
      axisformat(1)='%6.0f '
      axisformat(2)='%8.0f '
      nformx=0
      nformy=0   
      goto 5
c     display_mode(4)='-channel scale, residual aintensity'
 4    b_34=.true.
      abscissa='channel '
      ordinata='intensity '
      axisformat(1)='%6.0f '
      axisformat(2)='%8.0f '
      nformx=0
      nformy=0 
 5    continue
      

      if(b_12) then
       kform(1)='f7.2'
       kform(2)='f8.4'
       kform(3)='f8.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
       nformy=2       
      end if
      if(b_34) then
       kform(1)='f6.0'
       kform(2)='f10.0'
       kform(3)='f8.1'
       kform(4)='f8.1'
       kform(5)='f6.0'
       kform(6)='f10.0'
       kform(7)='f10.0'
       nformy=0
      end if
      kform(8)=' '

      nexp=channels
      n_subspectra=n_subset

      bgcolor='LightYellow'//ch0
      fgcolor='black'//ch0
      datacolor=fgcolor
      thcolor=fgcolor
      rescolor='blue'//ch0
      do j=1,maxsub
       ncolor(j)=icolor_sub(j)
      end do
 
      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

      if(b_data) then
       do i=1,nexp
        daty(i)=real_fr(mfpt+i)
       end do
       do i=1,nexp
        erry(i)=real_fr(mdfpt+i)
       end do
      end if
      
      nresidue=0
      do ii=1,infplot
       nchanplot(ii)=0
      end do

c     if(b_theory) then
c      write(6,'(8g14.4)') (thfk(j),j=1,nexp,8)
c     else
c      write(6,'(8g15.4)') (daty(j),j=1,16)
c     end if
      mscale=scale
      if(ifrcase.eq.11) then
       x_multiplier=100.    
      else if(ifrcase.gt.20)then
       if(mscale.eq.1)then
        x_multiplier=1.    
       else
        x_multiplier=1000. 
       end if
      end if
      nthe=istorTH*2

      dx_the=abs(q_end-q_beg)/(q_ch-1.0)
      dx_exp=abs(q_end-q_beg)/(channels-1.0)
      xb_the=q_beg+v_shift
      xb_exp=q_beg

      nyy=0
      ny=0
      if(b_12) then
c       call x_scale(mscale)

       if(b_data) then
        if(ndisplay_mode.eq.1)then
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ny=ny+1
           plotx(ny)=x_exp(j)
           h=abs(daty(j))
           if(h.lt.0.1) then
            ploty(ny)=0.
            ploterry(ny)=1.
            ny=ny-1
           else
            ploty(ny)=alog(h)
            ploterry(ny)=1./erry(j)
           end if
          end do
         end do
        else
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ny=ny+1
           plotx(ny)=x_exp(j)
           ploty(ny)=daty(j)
           ploterry(ny)=erry(j)
          end do
         end do
         if(b_theory)then
          nresidue=1
          ns=0
          do k=2,ichanks(0),2
           do j=ichanks(k-1),ichanks(k)
            ns=ns+1
            plotres(ns)=daty(j)-thfk(j)
           end do
          end do
         end if
        end if
       end if ! b_data


       if(b_theory) then

        if(ndisplay_mode.eq.1)then
         nyy=nthe
         do ii=1,nyy
          plotxx(ii)=xb_the+ (ii-1)*dx_the
          plotyy(ii)=alog(abs(thfk(ii)+0.1))
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=alog(abs(subspectrum(ii,j)+0.1))
           end do
          end do
         end if
        else
         nyy=nexp
         do ii=1,nyy
          plotxx(ii)=x_exp(ii)
          plotyy(ii)=thfk(ii)
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
           end do
          end do
         end if
        end if
       end if  ! b_theory
      end if ! log scale
      
      if(b_34) then
c       call x_scale(mscale)
       if(b_data) then
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k)
          ny=ny+1
          plotx(ny)=j
          ploty(ny)=daty(j)
          ploterry(ny)=erry(j)
          if(daty(j).lt.0.1) ny=ny-1
         end do
        end do
        if(b_theory.and.ndisplay_mode.eq.4)then
         nresidue=1
         ns=0
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k)
           ns=ns+1
           plotres(ns)=daty(j)-thfk(j)
          end do
         end do
        end if
       end if ! b_data

       if(b_theory) then
        nyy=nexp
        do ii=1,nyy
         plotxx(ii)=x_exp(ii)
         plotyy(ii)=thfk(ii)
        end do
        if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*max8
          nchanplot(6+j)=nyy
          do i=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
          end do
         end do
        end if
       end if  ! b_theory
      end if ! counts


      xmin=1.e30
      xmax=-xmin
      ymin=xmin
      ymax=-ymin                       ! counts > 0
      if(b_data) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i)
       end do
       do i=1,ny
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i)
       end do
      end if
      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy
        if(ymin.gt.plotyy(i))ymin=plotyy(i)
       end do
       do i=1,nyy
        if(ymax.lt.plotyy(i))ymax=plotyy(i)
       end do
      end if

      if(nresidue.eq.1) then
        nchanplot(4)=ny
        resmin=0.
        resmax=0.
        do i=1,ny
         hd= plotres(i)-ploterry(i)           
         if(resmin.gt.hd) resmin=hd
        end do
        do i=1,ny
         hd= plotres(i)+ploterry(i)           
         if(resmax.lt.hd) resmax=hd
        end do
         hd= resmax-2.0*resmin 
        do i=1,ny
         plotres(i)=plotres(i)+ymax-resmin
        end do
        ymax=ymax-resmin+resmax
      end if
       xyzdz(1)=xmin
       xyzdz(2)=xmax
       xyzdz(3)=ymin
       xyzdz(4)=ymax
c       write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax

c      write(6,'(a,5i8)') 'nchanplot(ii)=',(nchanplot(ii),ii=1,6)
c      write(6,'(a,3i8)') 'plotx  nyy=',nyy
c      write(6,'(8g12.4)') (plotxx(ii),ii=1,nyy,8)
c      write(6,'(a,3i8)') 'plotyy  nyy=',nyy
c      write(6,'(8g12.4)') (ploty(ii),ii=1,nyy,8)
c      write(6,'(a,3i8)') 'ploterry ny=',ny
c      write(6,'(8g12.4)') (ploterry(ii),ii=1,ny,8)


       
c      definitions taken from allplo
       chx='b'                 ! (none,Both,bottom,top)  [B]
       chbx='n'                ! (none,bottom,top)  [n]
       chlr='l'                ! (left,right)  [r]
       chy='l'                 ! (none,Both,left,right)  [B]
       chby='l'                ! (none,left,right)  [r] 
       chbt='b'                ! (bottom,top)  [t]
       chh=0.3                 ! 
       chw=0.25                ! character cw,ch  [0.40,0.40]         
       syw=0.1                 !
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]
       frcolor=fgcolor         ! color frame       [black]
       frcolor='blue'//ch0
       CTEXT=title
       CXTEXT=abscissa
       CYTEXT=ordinata
         
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,
     &            chh,chw,syw,syh,
     &          CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)
 
      
      return
      end
      
      subroutine integration(q_beg,q_end,nch_q,chrock,chrock2,
     &                         aver_points,dtheta1,dtheta2,dlambda)
      implicit none
!Input
      integer nch_q
      real q_beg,q_end,dtheta1,dtheta2,dlambda,chrock
      dimension chrock(nch_q)

!other variables
      integer j,aver_points,pnts_forw,pnts_back,i
      real dQ,chrock2,div_factor,Qj,Qi,tmp_var,resfunc
	dimension chrock2(nch_q)
! Body of the subroutine

      dQ=6.28*sqrt(dtheta1*dtheta1+dtheta2*dtheta2+dlambda*dlambda)
      IF (nch_q.GT.1.and.dQ.GT.0) then  
	pnts_forw=(aver_points-1)*0.5 !Points for averaging forward and 
 	pnts_back=aver_points-pnts_forw-1  !backward  
 
      do j=1,nch_q !loop over channels

      Qj=q_beg+((q_end-q_beg)*(j-1)/(nch_q-1))
  	chrock2(j)=0
       div_factor=0.0

			DO i=j-pnts_back,j+pnts_forw
      	      IF (i.GT.0.and.j+pnts_forw.LE.nch_q) THEN
                  Qi=q_beg+((q_end-q_beg)*(i-1)/(nch_q-1))
	            tmp_var=-((Qi-Qj)**2)/(2.0*dQ*dQ)
	            resfunc=exp(tmp_var)/(2.50663*dQ) !/sqrt(2*pi)*dQ
	    		chrock2(j)=chrock2(j)+chrock(i)*resfunc
			   
			    div_factor=div_factor+resfunc
      		    END IF 
              END DO
	   IF (div_factor.EQ.0 ) THEN 
	     chrock2(j)=chrock(j)
	   ELSE
	     chrock2(j)=chrock2(j)/div_factor
	   END IF
      end do ! Loop over all channels
 
            DO j=1,nch_q !loop over channels
            chrock(j)=chrock2(j)
            END DO

      END IF !Number of chanels more than one
      return
      end
      

C  *****************************************************************
C    Correlation function of susceptibilities in  layers
C         
C   	C~+-I*sigma_magn*(ksi*ksi*pi2)/((1+(Qx*ksi)**2)**1.5)
C  *****************************************************************
	subroutine correlate(Qx,ksi,sigma,both_plus,C)
	implicit none
	logical both_plus
	real*4 ksi,sigma
	real*8 Qx,ksiD,pi2,pr,sigmaD,C

	ksiD=ksi
	sigmaD=sigma
      pi2=atan(1.)*8.
	pr=(Qx*ksiD)*(Qx*ksiD)
	IF (both_plus) then 
	C=sigmaD*(ksiD*ksiD*pi2)/((1.D0+pr)**1.5)
!	C=1.0
	ELSE
	C=-sigmaD*(ksiD*ksiD*pi2)/((1.D0+pr)**1.5)  
!	C=-1.0
!      C=1.0 
	END IF
! 	C=1.
! 	print *, C
      return
      end



C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine n_field(maxl,I_DMAX,NL,b_Cm,MAXGRP,GEOSTR,SQ,K1,
     &        Cmatrix,VKD,roughlay,Rmatrix,domain,Tmatrix)
C****************************************************************************
c This Subroutine calculates Fourier transform (2.12) for each layer where 
c domains exists.  
C
C Field of incident wave is calculated using Rmatrix for SQ=2k(sin(theta_in)).
c K1=k(sin(theta_out)
C
C                                 Budapest 2004, 
C                          
C                                 Khaidukov Yu
CC*************************************************************************
 
 
       implicit none
C   input:
       integer    NL,maxl,I_DMAX
	 logical domain(maxl)
C     NL: number of layers  (in period)
       complex*16 T(2,2)
C   other variables:
       complex*16 C0,C1,CI,M(4,4),ML(4,4),KL(2,2),R(2,2)
       real*8     QD, DL,K1
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,
     &            GEOSTR(0:2*maxl),MAXGRP,POINTER,I_D
c       real*8     Dper(maxl),Dgrp(maxl) 

       parameter  (C0=(0.D0,0.D0), C1=(1.D0,0.D0), CI=(0.D0,1.D0))
C**************************************

       complex*8  Cmatrix(2,2,maxl),Rmatrix(2,2),cz,
     &            Tmatrix(2,2,I_DMAX)
      complex*16  A(2,2),B(2,2)
       real*4     VKD(maxl),SQ,roughlay(maxl),absCmatr,
     &            VKDMAX
       logical    b_Cm(maxl),b_odz,b_first,b_grp
!       parameter  (cz=(0.0,0.0),VKDMAX=7.30416e3)
       parameter  (cz=(0.0,0.0),VKDMAX=7.30416e4)

C********* Variables added by Khaidukov for neutron case
	integer Lprev,Lnext,n
	logical prev_dgnl,both_dgnl,both_NONdgnl
	complex*16 KLprev(2,2)
	real*8 DabsMatr,z1,z2
             
C---------------------------------------------
	NL=5 !Unused for this program variable

	 QD=dble(SQ)*0.5D0 

       R(1,1) = Rmatrix(1,1)
       R(1,2) = Rmatrix(1,2)
       R(2,1) = Rmatrix(2,1)
       R(2,2) = Rmatrix(2,2)
C 
       b_first     =.true.

C       To set the characteristic matrix to unit matrix
        do I=1,4
         do J=1,4
          ML(I,J)=C0
         end do
         ML(I,I)=C1
        end do

	I_D=0

       POINTER=0                                     
      z1=0.0D0  !First 
      z2=0.0D0  !and the second coordinate for each layer

       do GRP=1,MAXGRP      ! loop for the groups
        b_grp=.false.
C
        LMIN =POINTER+1
        LMAX =POINTER+GEOSTR(2*GRP)
        n_rep=GEOSTR(2*GRP-1)
C
      	n=1
   
       DO WHILE (n.LE.n_rep)
	n=n+1
        do L=LMIN,LMAX 
	  if(VKD(L).gt.0.and.VKD(L).lt.1.e30) then
C          b_odz=.false.                              
	    b_odz=.not.b_Cm(L)
            b_grp=.true.  			 
            DL=VKD(L)

	    z2=z1+DL
            KL(1,1)=Cmatrix(1,1,L)
            KL(1,2)=Cmatrix(1,2,L)
            KL(2,1)=Cmatrix(2,1,L)
            KL(2,2)=Cmatrix(2,2,L)
            absCmatr=real(Cmatrix(1,2,L)*conjg(Cmatrix(1,2,L))+
     &                    Cmatrix(2,1,L)*conjg(Cmatrix(2,1,L)))
           if(absCmatr.lt.1.e-15) b_odz=.true.

           IF (domain(L)) THEN !If there are domains in this layer store inform
            call trans(QD,KL,R,ML,A,B)  ! A ne M li dolzno bit vmest ML??? Kh
            call nanalytic_fourier(z1,z2,QD,K1,KL,A,B,T)
            I_D=I_D+1
            Tmatrix(1,1,I_D)=T(1,1)
	    Tmatrix(1,2,I_D)=T(1,2)
	    Tmatrix(2,1,I_D)=T(2,1)
	    Tmatrix(2,2,I_D)=T(2,2)
           END IF     ! Domains

           call genM(b_odz,QD,DL,KL,M)  !

C************* Roughness************
           IF (roughlay(L).GT.0) THEN
            if (n_rep.GT.1.and.L.eq.Lmin) then  ! In case of repeating layers
	      Lprev=Lmax	                       ! we are more interested in the 
	     else                              !information about roughnesses
                              		       !in repeated ones. 
	     Lprev=L-1			               !#Khaidukov
	    END IF

            if(n_rep.GT.1.and.L.eq.LMAX) then  !
             Lnext=LMIN         ! For peiodical structure the rougness
            else                ! is also periodical! The next layer to 
             Lnext=L+1          ! the last element is the first layer! 
             if(Lnext.gt.NL) Lnext=NL
            end if              

	    DO I=1,2
	     DO J=1,2 
	      IF (Lprev.EQ.0) THEN 
	       KLprev(I,J)=C0     ! In case of 1st layer KLprev is for vacuum
	       prev_dgnl=.true.
              END IF                
              IF (Lprev.GT.0) THEN 	  
               KLprev(I,J)=Cmatrix(I,J,Lprev)
	       prev_dgnl=.not.b_Cm(Lprev)							
	      ENDIF
             END DO
	    END DO

            DabsMatr=
     &         dreal(KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+
     &              (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))         
	
            IF(prev_dgnl.and.b_odz) then	            !
             both_dgnl=.true.		            ! Rohlsberger roughness1
             both_NONdgnl=.false.                       !
            ELSEIF (DabsMatr.lt.1.e-15)	then        !
	     both_dgnl=.true.		            ! Rohlsberger roughness1
	     both_NONdgnl=.false.			    !
	    ELSEIF (.not.prev_dgnl.and..not.b_odz) then
	     both_dgnl=.false. 			    !
             both_NONdgnl=.true.			    ! Deak's roughness
	    ELSE							  
             both_dgnl=.false. 		            ! Rohlsberger roughness2
             both_NONdgnl=.false.			  
	    ENDIF

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C           both_dgnl=.false. 	  !DONT FORGET TO REMOVE!!!!!!!!!
C           both_NONdgnl=.TRUE.	  !Deak's roughness
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

            call roughness(both_dgnl,both_NONdgnl,
     &                  roughlay(L),roughlay(Lnext),QD,KLprev,KL,M)    
           END IF !Roughness
           call mat4(M,ML,ML) 
          end if ! VKD(L) > 0.         
         z1=z2
         end do ! L
	END DO ! while
        POINTER=POINTER+GEOSTR(2*GRP)
       end do ! GRP

       return
       end

C ******************************************************************************
C Subroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz 
C in the interval from z1 to z2
C ******************************************************************************

      subroutine nanalytic_fourier(z1,z2,QD,K1,KL,A,B,T)
      implicit none
      real*8     z1,z2,QD,K1
      complex*16 KL(2,2),A(2,2),B(2,2),T(2,2)
c     OutPut  T 

      complex*16 Im1,b_const,iz1,iz2,DM1(2,2),K(2,2),DMA(2,2),DMB(2,2),
     &           DMA1(2,2),DMB1(2,2),DMA2(2,2),DMB2(2,2),DMAS(2,2),
     &           DMBS(2,2),DMAA(2,2),DMBB(2,2)
      parameter (Im1=(0.0D0,1.0D0))
      real*8     Kz2
      integer    I,J

      iz1=Im1*z1
      iz2=Im1*z2
      b_const=1.0/(Im1*2.50662827)  !b_const=1/i*sqrt(2*pi)
      Kz2=QD*QD
 
      DM1(1,1)=KL(1,1)+Kz2
      DM1(1,2)=KL(1,2)                          !DM1=Ko**2+KL
      DM1(2,1)=KL(2,1)
      DM1(2,2)=KL(2,2)+Kz2 

      call sqrt2(DM1,K)   ! K=sqrt(Ko**2+KL)- z component of incoming wavevector   
                          ! in the given layer
      DO I=1,2
       DO J=1,2
        DMA(I,J)=K(I,J) 
	DMB(I,J)=K(I,J) 
       END DO
       DMA(I,I)=K(I,I)-K1                !DMA=K-K1
       DMB(I,I)=K(I,I)+K1                !DMB=K+K1
      END DO

      DO I=1,2
       DO J=1,2
        DMA1(I,J)= iz1*DMA(I,J)       ! DMA1= i*z1*(K-K1)
        DMA2(I,J)= iz2*DMA(I,J)       ! DMA1= i*z2*(K-K1)
        DMB1(I,J)=-iz1*DMB(I,J)       ! DMB1=-i*z1*(K+K1)
        DMB2(I,J)=-iz2*DMB(I,J)       ! DMB2=-i*z2*(K+K1)
       END DO
      END DO

      call exp2(DMA1)    ! DMA1=exp(i*z1*(K-K1))
      call exp2(DMA2)    ! DMA2=exp(i*z2*(K-K1))
      call exp2(DMB1)    ! DMB1=exp(-i*z1*(K+K1))
      call exp2(DMB2)    !DMB2=exp(-i*z2*(K+K1))

      DO I=1,2
       DO J=1,2
        DMAS(I,J)=DMA2(I,J)-DMA1(I,J) ! DMAS=exp(i*z2*(K-K1))-exp(i*z1*(K-K1))
        DMBS(I,J)=DMB1(I,J)-DMB2(I,J) ! DMBS=exp(-i*z1*(K+K1))-exp(-i*z2*(K+K1))
       END DO
      END DO
      
      call inv2(DMA,DMAA) ! DMAA=[K-K1]**-1
      call inv2(DMB,DMBB) ! DMBB=[K+K1]**-1
	
      call mat2(DMAA,A,DMA) !DMA=([K-K1]**-1)*A
      call mat2(DMBB,B,DMB) !DMB=([K+K1]**-1)*B
      call mat2(DMAS,DMA,DMAA)
c     DMAA=[exp(i*z2*(K-K1))-exp(i*z1*(K-K1))]*([K-K1]**-1)*A
      call mat2(DMBS,DMB,DMBB)
c     DMBB=[exp(-i*z1*(K+K1))-exp(-i*z2*(K+K1))]*([K+K1]**-1)*B

      DO I=1,2
       DO J=1,2
        T(I,J)=(DMAA(I,J)+DMBB(I,J))*b_const
       END DO
      END DO
      return
      end


C*******************************************************************
       subroutine n_optics(mlay,MAXGRP,GEOSTR,b_Bfield,Hextz,Cmatrix,
     &                thicklayer,roughlay,SSQ,b_up,b_down,Rmatrix)

C                               OPTICS
C
C          Reflectivity calculation of anizotropic multilayers
C          in the Neutron case. 
C
C          (method of G. H. Borzbov et. al. - L. Deak et. al.)
C
C                         Laszlo Deak, Hartmut Spiering 
C
C                         Budapest, 2000. December
C				
C		           Khaidukov Yuri
C
C                         Budapest, 2004, September
C ***************************************************************** 
C Geometry:
C               incident        reflected                    
C                        \    /    
C                         \  /
C                      FI (\/
C      Z=0>           -------------  
C           covering  _____________         [D(1),K(1,I,J)]  
C                                  >Layer#1 [D(2),K(2,I,J)]
C                 1.  .............     
C                           .
C                           .
C                     .............
C Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]
C       I              
C          substrate  _____________         [D(NL),K(NL,I,J)]
C                            `                 ^
C                              `            infinit or finit
C                             refracted
C
C  Variables of system:
C  INPUT:
C                           covering   layer #L     substrate
C
C            thickneses:         D(1)     D(L)        D(NL)
C        susceptibility:
C          (nuclear+magnetic)
C                                K(1)     K(L)        K(NL)
C         where  L=1..NL  I,J=1,2,3 
C
C  OUTPUT:
C         The 2x2 complex reflectivity (or transmitivity) matrix:  R
C
C ******************************************************************
       implicit none
       integer    mlay,MAXGRP,GEOSTR
       logical    b_Bfield,b_up,b_down
       real*8     SSQ,Hextz,thicklayer,roughlay
       complex*16 Cmatrix,Rmatrix
       dimension  b_Bfield(mlay),GEOSTR(0:2*mlay),Cmatrix(2,2,mlay),
     &            thicklayer(mlay),roughlay(mlay),Rmatrix(2,2)

       real*8     DL,Hext4,QP,QD,DabsMatr
       logical    b_odz,b_first,b_grp,prev_dgnl,both_dgnl,both_NONdgnl
       integer    I,J,L,GRP,LMIN,LMAX,Lprev,POINTER,Lnext,NLOG,n_rep,NL
       real*4     absCmatr,absC1,absC2,level

       complex*16 C0,C1,CI,
     &            M,ML,MS,KL,Gamma,Q,KLprev,UnMat
       dimension  M(4,4),ML(4,4),MS(4,4),KL(2,2),Gamma(2,2),
     &            KLprev(2,2),UnMat(2,2)
       parameter (C0=(0.D0,0.D0), C1=(1.D0,0.D0), CI=(0.D0,1.D0),
     &            level=1.E17)
C**************************************
       NL=mlay
       UnMat(1,1)=C1
       UnMat(1,2)=C0	 !Unit matrix
       UnMat(2,1)=C0
       UnMat(2,2)=C1

       QD=dble(SSQ)
       Q =dcmplx(QD,0.D0)       

       Gamma(1,1)=C1
       Gamma(1,2)=C0
       Gamma(2,1)=C0
       Gamma(2,2)=C1 ! no analizator

       if(b_up)then
        Hext4=4.D0*dble(Hextz)
        QP=QD*QD-Hext4
        if(QP.ge.0.D0)then
          Q= dcmplx(sqrt(QP),0.D0)
C          write(6,'(2E16.3)')Q
        else
          Q= dcmplx(0.D0,-sqrt(-QP))
C          write(6,'(2E16.3)')Q
        end if
        if(QP-Hext4.ge.0.D0)then
          Gamma(1,1)=dcmplx(QD/dble(Q),0.D0)
          Gamma(2,2)=dcmplx(sqrt(QP-Hext4)/dble(Q),0.D0)
        else
         if(QP.ge.0.D0)then
           Gamma(1,1)=dcmplx(QD/dble(Q),0.D0)
           Gamma(2,2)=dcmplx(0.D0,-sqrt(Hext4-QP)/dble(Q))
         else
           Gamma(1,1)=dcmplx(0.D0,-QD/dimag(Q))
           Gamma(2,2)=dcmplx(-sqrt(Hext4-QP)/dimag(Q),0.D0)
         end if
        end if
C       write(6,*)SSQ,Gamma(1,1)*Gamma(2,2)
        Gamma(1,2)=C0
        Gamma(2,1)=C0
       end if         ! we measure the '+' beam

       if(b_down)then
        Hext4=4.D0*dble(Hextz)
        QP=Hext4/(QD*QD+Hext4)
        Q=sqrt(dcmplx(QD*QD+Hext4,0.D0))
        Gamma(1,1)=sqrt(C1+dcmplx(QP,0.D0))
        Gamma(1,2)=C0
        Gamma(2,1)=C0
        Gamma(2,2)=sqrt(C1-dcmplx(QP,0.D0))
c       write(6,*)SSQ,Gamma(2,2),Q
       end if         ! we measure the '-' beam

       b_first     =.true.
       POINTER=0                                     
       do GRP=1,MAXGRP      ! loop for the groups
C       To set the characteristic matrix to unit matrix
        do I=1,4
         do J=1,4
          ML(I,J)=C0
         end do
         ML(I,I)=C1
        end do
        b_grp=.false.
C
        LMIN =POINTER+1
        LMAX =POINTER+GEOSTR(2*GRP)
        n_rep=GEOSTR(2*GRP-1)
C
        do L=LMIN,LMAX

         if(thicklayer(L).gt.0.) then
C         b_odz=.false.                              
	  b_odz=.not.b_Bfield(L)
          b_grp=.true.  			 
          DL=thicklayer(L)
          KL(1,1)=Cmatrix(1,1,L)
          KL(1,2)=Cmatrix(1,2,L)
          KL(2,1)=Cmatrix(2,1,L)
          KL(2,2)=Cmatrix(2,2,L)

          absCmatr=real(dble(KL(1,2)*dconjg(KL(1,2))+
     &                    KL(2,1)*dconjg(KL(2,1))))
          absC1=real(dble(KL(1,1)*dconjg(KL(1,1))+
     &                    KL(2,2)*dconjg(KL(2,2))))
          absC2=absCmatr*level
          if(absC1.gt.absC2) then
           b_odz=.true.
          end if
          call genM(b_odz,QD*0.5D0,DL,KL,M)
C************* Roughness************
          IF (roughlay(L).GT.0) THEN
           if (n_rep.GT.1.and.L.eq.Lmin) then  ! In case of repeating layers
             Lprev=LMAX	                       ! we are more interested in the 
           else                              !information about roughnesses
                               		       !in repeated ones. 
            Lprev=L-1			               !#Khaidukov
           END IF
           if(n_rep.GT.1.and.L.eq.LMAX) then
            Lnext=LMIN         ! For peiodical structure the rougness
           else                ! is also periodical! The next layer to 
            Lnext=L+1          ! the last element is the first layer! 
            if(Lnext.gt.NL) Lnext=NL
           end if              
          
          
           DO I=1,2
            DO J=1,2 
             IF (Lprev.EQ.0) THEN 
              KLprev(I,J)=C0     ! In case of 1st layer KLprev is for vacuum
              prev_dgnl=.true.
                  END IF                
                 IF (Lprev.GT.0) THEN 	  
         	   KLprev(I,J)=Cmatrix(I,J,Lprev)
                  prev_dgnl=.not.b_Bfield(Lprev)							
              ENDIF
        
                END DO
           END DO

           DabsMatr=
     &       dble((KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+
     &            (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1))))

           IF (prev_dgnl.and.b_odz) then	          !
            both_dgnl=.true.				  ! Rohlsberger roughness1
            both_NONdgnl=.false.                          !
           ELSEIF (DabsMatr.lt.1.e-15)	then              !
            both_dgnl=.true.				  ! Rohlsberger roughness1
            both_NONdgnl=.false.			  !
           ELSEIF (.not.prev_dgnl.and..not.b_odz) then
            both_dgnl=.false. 				  !
            both_NONdgnl=.true.		                  ! Deak's roughness
           ELSE							  
            both_dgnl=.false. 				  ! Rohlsberger roughness2
            both_NONdgnl=.false.			  !
           ENDIF
C-----------------------------------------------------------------------
C          both_dgnl=.false. 		!DONT FORGET TO REMOVE!!!!!!!!!
C          both_NONdgnl=.TRUE.		!Deak's roughness
C-----------------------------------------------------------------------
           call OSroughness(both_dgnl,both_NONdgnl,
     &            roughlay(L),roughlay(Lnext),QD*0.5D0,KLprev,KL,M)
          END IF !Roughness

          call mat4(M,ML,ML) 
         endif ! thicklayer(L) > 0.         
        end do ! L

C       For periodic multilayers the int. propagation matrix is (ML)**n_rep, 
C       where n_rep is the number of periods.
        
        if(n_rep.gt.1.and.b_grp)then
         do I=1,4
          do J=1,4
           M(I,J)=ML(I,J)
          end do
         end do
C        
         NLOG=alog(float(n_rep))/alog(2.0)
C
         do I=1,NLOG
          call mat4(ML,ML,ML)
         end do
C
         do I=1,n_rep-2**NLOG
          call mat4(M,ML,ML)
         end do
C
        end if  ! n_rep>1

        if(b_first) then
         b_first=.false.
         do I=1,4
          do J=1,4
           MS(I,J)=ML(I,J)
          end do
         end do
        else
         call mat4(ML,MS,MS)
        end if         
C
        POINTER=POINTER+GEOSTR(2*GRP)
       end do ! GRP

C      Now we have the integreted propagation matrix of the structure: ML
C      Calculation of reflectivity matrix (2x2):
C
       call refl(MS,Rmatrix)

       return
       end

C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	subroutine OSroughness(both_dgnl,both_NONdgnl,
     &                                     sigma1,sigma2,A0,A1,A2,M)
C ******************************************************************

C  This subroutine updates integrated matrix of distibution with roughness on
C	 the top border of a given layer. 
C      M->Mupd, where Mupd=exp(sigma**2)*[W1,W2]*0.5*M. For the details see 
C      R. Rohlsberger, Hyperfine Inreractions 123/124 (1999) 301-325
C      ------------------------------------------------------------
C	 Differential matrix of distribution is  represented like
C		      0		  I*Ao+Ai/Ao
C      Wi   =	  
C                     I*Ao         0
     	      
C      ---------------------------------------------------------------     
      implicit none
C     Input variables	
        logical    both_dgnl,both_NONdgnl
	real*8     sigma1,sigma2,A0
	complex*16 A1(2,2),A2(2,2),M(4,4)

	real*8     sigmaD1,sigmaD2,R2min,R2plu
        complex*16 Mupd(4,4),exp_Dp(2,2),exp_Dm(2,2),
     &             exp_scalar(2),C_scal(2),dA_scal(2),C(2,2),dA(2,2),
     &             TMP(2,2),C2(2,2),AA(2,2),BB(2,2),CC(2,2),DD(2,2),
     &             C1,C0
	parameter (C1=(1.D0,0.D0), C0=(0.D0,0.D0))	
	integer I,J,K

        sigmaD1=sigma1  !RMS roughness at the upper border of the layer
	sigmaD2=sigma2	!RMS roughness at the down border of the layer

	IF (both_dgnl.and..not.both_NONdgnl)  then	!Both layers are non resonant
         DO I=1,2
          dA_scal(I)=A2(I,I)-A1(I,I)
          C_scal(I) =2.D0*(2.D0*A0*A0+A2(I,I)+A1(I,I))
                     exp_scalar(I)=dA_scal(I)*(C1/C_scal(I))*
     &               (-exp(-0.5D0*sigmaD1*sigmaD1*C_scal(I))+C1)
	exp_scalar(I)=exp(exp_scalar(I))

!	exp_scalar(I)=exp(dA(I)*(C1/C_scal(I))*
!	&(exp(0.5D0*sigmaD*sigmaD*C_scal(I))-C1))

	 END DO

         DO J=1,4
	  Mupd(J,1) =  exp_scalar(1)*M(J,1)
	  Mupd(J,2) =  exp_scalar(2)*M(J,2)
	  Mupd(J,3) =  (C1/exp_scalar(1))*M(J,3)
	  Mupd(J,4) =  (C1/exp_scalar(2))*M(J,4)
         END DO

        ELSE IF(.not.both_dgnl.and..not.both_NONdgnl)then  !One of the layers 
                                                           ! is resonant            
         C(1,1)=2.D0*(2.D0*A0*A0+A1(1,1)+A2(1,1))
         C(2,2)=2.D0*(2.D0*A0*A0+A1(2,2)+A2(2,2))   !C=2*(2A0+A1+A2)
         C(1,2)=2.D0*(A1(1,2)+A2(1,2))
         C(2,1)=2.D0*(A1(2,1)+A2(2,1))

         DO I=1,2
          DO J=1,2
           dA(I,J)=A2(I,J)-A1(I,J)		         !dA=A2-A1
           TMP(I,J)=-0.5D0*sigmaD1*sigmaD1*C(I,J)   !TMP=-0.5*sigma**2*C
          END DO
         END DO

         call exp2(TMP)                           !TMP=exp(-0.5*sigma**2*C)
         call inv2(C,C2)							 !C2=1/C
         call mat2(dA,C2,C2)  					 !C2=dA*1/C

         TMP(1,1)=C1-TMP(1,1)
         TMP(1,2)=-TMP(1,2)
         TMP(2,1)=-TMP(2,1)	                     !TMP=I-exp(-0.5*sigma**2*C)
         TMP(2,2)=C1-TMP(2,2)

         call mat2(C2,TMP,exp_Dp) 		 !expDp=dA*1/C*(I-exp(-0.5*sigma**2*C))
         call exp2(exp_Dp)		 !expDp=exp(dA*1/C*(I-exp(-0.5*sigma**2*C)))
         call inv2(exp_Dp,exp_Dm)
C        The 'roughness' matrix has form:	
C        	       	                              exp_Dp        0
C        exp(W)=exp(sigma**2)*[W1,W2]*0.5 =  C	   0        exp_Dm
         DO I=1,2             
          DO J=1,2
           Mupd(I,J)     = C0
           Mupd(I,J+2)   = C0
           Mupd(I+2,J)   = C0
           Mupd(I+2,J+2) = C0
           DO K=1,2
            Mupd(I,J)     = Mupd(I,J)    +  M(I,K)*exp_Dp(K,J)
            Mupd(I,J+2)   = Mupd(I,J+2)  +  M(I,K+2)*exp_Dm(K,J)
	    Mupd(I+2,J)   = Mupd(I+2,J)  +  M(I+2,K)*exp_Dp(K,J)
	    Mupd(I+2,J+2) = Mupd(I+2,J+2)+  M(I+2,K+2)*exp_Dm(K,J)	  
	   END DO
     	  END DO
         END DO

	ELSEIF (.not.both_dgnl.and.both_NONdgnl)  then  !Both layers are 
C	 print *, 'Deak'									!resonant
         R2min=(sigmaD1**2-sigmaD2**2)/2.D0
         R2plu=(sigmaD1**2+sigmaD2**2)/2.D0
cc       write(*,*)R2min,R2plu
         do I=1,2
          do J=1,2
           AA(I,J)= M(I,J)
           BB(I,J)= M(I,J+2)
           CC(I,J)= M(I+2,J)
           DD(I,J)= M(I+2,J+2)
          end do
         end do
cC
         call mat2(AA,A2,AA)
         call mat2(BB,A2,BB)
         call mat2(CC,A2,CC)
C
         do I=1,2
	  do J=1,2
           Mupd(I,J)    = M(I,J)+R2min*AA(I,J)
           Mupd(I,J+2)  = M(I,J+2)-R2plu*BB(I,J)
           Mupd(I+2,J)  = M(I+2,J)+R2plu*CC(I,J)
           Mupd(I+2,J+2)= M(I+2,J+2)-R2min*AA(I,J)
          end do
         end do
cC
        END IF	  !Both are resonant



        DO I=1,4
         DO J=1,4
          M(I,J)=Mupd(I,J)
         END DO
        END DO
     
        return
        end





C ******************************************************************************
C	Subroutine calculates (3.8) expression.Output Gamma(E,l,i,j) for both 
C	kind of domains
C ******************************************************************************

       subroutine energy_trndwba(DWBA,mlay,lay_domain,MAXGRP,GEOSTR,
     &                    b_Bfield,b_domain,eta_domain,K_mag_lay,
     &                    scatlength,thicklayer,rough,SQ,K1,
     &             G_mjv,C_pls,C_mns,Fouphase,
     &             L1matrix,R1matrix,L2matrix,R2matrix,
     &             L3matrix,R3matrix,L4matrix,R4matrix,
     &             Fmatrix_cur,AFmatrix_cur)
        implicit none

        integer    mlay,lay_domain 

        integer    MAXGRP,GEOSTR(0:2*mlay)
        logical    DWBA,b_domain(mlay),b_Bfield(mlay)
        real*8     eta_domain,thicklayer(mlay),rough(mlay),K1,SQ

        complex*16 HI_plus(2,2),HI_minus(2,2),scatlength(mlay)

        complex*16 G_mjv(2,2,2,lay_domain),C_pls(2,2,lay_domain),
     &             K_mag_lay(2,2,mlay),
     &             C_mns(2,2,lay_domain),Fouphase(lay_domain),
     &             L1matrix(2,2,lay_domain),R1matrix(2,2,lay_domain),
     &             L2matrix(2,2,lay_domain),R2matrix(2,2,lay_domain),
     &             L3matrix(2,2,lay_domain),R3matrix(2,2,lay_domain),
     &             L4matrix(2,2,lay_domain),R4matrix(2,2,lay_domain),
     &             Fmatrix_cur(2,2,mlay),AFmatrix_cur(2,2,mlay)

        complex*16 L1(2,2),R1(2,2),L2(2,2),R2(2,2),
     &             L3(2,2),R3(2,2),L4(2,2),R4(2,2),
     &             C_P(2,2),C_M(2,2),
     &             INT1(2,2),INT2(2,2),INT3(2,2),INT4(2,2)

        real*8     coef(2),k,Fi_fin,Fi_inc
        integer    L,classPOINTER,GRP,LMIN,LMAX,N_rep,N,ll,ii,I,J,I1,J1
        complex*16 Rmatrix(2,2),ARmat(2,2),ARmatrix(2,2),C0,hpm
        parameter (C0=(0.D0,0.D0))

C---------------Body of program

      if(DWBA)then ! DWBA approximation
C       write(*,'(a)')'DWBA'
       coef(1)=1.D0-eta_domain
       coef(2)=eta_domain
	    
       DO ii=1,mlay 
         Fmatrix_cur(1,1,ii) =+scatlength(ii)
         Fmatrix_cur(1,2,ii)=(0.d0,0.d0)
         Fmatrix_cur(2,1,ii)=(0.d0,0.d0)
         Fmatrix_cur(2,2,ii) =+scatlength(ii)       
        IF (b_domain(ii)) THEN
         coef(1)=1.D0-coef(1)  ! =eta
         coef(2)=1.D0-coef(2)  ! =1-eta
         b_Bfield(ii)=.true.
         DO I1=1,2
          DO J1=1,2
           Fmatrix_cur(I1,J1,ii) =Fmatrix_cur(I1,J1,ii)+
     &                    (coef(1)-coef(2))*K_mag_lay(I1,J1,ii) 
           hpm=2.d0*K_mag_lay(I1,J1,ii)
           C_pls(I1,J1,ii)= coef(2)*hpm
           C_mns(I1,J1,ii)=-coef(1)*hpm
          END DO
c          Fmatrix_cur(I1,I1,ii) = Fmatrix_cur(I1,I1,ii)+scatlength(ii)
         END DO
        END IF

        DO I1=1,2
         DO J1=1,2
          AFmatrix_cur(J1,I1,ii)=Fmatrix_cur(I1,J1,ii)
         END DO
        END DO
       END DO

       call n_optics(mlay,MAXGRP,GEOSTR,b_Bfield,0.0d0, Fmatrix_cur, 
     &               thicklayer,rough, 2.D0*SQ,.false.,.false.,Rmatrix)

       call n_optics(mlay,MAXGRP,GEOSTR,b_Bfield,0.0d0,AFmatrix_cur, 
     &               thicklayer,rough,-2.D0*K1,.false.,.false.,ARmatrix)
       call g_fndwba(mlay,lay_domain,MAXGRP,GEOSTR, 
     &               b_Bfield,b_domain,thicklayer,rough,SQ,K1,
     &               Fmatrix_cur, AFmatrix_cur,
     &               Rmatrix,ARmatrix,
     &                      L1matrix,R1matrix,
     &                      L2matrix,R2matrix,
     &                      L3matrix,R3matrix,
     &                      L4matrix,R4matrix)
       ll=0	
!       G_mjv1 matrix filling (for plus domains
       classPOINTER=0 
       do GRP=1,MAXGRP
        LMIN =classPOINTER+1
        LMAX =classPOINTER+GEOSTR(2*GRP)
        n_rep=GEOSTR(2*GRP-1)
C
        n=1
        DO WHILE (n.LE.n_rep)
	 n=n+1
         do L=LMIN,LMAX
          IF (b_domain(L)) THEN	   
	   ll=ll+1
C----Calculation of the  G_mjv matrixes -----
      
           do I=1,2
            do J=1,2           
             C_P(I,J)=C_pls(I,J,L)
             C_M(I,J)=C_mns(I,J,L)
             L1(I,J)= L1matrix(I,J,ll)
             R1(I,J)= R1matrix(I,J,ll)
             L2(I,J)= L2matrix(I,J,ll)
             R2(I,J)= R2matrix(I,J,ll)
             L3(I,J)= L3matrix(I,J,ll)
             R3(I,J)= R3matrix(I,J,ll)
             L4(I,J)= L4matrix(I,J,ll)
             R4(I,J)= R4matrix(I,J,ll)
            end do
           end do
C plus domains:
           call mat2x3(L1,C_P,R1,INT1)
           call mat2x3(L2,C_P,R2,INT2)
           call mat2x3(L3,C_P,R3,INT3)
           call mat2x3(L4,C_P,R4,INT4)

           do I=1,2
            do J=1,2           
             G_mjv(I,J,1,ll)=INT1(I,J)+INT2(I,J)+INT3(I,J)+INT4(I,J)
            end do
           end do
C minus domains:
           call mat2x3(L1,C_M,R1,INT1)
           call mat2x3(L2,C_M,R2,INT2)
           call mat2x3(L3,C_M,R3,INT3)
           call mat2x3(L4,C_M,R4,INT4)

           do I=1,2
            do J=1,2           
             G_mjv(I,J,2,ll)=INT1(I,J)+INT2(I,J)+INT3(I,J)+INT4(I,J)
            end do
           end do

C--------------------------------------------
          END IF
         end do ! L
        END DO ! while
C
        classPOINTER=classPOINTER+GEOSTR(2*GRP)      
       end do !over GRP

Cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

      else   ! Born approximation

C              _________________
C       write(*,'(a)')'BA'


       SQ=-k*(sin(Fi_inc)+sin(Fi_fin))

       coef(1)=1.D0-eta_domain
       coef(2)=eta_domain
	    
       DO ii=1,mlay

        IF (b_domain(ii)) THEN
         coef(1)=1.D0-coef(1)
	 coef(2)=1.D0-coef(2)

         DO I1=1,2
          DO J1=1,2
           C_pls(I1,J1,ii)=coef(2)*(HI_plus(I1,J1)
     &                                -HI_minus(I1,J1))
           C_mns(I1,J1,ii)=coef(1)*(HI_minus(I1,J1)
     &                                 -HI_plus(I1,J1))
          END DO
         END DO
        END IF

       END DO
       call g_phase(mlay,lay_domain,MAXGRP,GEOSTR,b_domain,
     &                      thicklayer,SQ,Fouphase)

! Output Fourier of field inside the structure.See (2.12) expression
       ll=0	
!       G_mjv1 matrix filling (for plus domains
       classPOINTER=0 
       do GRP=1,MAXGRP
        LMIN =classPOINTER+1
        LMAX =classPOINTER+GEOSTR(2*GRP)
        n_rep=GEOSTR(2*GRP-1)
C
        n=1
        DO WHILE (n.LE.n_rep)
	 n=n+1
         do L=LMIN,LMAX
          IF (b_domain(L)) THEN	   
	   ll=ll+1
!-----------------Place where G_mjv matrixes are filling----------------------------------
           do I=1,2
            do J=1,2
               ARmat(I,J)=C_pls(I,J,L)
            end do
           end do                

C           call mat2(sqrhoA,ARmat,ARmat)
C           call mat2(ARmat,sqrhoP,ARmat)

           do I=1,2
            do J=1,2
             G_mjv(I,J,1,ll)=ARmat(I,J)*Fouphase(ll)
            end do
           end do                

           do I=1,2
            do J=1,2
               ARmat(I,J)=C_mns(I,J,L)
            end do
           end do                

C           call mat2(sqrhoA,ARmat,ARmat)
C           call mat2(ARmat,sqrhoP,ARmat)

           do I=1,2
            do J=1,2
             G_mjv(I,J,2,ll)=ARmat(I,J)*Fouphase(ll)
            end do
           end do                
C-----------------END OF place where G_mjv matrixes are filling----------------------------------
	  END IF
	 end do ! L
        END DO ! while
C
        classPOINTER=classPOINTER+GEOSTR(2*GRP)      
       end do !over GRP

      end if

      return
      end

C *******************************************************************    

      subroutine energy_diffuse(mlay,lay_domain,MAXGRP,GEOSTR,b_domain,
     &                          eta,G_mjv,prho,arho,Idiff)

C*******************************************************************    
C                               OPTICS
C
C          Calculation of intensity of diffuse scattering for 
C		 magnetic domain roughness. Black-n-white 
C          non-correlated domains, x-ray case, energy domains 
C
C          (method of G. H. Borzbov et. al. - L. Deak et. al.)
C
C						Khaidukov Yuri
C
C                         Budapest, 2003. May
C	                    Budapest, 2003. November 
C ***************************************************************** 
C
C Geometry:
C
C
C               incident        reflected                    
C                          
C                        \    /    
C                         \  /
C                  FI_inc (\/) FI_final
C      Z=0>           -------------  
C           covering  _____________         [D(1),K(1,I,J)]  
C                                  >Layer#1 [D(2),K(2,I,J)]
C                 1.  .............     
C                           .
C                           .
C                     .............
C Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]
C       I              
C          substrate  _____________         [D(NL),K(NL,I,J)]
C                            `                 ^
C                              `            infinit or finit
C                             refracted
C
C 
C  Variables of system:
C
C  INPUT:
C
C                           covering   layer #L     substrate
C
C            thickneses:         D(1)     D(L)        D(NL)
C
C        susceptibility:
C          (nuclear+magnetic)
C                                K(1)     K(L)        K(NL)
C
C       	 effect_rough       sigma(1)   sigma(L)    sigma(NL)
C  (struct+magnetic rough)
C (rms of domain angle distrib)
C	   mag_sigma(i)->0
C lateral length of correl-n	 ksi(1)     ksi(2)       ksi(NL)
C   where  L=1..NL  I,J=1,2,3 
C --------
C      SFI_inc,SFI_final - incident angle and angle of scattered wave
C      r                    sample-detector distance
C      A                    area of sample
C  
C
C
C  OUTPUT:
C
C         Intensity of diffusely scattered wave from the above sample 
C		which goes under angle SFI-final
C
C ******************************************************************
      implicit none
      integer    mlay,lay_domain,GEOSTR,MAXGRP
      logical    b_domain
      complex*16 G_mjv,Idiff
      dimension  GEOSTR(0:2*mlay),G_mjv(2,2,2,lay_domain),b_domain(mlay)
      real*8     eta

C OUTPUT: Idiff

C Other variables
      integer    POINTER,GRP,GRP1,LMIN,LMAX,n_rep,L,n,POINTER1,
     &            LMIN1,LMAX1,n_rep1,n1,L1,I1,I2,mju1,mju2
       complex*16 dIdiff,prho(2,2),arho(2,2)

      Idiff=dcmplx(0.0D0,0.0D0)

C***************** Sum over mju************
      DO mju1=1,2 
       DO mju2=1,2
C***************** Sum over layers************
	I1=0
        POINTER=0
                                    
        do GRP=1,MAXGRP      ! loop for the groups
         LMIN =POINTER+1
         LMAX =POINTER+GEOSTR(2*GRP)
         n_rep=GEOSTR(2*GRP-1)
	 n=1
         DO WHILE (n.LE.n_rep)
	  n=n+1
          do L=LMIN,LMAX
c          write(6,'(3i4,2x,L4)')n,L,I1,b_domain(L) 
	   if(b_domain(L)) then    !  
	    I1=I1+1
C Second sum over L1
            POINTER1=0
	    I2=0
            do GRP1=1,MAXGRP      ! loop for the groups
             LMIN1 =POINTER1+1
             LMAX1 =POINTER1+GEOSTR(2*GRP1)
             n_rep1=GEOSTR(2*GRP1-1)
             n1=1
             DO WHILE (n1.LE.n_rep1)
              n1=n1+1
              do L1=LMIN1,LMAX1
               if(b_domain(L1))  then  !
 	        I2=I2+1
                call contribution(lay_domain,mju1,mju2,G_mjv,I1,I2,
     &                                             prho,arho,dIdiff)
C------------- All the model assumptions are in this IF-block------------               
               if (mod((I1+I2)*1.0,2.0).EQ.0.)then 
                 if(mju1.eq.mju2)then
                  Idiff=Idiff+dIdiff*eta*(1.D0-eta)
                 else
                  Idiff=Idiff-dIdiff*eta*(1.D0-eta)
                 end if
 	        else  
                 if(mju1.eq.mju2)then
                  Idiff=Idiff-dIdiff*eta*(1.D0-eta)
                 else
                  Idiff=Idiff+dIdiff*eta*(1.D0-eta)
                 end if
 	        end if
!------------------------------------------------------------------------
               endif ! thicklayer(L1) > 0. and ksi(L1)>0
	      end do ! L1
		  
             END DO  ! n1<=n1_rep
             POINTER1=POINTER1+GEOSTR(2*GRP1)
            end do ! GRP1


           endif ! thicklayer(L) > 0. and ksi>0        
!	   print *, d1,d2
          end do ! L
	 END DO  ! n<=n_rep

         POINTER=POINTER+GEOSTR(2*GRP)
        end do ! GRP

       END DO ! over mju1
      END DO ! over mju2
C     close(8)
C      write(6,'(a)')'ready'
c      read(5,'(a)')
      return										 
      end
C  *****************************************************************
C    Contribution to diffuse scattering of layers I1 and I2 for 
C    a given polarization.      
C   	
C  *****************************************************************
       subroutine contribution(lay_domain,mju1,mju2,G_mjv,I1,I2,
     &                                               prho,arho,dIdiff)
	implicit none
        integer    lay_domain,I1,I2,mju1,mju2
        complex*16 G_mjv,prho,arho
        dimension  G_mjv(2,2,2,lay_domain),prho(2,2),arho(2,2)

	complex*16 A,B,dIdiff
	dimension  A(2,2),B(2,2)
	integer    ii,jj
        
	DO ii=1,2
	 DO jj=1,2
	  A(ii,jj)=conjg(G_mjv(jj,ii,mju2,I2))
	  B(ii,jj)=G_mjv(ii,jj,mju1,I1)
	 END DO
	END DO
C
CCC observation with analizer of polarization arho
        call mat2(A,arho,A)
CC
        call mat2(A,B,A) !A=conj[G(E+nh)]*G(E) 
        call mat2(A,prho,B) !B=conj[G(E+nh)]*G(E) *rho
C                                                
	dIdiff=B(1,1)+B(2,2) !dIdiff=Sp{conj[G(E+nh)]*G(E) *rho}                            
C
        return								      
        end

C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine g_fndwba(mlay,lay_domain,MAXGRP,GEOSTR,
     &                    b_Bfield,b_domain,thicklayer,roughlay,SQ,K1,
     &                    Fmatrix_cur, AFmatrix_cur,
     &                    Rmatrix,ARmatrix,
     &                    L1matrix,R1matrix,
     &                    L2matrix,R2matrix,
     &                    L3matrix,R3matrix,
     &                    L4matrix,R4matrix)
C
C*********************************************************************************************************************
C      This subroutine calculates the multiplication factors from the left and right in the expression Gamma. 
C      The four 2x2 matrices are L1matrix...L4matrix from left and R1matrix...R4 matrix from right, respectively.
C                   Gamma= L1matrix*khi*R1matrix+ ... + L4matrix*khi*R4matrix
C      L.Deak, 18.03.2011 (Budapest)
CC*********************************************************************************************************************
 
 
      implicit none
      integer    mlay,lay_domain,NL,MAXGRP,GEOSTR
      logical    b_Bfield,b_domain
      real*8     thicklayer,roughlay,SQ,K1
      complex*16 Fmatrix_cur, AFmatrix_cur,Rmatrix,ARmatrix,
     &           L1matrix,L2matrix,L3matrix,L4matrix,
     &           R1matrix,R2matrix,R3matrix,R4matrix

      dimension   b_Bfield(mlay),GEOSTR(0:2*mlay),thicklayer(mlay),
     &            roughlay(mlay),
     &            Fmatrix_cur(2,2,mlay),AFmatrix_cur(2,2,mlay),
     &            Rmatrix(2,2),ARmatrix(2,2),b_domain(mlay),
     &            L1matrix(2,2,lay_domain),R1matrix(2,2,lay_domain),
     &            L2matrix(2,2,lay_domain),R2matrix(2,2,lay_domain),
     &            L3matrix(2,2,lay_domain),R3matrix(2,2,lay_domain),
     &            L4matrix(2,2,lay_domain),R4matrix(2,2,lay_domain)
C   NL: number of layers  (in period)
C   other variables:
      complex*16 C0,C1,CI,M(4,4),AM(4,4),ML(4,4),AML(4,4),
     &           MGRP(4,4),AMGRP(4,4),KL(2,2),AKL(2,2)
      real*8     QD, DL
      integer    I,J,L,n_rep,GRP,LMIN,LMAX,NLOG,POINTER,I_D

C**************************************

C  L.Deak:    change Rmatrix back to double complex to avoid twicefold conversion
      complex*16  A(2,2),B(2,2),C(2,2),D(2,2),H12
      complex*16  matL1(2,2),matR1(2,2),matL2(2,2),matR2(2,2),
     &            matL3(2,2),matR3(2,2),matL4(2,2),matR4(2,2)
      real        absCmatr,absC1,absC2,alevel
      logical     b_odz,b_grp

C********* Variables added by Khaidukov for neutron case
      complex*16 KLprev(2,2),AKLprev(2,2)
      real*8     DabsMatr,z1,z2

      integer    Lprev,Lnext,n
      logical    prev_dgnl,both_dgnl,both_NONdgnl
C   NL: number of layers  (in period)
      parameter  (C0=(0.D0,0.D0), C1=(1.D0,0.D0), CI=(0.D0,1.D0),
     &            alevel=1.e17)
             
C---------------------------------------------
      QD=SQ 
      NL=mlay
!  Setting the T matrix zero fisrt
c      DO I_D=1,lay_domain
c       DO I=1,2
c	DO J=1,2   
c        L1matrix(I,J,I_D)=C0
c         R1matrix(I,J,I_D)=C0
c         L2matrix(I,J,I_D)=C0
c         R2matrix(I,J,I_D)=C0
c         L3matrix(I,J,I_D)=C0
c         R3matrix(I,J,I_D)=C0
c         L4matrix(I,J,I_D)=C0
c         R4matrix(I,J,I_D)=C0
c        END DO
c       END DO
c      END DO

C  Setting the characteristic matrix to unit matrix
      do I=1,4
       do J=1,4
        M(I,J)  =C0
        AM(I,J) =C0
       end do
       M(I,I)  =C1
       AM(I,I) =C1
      end do

      I_D=0
      POINTER=0                                     

      z1=0.0D0  !First 
      z2=0.0D0  !and the second coordinate for each layer

      do GRP=1,MAXGRP   ! loop for the groups
       do I=1,4
        do J=1,4
         MGRP(I,J)=C0
         AMGRP(I,J)=C0
        end do
        MGRP(I,I)=C1
        AMGRP(I,I)=C1
       end do

       b_grp=.false.
C
       LMIN =POINTER+1
       LMAX =POINTER+GEOSTR(2*GRP)
       n_rep=GEOSTR(2*GRP-1)

CC CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C       if(n_rep.gt.5)n_rep=5                           C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
   
       DO n=1,n_rep   ! loop for the period

        do I=1,4
         do J=1,4
          ML(I,J)=C0
          AML(I,J)=C0
         end do
         ML(I,I)=C1
         AML(I,I)=C1
        end do

        do L=LMIN,LMAX ! loop for the layers
c	 if(real(thicklayer(L)).gt.0..and.real(thicklayer(L)).lt.1.e30) then

	  b_odz=.not.b_Bfield(L)
	  b_grp=.true.  			 

          DL=thicklayer(L)
	  z2=z1+DL

          do I=1,2
           do J=1,2
            KL(I,J) = Fmatrix_cur(I,J,L)
            AKL(I,J)=AFmatrix_cur(I,J,L)
           end do
          end do

          absCmatr=dreal(KL(1,2)*dconjg(KL(1,2))+
     &                    KL(2,1)*dconjg(KL(2,1)))
          absC1=dreal(KL(1,1)*dconjg(KL(1,1))+
     &                    KL(2,2)*dconjg(KL(2,2)))
          absC2=absCmatr*alevel
          if(absC1.gt.absC2) then
           b_odz=.true.
          end if

          IF (b_domain(L)) THEN !If there are domains in this layer store inform
   
           I_D=I_D+1            ! identification of the layer having domains

c           call trans(b_odz,QD,KL, Rmatrix, M, A,B) 
c           call trans(b_odz,K1,AKL,ARmatrix,AM,C,D)
           call trans(QD,KL, Rmatrix, M, A,B) 
           call trans(K1,AKL,ARmatrix,AM,C,D)
            H12=C(1,2)
            C(1,2)=C(2,1)
            C(2,1)=H12

            H12=D(1,2)
            D(1,2)=D(2,1)
            D(2,1)=H12

           if(b_odz)then
            call com_integral(z1,z2,QD,K1,KL,AKL,A,B,C,D,
     &              matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)
           else
            call analytic_integral(z1,z2,QD,K1,KL,AKL,A,B,C,D,
     &              matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)
           end if


           do I=1,2
            do J=1,2
             L1matrix(I,J,I_D)=matL1(I,J)
             R1matrix(I,J,I_D)=matR1(I,J)
             L2matrix(I,J,I_D)=matL2(I,J)
             R2matrix(I,J,I_D)=matR2(I,J)
             L3matrix(I,J,I_D)=matL3(I,J)
             R3matrix(I,J,I_D)=matR3(I,J)
             L4matrix(I,J,I_D)=matL4(I,J)
             R4matrix(I,J,I_D)=matR4(I,J)
	    end do
           end do

C                         call check_for_NAN (Tmatrix(1,1,I_D),'T(1,1)')
C	                  call check_for_NAN (Tmatrix(1,2,I_D),'T(1,2)')
C	                  call check_for_NAN (Tmatrix(2,1,I_D),'T(2,1)')
C	                  call check_for_NAN (Tmatrix(2,2,I_D),'T(2,2)')

          END IF     ! Domains

          call genM(b_odz,QD,DL,KL,M)  !
          call genM(b_odz,-K1,DL,AKL,AM)  !

C************* Roughness************
	  IF (roughlay(L).GT.1.d-3) THEN
           if (n_rep.GT.1.and.L.eq.Lmin) then  ! In case of repeating layers
	    Lprev=LMAX	                       ! we are more interested in the 
	   else                                ! information about roughnesses
                              		       ! in repeated ones. 
	    Lprev=L-1			       !#Khaidukov
	   END IF

           if(n_rep.GT.1.and.L.eq.LMAX) then  !
            Lnext=LMIN         ! For peiodical structure the rougness
           else                ! is also periodical! The next layer to 
            Lnext=L+1          ! the last element is the first layer! 
            if(Lnext.gt.NL) Lnext=NL
           end if              


	   DO I=1,2
	    DO J=1,2 
	     IF (Lprev.EQ.0) THEN 
	      KLprev(I,J)=C0         ! In case of 1st layer KLprev is for vacuum
	      AKLprev(I,J)=C0         ! In case of 1st layer KLprev is for vacuum
	      prev_dgnl=.true.
             END IF                
	     IF (Lprev.GT.0) THEN 	  
              KLprev(I,J)=Fmatrix_cur(I,J,Lprev)
              AKLprev(I,J)=AFmatrix_cur(I,J,Lprev)
	      prev_dgnl=.not.b_Bfield(Lprev)							
	     ENDIF

            END DO
	   END DO

           DabsMatr=dble((KLprev(1,2)-KL(1,2))
     &                    *conjg((KLprev(1,2)-KL(1,2)))+
     &                    (KLprev(2,1)-KL(2,1))
     &                    *conjg((KLprev(2,1)-KL(2,1))))         
	
           IF (prev_dgnl.and.b_odz) then	           !
            both_dgnl   =.true.	                           !  Rohlsberger roughness1
            both_NONdgnl=.false.                           !
           ELSEIF (DabsMatr.lt.1.d-15) then                !
            both_dgnl   =.true.	                           !  Rohlsberger roughness1
            both_NONdgnl=.false.                           !
           ELSEIF (.not.prev_dgnl.and..not.b_odz) then
            both_dgnl   =.false.                           !
            both_NONdgnl=.true.                            !  Deak's roughness
           ELSE  
            both_dgnl   =.false.                           !  Rohlsberger roughness2
            both_NONdgnl=.false.                           !
           ENDIF

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C	  both_dgnl=.false.             !DONT FORGET TO REMOVE!!!!
C      both_NONdgnl=.true.              !Deak's roughness
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

           call OSroughness(both_dgnl,both_NONdgnl,roughlay(L),
     &                   roughlay(Lnext),QD,KLprev,KL,M)    
           call OSroughness(both_dgnl,both_NONdgnl,roughlay(L),
     &                   roughlay(Lnext),-K1,AKLprev,AKL,AM)    
          END IF !Roughness

          call mat4(M,ML,ML)
          call mat4(AM,AML,AML)

          call mat4(ML,MGRP,M) 
          call mat4(AML,AMGRP,AM) 
          z1=z2                     !! changed 14.02.2011

        end do ! L

        if(n_rep.gt.1.and.b_grp)then
         if(n.gt.1)then
          do I=1,4
           do J=1,4
            M(I,J)=ML(I,J)
            AM(I,J)=AML(I,J)
           end do
          end do
         end if ! n.gt.1
C        
         NLOG=alog(float(n))/alog(2.0)
C
         do I=1,NLOG
          call mat4(ML,ML,ML)
          call mat4(AML,AML,AML)
         end do
C
         do I=1,n-2**NLOG
          call mat4(M,ML,ML)
          call mat4(AM,AML,AML)
         end do
         do I=1,4
          do J=1,4
           MGRP(I,J)=ML(I,J)
           AMGRP(I,J)=AML(I,J)

           M(I,J) =ML(I,J)
           AM(I,J) =AML(I,J)
          end do
         end do
        end if  ! n_rep>1

       END DO   ! n=1,n_rep

   
C
       POINTER=POINTER+GEOSTR(2*GRP)
      end do ! GRP

      return
      end

C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      subroutine transb(b_odz,QD,KL,R,L,A,B)
C *******************************************************************
C
C           Calculation of the 2x2 A and B matrixes - amplitudes of wave on the upper border
C
C ******************************************************************
       implicit none
 ! Input 
      real*8     QD     !Kz- perpendicular komponent of wave vektor (Kz=Qz*0.5)
      complex*16 KL(2,2),R(2,2),L(4,4)
      logical    b_odz
!   Output
      complex*16 A(2,2),B(2,2)
!Other
      complex*16 L11(2,2),L12(2,2), L21(2,2),L22(2,2),
     &             RM(2,2),RP(2,2),A1(2,2),A2(2,2),
     &             C1(2,2),C2(2,2),C1P(2,2),C2P(2,2),
     &             C1M(2,2),C2M(2,2),C0
      real*8     QD2

      integer    I,J
      parameter(C0=(0.D0,0.D0))

C   ********************Body of the subroutine**************************************

      QD2=QD*QD

C    Definition of 2x2 block matrices L21, L22 and 
C    the 2x2 I-R and I+R matrices

      do I=1,2
       do J=1,2
        L11(I,J)= 0.5D0*L(I,J)  
	L12(I,J)= 0.5D0*L(I,J+2)
        L21(I,J)= 0.5D0*L(I+2,J)
        L22(I,J)= 0.5D0*L(I+2,J+2)
C
        RM(I,J) = -R(I,J)      ! L.D 15.02.2011 (Garching)
        RP(I,J) =  R(I,J)
       end do
       RM(I,I)  =  1.D0-R(I,I)
       RP(I,I)  =  1.D0+R(I,I)

      end do
!Now Lij are block matrixes already divided by 2, Rm=1-R, Rp=1+R
      if(b_odz)then
       A1(1,1)=(KL(1,1)/QD2)+1.D0     !
       A1(1,2)= C0                    !A1=1+(K/Kz**2)
       A1(2,1)= C0                    !
       A1(2,2)=(KL(2,2)/QD2)+1.D0     !
       
       A2(1,1)= -sqrt(A1(1,1))
       A2(1,2)= C0
       A2(2,1)= C0
       A2(2,2)= -sqrt(A1(2,2))

       A1(1,1)= 1.D0/A2(1,1) 
       A1(1,2)= C0
       A1(2,1)= C0
       A1(2,2)= 1.D0/A2(2,2) 
       
      else

       A1(1,1)=(KL(1,1)/QD2)+1.D0     !
       A1(1,2)= KL(1,2)/QD2           !A1=1+(K/Kz**2)
       A1(2,1)= KL(2,1)/QD2           !
       A1(2,2)=(KL(2,2)/QD2)+1.D0     !

       call sqrt2(A1,A2)

       A2(1,1)=-A2(1,1)
       A2(1,2)=-A2(1,2)
       A2(2,1)=-A2(2,1)
       A2(2,2)=-A2(2,2)

       call inv2(A2,A1)             !A1=eta**-1

      end if
 
      call mat2(A1,L11,C1)         !C1=(eta**-1)*L11*0.5
      call mat2(A1,L12,C2)         !C2=(eta**-1)*L12*0.5

      do I=1,2
       do J=1,2
        C1P(I,J)=L21(I,J)+C1(I,J)  !C1P=(L21+(eta**-1)*L11)*0.5
        C1M(I,J)=L21(I,J)-C1(I,J)  !C1M=(L21-(eta**-1)*L11)*0.5
        C2P(I,J)=L22(I,J)+C2(I,J)  !C2P=(L22+(eta**-1)*L12)*0.5
        C2M(I,J)=L22(I,J)-C2(I,J)  !C2M=(L22-(eta**-1)*L12)*0.5
       end do
      end do
      
      call mat2(C1P,RM,C1)    !C1=(L21+(eta**-1)*L11)*(1-R)*0.5
      call mat2(C2P,RP,C2)    !C2=(L22+(eta**-1)*L12)*(1+R)*0.5
      call mat2(C1M,RM,A1)    !A1=(L21-(eta**-1)*L11)*(1-R)*0.5
      call mat2(C2M,RP,A2)    !A2=(L22-(eta**-1)*L12)*(1+R)*0.5

      do I=1,2
       do J=1,2
        A(I,J)=C1(I,J)+C2(I,J)  ! A=[L21+(eta**-1)*L11)*(1-R)+
		                !      (L22+(eta**-1)*L12)*(1+R)]*0.5
        B(I,J)=A1(I,J)+A2(I,J)  ! B=[(L21-(eta**-1)*L11)*(1-R)+
                                !      (L22-(eta**-1)*L12)*(1+R)]*0.5
       end do
      end do

      return
      end

C ******************************************************************************
C Subroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz 
C in the interval from z1 to z2
C ******************************************************************************
      subroutine analytic_integral(z1,z2,QINC,QOUT,KL,AKL,A,B,C,D,
     &              matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)
      implicit none
! Input       
      real*8      z1,z2,QINC,QOUT
      complex*16  KL(2,2),AKL(2,2),A(2,2),B(2,2),C(2,2),D(2,2)
!OutPuts   
      complex*16  matL1(2,2),matR1(2,2),matL2(2,2),matR2(2,2),
     &            matL3(2,2),matR3(2,2),matL4(2,2),matR4(2,2)
! Other
      complex*16  F(2,2),AF(2,2),FF(2,2),F1(2,2),hTrF,hTrAF,
     &            noTrF(2,2),noTrAF(2,2),sq_detF,sq_detAF,
     &            S(2,2,2,2),dS(2,2,2,2),comR(2,2),comL(2,2)
      complex*16  fact1,fact2,fact3,fact4,fact13,fact24,nu,CI,C1,C0
      real        sqdetcrit
      real*8      z21,QINC2,QOUT2,aLIMIT
      parameter   (CI=(0.0D0,1.0D0),C1=(1.D0,0.D0),C0=(0.D0,0.D0),             
     &                               aLIMIT=2.D1,sqdetcrit=1.E-7)
      integer     I,J,M,N
C  L.Deak 23.02.2009
C  L.Deak 17.03.2011 (Budapest)
C  L.Deak 29.03.2011 (Budapest)
C********************Body of the subroutine
      z21=z2-z1
C matrices, variebles for the incoming wave: 

      QINC2=QINC*QINC
      QOUT2=QOUT*QOUT

      FF(1,1)=-KL(1,1)-QINC2
      FF(1,2)=-KL(1,2)
      FF(2,1)=-KL(2,1)
      FF(2,2)=-KL(2,2)-QINC2

      call sqrt2(FF,F)                         !F=sqrt(-I*QINC**2-KL)  

      hTrF= 0.5D0*(F(1,1)+F(2,2))

      noTrF(1,1)= F(1,1)-hTrF
      noTrF(1,2)= F(1,2)                         !noTrF=F-I*Tr(F)/2
      noTrF(2,1)= F(2,1)                           
      noTrF(2,2)= F(2,2)-hTrF
      
      sq_detF   =sqrt(noTrF(1,1)*noTrF(1,1)+noTrF(1,2)*noTrF(2,1))

      comR(1,1) =  noTrF(1,1)/sq_detF
      comR(1,2) =  noTrF(1,2)/sq_detF
      comR(2,1) =  noTrF(2,1)/sq_detF           
      comR(2,2) = -comR(1,1)

C       variables for the outgoing wave:

      FF(1,1)=-AKL(1,1)-QOUT2
      FF(1,2)=-AKL(1,2)
      FF(2,1)=-AKL(2,1)
      FF(2,2)=-AKL(2,2)-QOUT2

      call sqrt2(FF,AF)                        !AF=sqrt(-QOUT**2-AKL)   

      AF(1,1)= (AF(1,1))
      AF(2,2)= (AF(2,2))
      fact1  = (AF(1,2))
      fact2  = (AF(2,1))
      AF(1,2)= fact2
      AF(2,1)= fact1                            !AF=transpose(AF) L.D, 22.02.2011 (Garching)   

      hTrAF      = 0.5D0*(AF(1,1)+AF(2,2))

      noTrAF(1,1)= AF(1,1)-hTrAF
      noTrAF(1,2)= AF(1,2)                       !noTrAF=AF-I*Tr(AF)/2
      noTrAF(2,1)= AF(2,1)                           
      noTrAF(2,2)= AF(2,2)-hTrAF

      sq_detAF=sqrt(noTrAF(1,1)*noTrAF(1,1)+noTrAF(1,2)*noTrAF(2,1))

      comL(1,1) =  noTrAF(1,1)/sq_detAF
      comL(1,2) =  noTrAF(1,2)/sq_detAF
      comL(2,1) =  noTrAF(2,1)/sq_detAF           
      comL(2,2) = -comL(1,1)
 
C variables for in and out: 

      do I=1,2
       fact1=(-1.D0)**(I-1)*hTrAF
       do J=1,2
        fact2=(-1.D0)**(J-1)*hTrF       
        do M=1,2
         fact3=(-1.D0)**(M-1)*sq_detAF
         do N=1,2
          fact4=(-1.D0)**(N-1)*sq_detF
          S(I,J,M,N)=fact1+fact2+fact3+fact4
          fact13    =(fact1+fact3)*z21
          fact24    =(fact2+fact4)*z21
          dS(I,J,M,N)=fact13+fact24
          if((dble(fact13).lt.aLIMIT).and.(dble(fact24).lt.aLIMIT))then
           if(abs(S(I,J,M,N)).lt.sqdetcrit)then
            dS(I,J,M,N)=0.25D0*z21
           else
            dS(I,J,M,N)=0.25D0*(exp(dS(I,J,M,N))-C1)/S(I,J,M,N)
           endif
          else
           dS(I,J,M,N)=C0
          endif
         enddo
        enddo
       enddo
      enddo
          
C*******************
c  1st grp  right: (I+comR)A 
C  left side:

      matL1(1,1)=C1+comL(1,1)
      matL1(1,2)=comL(1,2)
      matL1(2,1)=comL(2,1)
      matL1(2,2)=C1+comL(2,2)

      call mat2(C,matL1,F1)

      nu=dS(1,1,1,1)
      do I=1,2
       do J=1,2
        FF(I,J)=F1(I,J)*nu
       end do
      end do

      call mat2(D,matL1,F1)

      nu=dS(2,1,2,1)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      matL1(1,1)=C1-comL(1,1)
      matL1(1,2)=-comL(1,2)
      matL1(2,1)=-comL(2,1)
      matL1(2,2)=C1-comL(2,2)

      call mat2(C,matL1,F1)

      nu=dS(1,1,2,1)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      call mat2(D,matL1,F1)

      nu=dS(2,1,1,1)
      do I=1,2
       do J=1,2
        FF(I,J)   =FF(I,J)+F1(I,J)*nu
        matL1(I,J)=FF(I,J)
       end do
      end do

C  right side:

      matR1(1,1)=C1+comR(1,1)
      matR1(1,2)=comR(1,2)
      matR1(2,1)=comR(2,1)
      matR1(2,2)=C1+comR(2,2)

      call mat2(matR1,A,matR1)

C ***********************************
c  2nd grp  right: (I-comR)A
C  left side:

      matL2(1,1)=C1+comL(1,1)
      matL2(1,2)=comL(1,2)
      matL2(2,1)=comL(2,1)
      matL2(2,2)=C1+comL(2,2)

      call mat2(C,matL2,F1)

      nu=dS(1,1,1,2)
      do I=1,2
       do J=1,2
        FF(I,J)=F1(I,J)*nu
       end do
      end do

      call mat2(D,matL2,F1)
 
      nu=dS(2,1,2,2)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      matL2(1,1)=C1-comL(1,1)
      matL2(1,2)=-comL(1,2)
      matL2(2,1)=-comL(2,1)
      matL2(2,2)=C1-comL(2,2)

      call mat2(C,matL2,F1)

      nu=dS(1,1,2,2)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      call mat2(D,matL2,F1)

      nu=dS(2,1,1,2)
      do I=1,2
       do J=1,2
        FF(I,J)   =FF(I,J)+F1(I,J)*nu
        matL2(I,J)=FF(I,J)
       end do
      end do

C  right side:

      matR2(1,1)=C1-comR(1,1)
      matR2(1,2)=-comR(1,2)
      matR2(2,1)=-comR(2,1)
      matR2(2,2)=C1-comR(2,2)

      call mat2(matR2,A,matR2)

C ***********************************
c  3rd grp  right: (I-comR)B
C  left side:

      matL3(1,1)=C1+comL(1,1)
      matL3(1,2)=comL(1,2)
      matL3(2,1)=comL(2,1)
      matL3(2,2)=C1+comL(2,2)

      call mat2(C,matL3,F1)

      nu=dS(1,2,1,1)
      do I=1,2
       do J=1,2
        FF(I,J)=F1(I,J)*nu
       end do
      end do

      call mat2(D,matL3,F1)

      nu=dS(2,2,2,1)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      matL3(1,1)=C1-comL(1,1)
      matL3(1,2)=-comL(1,2)
      matL3(2,1)=-comL(2,1)
      matL3(2,2)=C1-comL(2,2)

      call mat2(C,matL3,F1)

      nu=dS(1,2,2,1)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      call mat2(D,matL3,F1)

      nu=dS(2,2,1,1)
      do I=1,2
       do J=1,2
        FF(I,J)   =FF(I,J)+F1(I,J)*nu
        matL3(I,J)=FF(I,J)
       end do
      end do

C  right side:

      matR3(1,1)=C1-comR(1,1)
      matR3(1,2)=-comR(1,2)
      matR3(2,1)=-comR(2,1)
      matR3(2,2)=C1-comR(2,2)

      call mat2(matR3,B,matR3)

C ***********************************
c  4th grp      
C  left side:  (I+comR)B 

      matL4(1,1)=C1+comL(1,1)
      matL4(1,2)=comL(1,2)
      matL4(2,1)=comL(2,1)
      matL4(2,2)=C1+comL(2,2)

      call mat2(C,matL4,F1)

      nu=dS(1,2,1,2)
      do I=1,2
       do J=1,2
        FF(I,J)=F1(I,J)*nu
       end do
      end do

      call mat2(D,matL4,F1)

      nu=dS(2,2,2,2)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      matL4(1,1)=C1-comL(1,1)
      matL4(1,2)=-comL(1,2)
      matL4(2,1)=-comL(2,1)
      matL4(2,2)=C1-comL(2,2)

      call mat2(C,matL4,F1)

      nu=dS(1,2,2,2)
      do I=1,2
       do J=1,2
        FF(I,J)=FF(I,J)+F1(I,J)*nu
       end do
      end do

      call mat2(D,matL4,F1)

      nu=dS(2,2,1,2)
      do I=1,2
       do J=1,2
        FF(I,J)   =FF(I,J)+F1(I,J)*nu
        matL4(I,J)=FF(I,J)
       end do
      end do

C  right side:

      matR4(1,1)=C1+comR(1,1)
      matR4(1,2)=comR(1,2)
      matR4(2,1)=comR(2,1)
      matR4(2,2)=C1+comR(2,2)

      call mat2(matR4,B,matR4)

      return
      end

C ******************************************************************************
C Subroutines calculate integral (exp(ikz)*A+exp(-ikz)B)*exp(-ik'z)dz 
C in the interval from z1 to z2
C ******************************************************************************
      subroutine com_integral(z1,z2,QINC,QOUT,KL,AKL,A,B,C,D,
     &              matL1,matR1,matL2,matR2,matL3,matR3,matL4,matR4)
      implicit none
! Input
      real*8      z1,z2,QINC,QOUT
      complex*16  KL(2,2),AKL(2,2),A(2,2),B(2,2),C(2,2),D(2,2)
!OutPuts   
      complex*16  matL1(2,2),matR1(2,2),matL2(2,2),matR2(2,2),
     &            matL3(2,2),matR3(2,2),matL4(2,2),matR4(2,2)
! Other
      complex*16  F(2,2),AF(2,2),FF(2,2),CI,C1,C0
      complex*16  AMPL1(2,2),L1(2,2)
      parameter   (CI=(0.0D0,1.0D0),C1=(1.D0,0.D0),C0=(0.D0,0.D0))
      real*8      z21,QINC2,QOUT2,aLIMIT,Rez21AF,Rez21F
      integer     I
      real         sqdetcrit
      parameter   (aLIMIT=2.D1,sqdetcrit=1.E-7)

C  L.Deak 23.02.2009

C********************Body of the subroutine

       z21   =z2-z1

C matrices, variebles for the incoming wave: 

       QINC2=QINC*QINC
       QOUT2=QOUT*QOUT

       FF(1,1)=-KL(1,1)-QINC2
       FF(1,2)= C0
       FF(2,1)= C0
       FF(2,2)=-KL(2,2)-QINC2

       F(1,1)= sqrt(FF(1,1))
       F(1,2)= C0
       F(2,1)= C0
       F(2,2)= sqrt(FF(2,2))                     !F=sqrt(-QINC**2-KL)  

C       variables for the outgoing wave:

       FF(1,1)=-AKL(1,1)-QOUT2
       FF(1,2)= C0
       FF(2,1)= C0
       FF(2,2)=-AKL(2,2)-QOUT2

       AF(1,1)= sqrt(FF(1,1))
       AF(1,2)= C0
       AF(2,1)= C0
       AF(2,2)= sqrt(FF(2,2))                    !AF=sqrt(-QOUT**2-AKL)  

C*******************
C
c 1st grp
C  left side:       

       do I=1,2

        AMPL1(I,I)= AF(I,I)+F(I,I)
        Rez21AF=    z21*dble(AF(I,I))
        Rez21F =    z21*dble(F(I,I))

        if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then
         if(abs(AMPL1(I,I)).lt.sqdetcrit)then
          matL1(I,I)=C(I,I)*z21        
         else
          L1(I,I)=1.D0/AMPL1(I,I)
          FF(I,I)=AMPL1(I,I)*z21
          FF(I,I)=exp(FF(I,I))
          FF(I,I)=FF(I,I)-C1

          AMPL1(I,I)=L1(I,I)*FF(I,I)
          matL1(I,I)=C(I,I)*AMPL1(I,I)
         endif
        else
          matL1(I,I)=C0
        endif
       end do

       matL1(1,2)=C0
       matL1(2,1)=C0

c
C  right side:

       matR1(1,1)=A(1,1)
       matR1(1,2)=A(1,2)
       matR1(2,1)=A(2,1)
       matR1(2,2)=A(2,2)

CC*******************
C
c 2nd grp
C  left side:

       do I=1,2

        AMPL1(I,I)=AF(I,I)-F(I,I)
        Rez21AF=    z21*dble(AF(I,I))
        Rez21F =   -z21*dble(F(I,I))

        if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then
         if(abs(AMPL1(I,I)).lt.sqdetcrit)then
          matL2(I,I)=C(I,I)*z21        
         else
          L1(I,I)=1.D0/AMPL1(I,I)
          FF(I,I)=AMPL1(I,I)*z21
          FF(I,I)=exp(FF(I,I))
          FF(I,I)=FF(I,I)-C1

          AMPL1(I,I)=L1(I,I)*FF(I,I)
          matL2(I,I)=C(I,I)*AMPL1(I,I)
         endif
        else
          matL2(I,I)=C0
        endif
       end do

       matL2(1,2)=C0
       matL2(2,1)=C0

C  right side:

       matR2(1,1)=B(1,1)
       matR2(1,2)=B(1,2)
       matR2(2,1)=B(2,1)
       matR2(2,2)=B(2,2)

C*******************
c 3rd grp
C  left side:

       do I=1,2

        AMPL1(I,I)=-AF(I,I)+F(I,I)
        Rez21AF=   -z21*dble(AF(I,I))
        Rez21F =    z21*dble(F(I,I))

        if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then
         if(abs(AMPL1(I,I)).lt.sqdetcrit)then
          matL3(I,I)=D(I,I)*z21        
         else
          L1(I,I)=1.D0/AMPL1(I,I)
          FF(I,I)=AMPL1(I,I)*z21
          FF(I,I)=exp(FF(I,I))
          FF(I,I)=FF(I,I)-C1

          AMPL1(I,I)=L1(I,I)*FF(I,I)
          matL3(I,I)=D(I,I)*AMPL1(I,I)
         endif
        else
          matL3(I,I)=C0
        endif
       end do

       matL3(1,2)=C0
       matL3(2,1)=C0

C  right side:

       matR3(1,1)=A(1,1)
       matR3(1,2)=A(1,2)
       matR3(2,1)=A(2,1)
       matR3(2,2)=A(2,2)

C ***********************************
c  4th grp
C  left side:

       do I=1,2

        AMPL1(I,I)=-AF(I,I)-F(I,I)
        Rez21AF=   -z21*dble(AF(I,I))
        Rez21F =   -z21*dble(F(I,I))

        if((Rez21AF.lt.aLIMIT).and.(Rez21F.lt.aLIMIT))then
         if(abs(AMPL1(I,I)).lt.sqdetcrit)then
          matL4(I,I)=D(I,I)*z21        
         else
          L1(I,I)=1.D0/AMPL1(I,I)
          FF(I,I)=AMPL1(I,I)*z21
          FF(I,I)=exp(FF(I,I))
          FF(I,I)=FF(I,I)-C1

          AMPL1(I,I)=L1(I,I)*FF(I,I)
          matL4(I,I)=D(I,I)*AMPL1(I,I)
         endif
        else
          matL4(I,I)=C0
        endif
       end do

       matL4(1,2)=C0
       matL4(2,1)=C0

C  right side:

       matR4(1,1)=B(1,1)
       matR4(1,2)=B(1,2)
       matR4(2,1)=B(2,1)
       matR4(2,2)=B(2,2)

       return
       end       

C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       subroutine g_phase(mlay,lay_domain,MAXGRP,GEOSTR,b_domain,
     &                      thicklayer,SQ,Fouphase)
C*********************************************************************************************************************
C      Subroutine calculates Fourier transformation of the field (experssion
C      2.12 in the article). Result is stored in Tmatrix.
C     Size of the Tmatrix is 2*2*i, where i - Number of the layer with domains (pay attention) 
C
CC*********************************************************************************************************************
      implicit none
      integer    mlay,lay_domain,MAXGRP,GEOSTR
      logical    b_domain
      real*8     thicklayer,SQ
      complex*16 Fouphase
      dimension  GEOSTR(0:2*mlay),thicklayer(mlay),b_domain(mlay),
     &           Fouphase(lay_domain)
C   NL: number of layers  (in period)

      integer    L,n_rep,GRP,LMIN,LMAX,POINTER,I_D 
      real*8     QD, DL
      complex*16 C0,C1,CI
      parameter (C0=(0.D0,0.D0), C1=(1.D0,0.D0), CI=(0.D0,1.D0))
C********* Variables added by Khaidukov for neutron case
      integer    n
      real*8     z1,z2
C---------------------------------------------

      QD=SQ
!  To set the Fouphase vector to zero fisrt
      DO I_D=1,lay_domain
	 Fouphase(I_D)=C0
      END DO 

      I_D=0
      POINTER=0                                     

      z1=0.0D0  !First 
      z2=0.0D0  !and the second coordinate for each layer

      do GRP=1,MAXGRP      ! loop for the groups

       LMIN =POINTER+1
       LMAX =POINTER+GEOSTR(2*GRP)
       n_rep=GEOSTR(2*GRP-1)

       DO n=1,n_rep

        do L=LMIN,LMAX 
	 if(thicklayer(L).gt.0.0.and.thicklayer(L).lt.1.e30) then  			 

          DL=thicklayer(L)
	  z2=z1+DL
          IF (b_domain(L)) THEN !If there are domains in this layer store inform
           I_D=I_D+1
           Fouphase(I_D)=-2.D0/QD*exp(CI*QD*(z1+DL/2.D0))
     &                     *sin(QD*DL/2.D0)
          END IF     ! Domains
         endif ! thicklayer(L) > 0.         
         z1=z2
        end do ! L

       END DO   ! n=1,n_rep
C
       POINTER=POINTER+GEOSTR(2*GRP)
      end do ! GRP

      return
      end


C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
	subroutine genMb(b_odz,sinFI,DL,KL,M)
C
C ******************************************************************
C
C            Definition of the integral propagation matrix  
C                   (see  Eq. (3.20) in the paper)
C
C *****************************************************************
      implicit none
      logical    b_odz
      real*8     DL,sinFI
      complex*16 M,KL
      dimension  M(4,4),KL(2,2)

      integer    I,J
      real*8     aimFFF,sin2FI,aLIMIT
      complex*16 exppF,expmF,FL,invF,shF,M12,M21,FF,
     &           detFF,TrFF,TrFL,exppFL,expmFL,shFL,chFL,
     &           FFF,sinFFF,FF1,C1,C0,CI
      dimension  exppF(2,2),expmF(2,2),FL(2,2),           
     &           invF(2,2),shF(2,2),M12(2,2),M21(2,2),FF(2,2)
      real       detcrit
      parameter( C0=(0.D0,0.D0),CI=(0.D0,1.D0),C1=(1.D0,0.D0),
     &           aLIMIT=2.D1,detcrit=1.E-14)

C      Definition of F and X ( Eq. (3.20) L.Deak et al, Phys. Rev B 1996)
C    | ch(vkd*FF)                  1/x*FF*sh(vkd*FF) |
C    | x*FF**(-1)*sh(vkd*FF)       ch(vkd*FF)        |
C    x= i*sin(FI)
C    FF=sqrt(-I*sin**2 FI-khi)
      sin2FI = sinFI*sinFI
      FF(1,1)=-sin2FI-KL(1,1)
      FF(1,2)=-KL(1,2)
      FF(2,1)=-KL(2,1)
      FF(2,2)=-sin2FI-KL(2,2)
C
      if(b_odz)then
        FF(1,1)=sqrt(FF(1,1))  !
        FF(2,2)=sqrt(FF(2,2))  ! for the advanced solutions
      else
       call sqrt2(FF,FF)
      endif
C
      do I=1,2
       do J=1,2
        FL(I,J)=DL*FF(I,J)
       end do
      end do
C
      do I=1,2
       do J=1,2
        exppF(I,J) =FL(I,J)
        M(I,J)     =C0
        M(I+2,J+2) =C0
        M(I,J+2)   =C0
        M(I+2,J)   =C0
       end do
      end do

      if(b_odz)then
       do J=1,2
        FF1   =FF(J,J)
        FFF   =FL(J,J)*CI        
        aimFFF=dimag(FFF)
        if(aimFFF.gt.aLIMIT)then
         M(J,J)    = C1
         M(J+2,J+2)= C1
         M(J,J+2)  =-CI*FF1/sinFI       
         M(J+2,J)  = CI/FF1*sinFI      ! aimFFF -> +infinit
C         write(*,*)'+inf'
        else
         if(aimFFF.lt.-aLIMIT)then
          M(J,J)    = C1
          M(J+2,J+2)= C1
          M(J,J+2)  = CI*FF1/sinFI
          M(J+2,J)  =-CI/FF1*sinFI     ! aimFFF -> -infinit
C          write(*,*)'-inf'
         else
          sinFFF    = sin(FFF)
          M(J,J)    = cos(FFF)
          M(J+2,J+2)= M(J,J)
cc          if(b_ret)then
           M(J,J+2)  =-sinFFF*FF1/sinFI
           M(J+2,J)  = sinFFF/FF1*sinFI ! general case
cc          else
cc           M(J,J+2)  =-sinFFF*FF1/sinFI*(-CI)
cc           M(J+2,J)  = sinFFF/FF1*sinFI*(-CI) ! general case
cc          endif
C          write(*,*)'general'
         end if
        end if
       end do 
C      
      else
C
       detFF=FF(1,1)*FF(2,2)-FF(1,2)*FF(2,1)

       if(abs(detFF).gt.detcrit)then
        call inv2(FF,invF)
        call exp2(exppF)
        call inv2(exppF,expmF)
C
        do I=1,2
         do J=1,2
          M(I,J)    = 0.5D0*(exppF(I,J)+expmF(I,J))
          M(I+2,J+2)= M(I,J)
          shF(I,J)  = 0.5D0*(exppF(I,J)-expmF(I,J))
         end do
        end do
C
        call mat2(FF,shF,M12)
        call mat2(invF,shF,M21)
C
        do I=1,2
         do J=1,2
          M(I,J+2) = -M12(I,J)/sinFI*CI
          M(I+2,J) =  M21(I,J)*sinFI*CI
         end do
        end do
C
       else
c       write(6,*)'genM, abs(detFF)<detcrit'
        TrFF  = FF(1,1)+FF(2,2)      
        TrFL  = FL(1,1)+FL(2,2)      
        exppFL= exp(TrFL)       
        expmFL= 1.D0/exppFL
        chFL  = (exppFL+expmFL)*0.5D0
        shFL  = (exppFL-expmFL)*0.5D0

        call mat2(FF,FF,M21)

        do I=1,2
         do J=1,2
          M(I,J)    = chFL/TrFF*FF(I,J)
          M(I+2,J+2)= M(I,J)
          M(I,J+2)  = -CI*shFL/TrFF/sinFI*M21(I,J)
          M(I+2,J)  =  CI*shFL/TrFF*sinFI
         end do
         M(I,I)    = M(I,I)+(C1-1.D0/TrFF)
         M(I+2,I+2)= M(I,I)
        end do
       endif
      endif ! b_odz == KL diagonal
C      
      return
      end


























































