       subroutine thstr_hyperfield(l_jth,cmch,nhelpentry)

c     hyperfine parameters of H,EFG
c     case 1 values set (no calculation)
c     case 2 g-tensor, A-tensor and EFG,
c     theory spin_Hamiltonian_H(T)_Deq calculates from g,A-tensors 
c     and temperature T the thermal average of S, so that H=A<S> 

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo


      if(cmch.eq.'name')then
       nhelpentry='spin_Hamiltonian one field' 
c      names for child theories , mthchild=3 <= max_nth 
       nameth(1)='DEQ-tensor,H-field values'            !  in S_C 
       namepg(1)='spin_Hamiltonian_H(T)_Deq plrs,1 '
       nameth(2)='spin Hamiltonian S=1/2'               !  in S_C      
       namepg(2)='spin_Hamiltonian_H(T)_Deq plrs,2 '
       nameth(3)='T2g(S=1/2) spin Hamiltonian'          !  in S_C      
       namepg(3)='spin_Hamiltonian_H(T)_Deq plrs,3 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='DEQ spin Hamiltonian'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=3
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk')then
       nstruct=' '        
       return
      end if

c      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,
c                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,

c      &1     /avmaps/  DEq,eta,phiE,thetaE,psiE,aH,thetaH,phiH,

c      &2     /avmaps/  DEq,eta,phiE,thetaE,psiE,
c                       gav,ga,geta,phi_g,theta_g,psi_g,
c                       Aav,A_a,A_eta,phi_A,theta_A,psi_A
c      &3     /avmaps/  Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g

       call conmatpar('coll',jc,jm,jp,jv,chth)

       if(l_jth.eq.1)then
        ntrmt(jm+1)='EFG     matrix=(2,2)   include=[n]'
        ctrmt(jm+1)='electric field gradient tensor at crystal site'
         thpa(jp+1)='EFG              , 0.0  0.0 0.0  0.1'
         thpa(jp+2)='eta              , 0.0  0.0 0.0  0.1'
         thvr(jv+1)='EFG                      1     1 0 '
         thvr(jv+2)='eta                      2     0 1 '
                     
        ntrmt(jm+2)='orient_EFG   matrix=(3,3)   include=[n]'
        ctrmt(jm+2)='Euler angle of the EFG in the crystal system'
         thpa(jp+3)='phiE            , 0.0  0.0 0.0  1.0'
         thpa(jp+4)='thetaE          , 0.0 0.0 0.0   1.0'
         thpa(jp+5)='psiE            , 0.0 0.0 0.0   1.0 '
         thvr(jv+3)='phiE                    3   1 0 0'
         thvr(jv+4)='thetaE                  4   0 1 0'
         thvr(jv+5)='psiE                    5   0 0 1'
                           
        ntrmt(jm+3)='H_internal   matrix=(3,3)   include=[n]'
        ctrmt(jm+3)='internal magnetic field at crystal site'
         thpa(jp+6)='Hi               , 333.0  0.0 0.0  1.0'
         thpa(jp+7)='thetaH           , 0.0 0.0 0.0   1.0'
         thpa(jp+8)='phiH             , 0.0 0.0 0.0   1.0 '
         thvr(jv+6)='Hi                       6    1 0 0  '
         thvr(jv+7)='thetaH                   7    0 1 0 '
         thvr(jv+8)='phiH                     8    0 0 1'
        jm=jm+3
        jp=jp+8
        jv=jv+8 
       else if(l_jth.eq.2)then

        ntrmt(jm+1)='EFG       matrix=(2,2)   include=[n]'
        ctrmt(jm+1)='electric field gradient tensor at crystal site'
         thpa(jp+1)='EFG              , 0.0  0.0 0.0  0.1'
         thpa(jp+2)='eta              , 0.0  0.0 0.0  0.1'
         thvr(jv+1)='EFG                      1     1 0 '
         thvr(jv+2)='eta                      2     0 1 '
                     
        ntrmt(jm+2)='orient_EFG   matrix=(3,3)   include=[n]'
        ctrmt(jm+2)='Euler angle of the EFG in the crystal system'
         thpa(jp+3)='phiE            , 0.0  0.0 0.0  1.0'
         thpa(jp+4)='thetaE          , 0.0 0.0 0.0   1.0'
         thpa(jp+5)='psiE            , 0.0 0.0 0.0   1.0 '
         thvr(jv+3)='phiE                    3   1 0 0'
         thvr(jv+4)='thetaE                  4   0 1 0'
         thvr(jv+5)='psiE                    5   0 0 1'
                           
        ntrmt(jm+3)='g-tensor    matrix=(3,3)   include=[n]'
        ctrmt(jm+3)='g-tensor in the crystal system'
         thpa(jp+6)='gav               , 2.0  0.0 0.0  0.1'
         thpa(jp+7)='g_a               , 0.0 0.0 0.0   0.1'
         thpa(jp+8)='g_eta             , 0.0 0.0 0.0   0.05 '
         thvr(jv+6)='gav                      6   1 0 0'
         thvr(jv+7)='g_a                      7   0 1 0'
         thvr(jv+8)='g_eta                    8   0 0 1'
        jm=jm+3
        jp=jp+8
        jv=jv+8 
        ntrmt(jm+1)='orient_g    matrix=(3,3)   include=[n]'
        ctrmt(jm+1)='Euler angle of the g-tensor in the crystal system'
         thpa(jp+1)='phi_g            , 0.0  0.0 0.0  1.0'
         thpa(jp+2)='theta_g          , 0.0 0.0 0.0   1.0'
         thpa(jp+3)='psi_g            , 0.0 0.0 0.0   1.0 '
         thvr(jv+1)='phi_g                    9   1 0 0'
         thvr(jv+2)='theta_g                  10  0 1 0'
         thvr(jv+3)='psi_g                    11  0 0 1'
   
        ntrmt(jm+2)='A-tensor     matrix=(3,3)   include=[n]'
        ctrmt(jm+2)='A-tensor in the crystal system'
         thpa(jp+4)='Aav               , 200.0  0.0 0.0  0.1'
         thpa(jp+5)='A_a               , 0.0 0.0 0.0   0.1'
         thpa(jp+6)='A_eta             , 0.0 0.0 0.0   0.05 '
         thvr(jv+4)='Aav                      12   1 0 0'
         thvr(jv+5)='A_a                      13   0 1 0'
         thvr(jv+6)='A_eta                    14   0 0 1'

        ntrmt(jm+3)='orient_A      matrix=(3,3)   include=[n]'
        ctrmt(jm+3)='Euler angle of the A-tensor in the crystal system'
         thpa(jp+7)='phi_A            , 0.0  0.0 0.0  1.0'
         thpa(jp+8)='theta_A          , 0.0 0.0 0.0   1.0'
         thpa(jp+9)='psi_A            , 0.0 0.0 0.0   1.0 '
         thvr(jv+7)='phi_A                    15   1 0 0'
         thvr(jv+8)='theta_A                  16  0 1 0'
         thvr(jv+9)='psi_A                    17  0 0 1'
        jm=jm+3
        jp=jp+9
        jv=jv+9 
       else if(l_jth.eq.3)then

        ntrmt(jm+1)='V-A-strength   matrix=(2,2)   include=[n]'
        ctrmt(jm+1)='stenght of EFg and A-tensor'
         thpa(jp+1)='Deq               , 0.0  0.0 0.0  0.1'
         thpa(jp+2)='Aav               , 200.0 0.0 0.0   1.0'
         thvr(jv+1)='Deq                      1   1 0 '
         thvr(jv+2)='Aav                      2   0 1 '

        ntrmt(jm+2)='covalenz      matrix=(2,2)   include=[n]'
        ctrmt(jm+2)='covalenz factors kappa,k of the t2g state'
         thpa(jp+3)='Hc_kappa          , 0.35  0.0 0.0  0.03'
         thpa(jp+4)='cov_k             , 0.785 0.0 0.0  0.03'
         thvr(jv+3)='Hc_kappa                 3   1 0 '
         thvr(jv+4)='cov_k                    4   0 1 '
   
        ntrmt(jm+3)='t2g_function   matrix=(2,2)   include=[n]'
        ctrmt(jm+3)='two angle describe the 1-electron t2g states'
         thpa(jp+5)='phi_t2g            , 45.0  0.0 0.0  1.0'
         thpa(jp+6)='theta_t2g          , 54.74 0.0 0.0   1.0'
         thvr(jv+5)='phi_t2g                   5  1 0 '
         thvr(jv+6)='theta_t2g                 6  0 1 '

        ntrmt(jm+4)='orient_PAS     matrix=(3,3)   include=[n]'
        ctrmt(jm+4)='Euler angle of the PAS in the crystal system'
         thpa(jp+7)='phi_t            , 0.0  0.0 0.0  1.0'
         thpa(jp+8)='theta_t          , 0.0 0.0 0.0   1.0'
         thpa(jp+9)='psi_t            , 0.0 0.0 0.0   1.0 '
         thvr(jv+7)='phi_t                    9    1 0 0'
         thvr(jv+8)='theta_t                  10   0 1 0'
         thvr(jv+9)='psi_t                    11   0 0 1'
        jm=jm+4
        jp=jp+9
        jv=jv+9 
       end if
      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end

      subroutine thstr_sH05slowrelax(l_jth,cmch,nhelpentry)
c     hyperfine parameters of H1,H2, ,EFG
c     g-tensor, A-tensor 
c     theory two_hyperfine_fields calculates from g,A-tensors 
c     two S expectation values so that H1=A<S1> H2=A<S2> of
c     energy levels E1 and E2.
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth
      character nhelpentry*132,chth*8,cmch*4
      logical  name_eq_ntheo


      if(cmch.eq.'name')then
       nhelpentry='spin_Hamiltonian two fields'
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='Kramers doublet slow relaxation'       !  in S_C 
       namepg(1)='spin_Ham_Deq_slowrelax  plrs,1 '
       nameth(2)='T2g(S=1/2) spin-Ham slow relaxation'   !  in S_C      
       namepg(2)='spin_Ham_Deq_slowrelax  plrs,2 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='DEQ spin Hamiltonian, 2 hyp_fields'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=2
       return
      end if
      
      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk')then
       nstruct=' '        
       return
      end if

c      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,
c                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,

c      &1     /avmaps/  DEq,eta,phiE,thetaE,psiE,
c                       gav,ga,geta,phi_g,theta_g,psi_g,
c                       Aav,A_a,A_eta,phi_A,theta_A,psi_A
c      &2     /avmaps/  Deq,Aav,Hc_kappa,cov_k,phi_t2g,theta_t2g

       call conmatpar('coll',jc,jm,jp,jv,chth) 

       if(l_jth.eq.1)then

        ntrmt(jm+1)='EFG       matrix=(2,2)   include=[n]'
        ctrmt(jm+1)='electric field gradient tensor at crystal site'
         thpa(jp+1)='EFG              , 0.0  0.0 0.0  0.1'
         thpa(jp+2)='eta              , 0.0  0.0 0.0  0.1'
         thvr(jv+1)='EFG                      1     1 0 '
         thvr(jv+2)='eta                      2     0 1 '
                     
        ntrmt(jm+2)='orient_EFG  matrix=(3,3)   include=[n]'
        ctrmt(jm+2)='Euler angle of the EFG in the crystal system'
         thpa(jp+3)='phiE            , 0.0  0.0 0.0  1.0'
         thpa(jp+4)='thetaE          , 0.0 0.0 0.0   1.0'
         thpa(jp+5)='psiE            , 0.0 0.0 0.0   1.0 '
         thvr(jv+3)='phiE                     3   1 0 0'
         thvr(jv+4)='thetaE                   4   0 1 0'
         thvr(jv+5)='psiE                     5   0 0 1'
                           
        ntrmt(jm+3)='g-tensor     matrix=(3,3)   include=[n]'
        ctrmt(jm+3)='g-tensor in the crystal system'
         thpa(jp+6)='gav               , 2.0  0.0 0.0  0.1'
         thpa(jp+7)='g_a               , 0.0 0.0 0.0   0.1'
         thpa(jp+8)='g_eta             , 0.0 0.0 0.0   0.05 '
         thvr(jv+6)='gav                      6   1 0 0'
         thvr(jv+7)='g_a                      7   0 1 0'
         thvr(jv+8)='g_eta                    8   0 0 1'
        jm=jm+3
        jp=jp+8
        jv=jv+8

        ntrmt(jm+1)='orient_g   matrix=(3,3)   include=[n]'
        ctrmt(jm+1)='Euler angle of the g-tensor in the crystal system'
         thpa(jp+1)='phi_g            , 0.0  0.0 0.0  1.0'
         thpa(jp+2)='theta_g          , 0.0 0.0 0.0   1.0'
         thpa(jp+3)='psi_g            , 0.0 0.0 0.0   1.0 '
         thvr(jv+1)='phi_g                    9   1 0 0'
         thvr(jv+2)='theta_g                  10  0 1 0'
         thvr(jv+3)='psi_g                    11  0 0 1'
   
        ntrmt(jm+2)='A-tensor   matrix=(3,3)   include=[n]'
        ctrmt(jm+2)='A-tensor in the crystal system'
         thpa(jp+4)='Aav               , 2.0  0.0 0.0  0.1'
         thpa(jp+5)='A_a               , 0.0 0.0 0.0   0.1'
         thpa(jp+6)='A_eta             , 0.0 0.0 0.0   0.05 '
         thvr(jv+4)='Aav                      12   1 0 0'
         thvr(jv+5)='A_a                      13   0 1 0'
         thvr(jv+6)='A_eta                    14   0 0 1'

        ntrmt(jm+3)='orient_A    matrix=(3,3)   include=[n]'
        ctrmt(jm+3)='Euler angle of the A-tensor in the crystal system'
         thpa(jp+7)='phi_A            , 0.0  0.0 0.0  1.0'
         thpa(jp+8)='theta_A          , 0.0 0.0 0.0   1.0'
         thpa(jp+9)='psi_A            , 0.0 0.0 0.0   1.0 '
         thvr(jv+7)='phi_A                    15   1 0 0'
         thvr(jv+8)='theta_A                  16  0 1 0'
         thvr(jv+9)='psi_A                    17  0 0 1'
        jm=jm+3
        jp=jp+9
        jv=jv+9
       else if(l_jth.eq.2)then

        ntrmt(jm+1)='V-A-strength matrix=(2,2)   include=[n]'
        ctrmt(jm+1)='strenght of EFg and A-tensor'
         thpa(jp+1)='Deq                 0.0  0.0 0.0  0.1'
         thpa(jp+2)='Aav                 0.0 0.0 0.0   1.0'
         thvr(jv+1)='Deq                     1   1 0 '
         thvr(jv+2)='Aav                     2   0 1 '

        ntrmt(jm+2)='covalenz    matrix=(2,2)   include=[n]'
        ctrmt(jm+2)='covalenz factors kappa,k of the t2g state'
         thpa(jp+3)='Hc_kappa            0.35  0.0 0.0  0.03'
         thpa(jp+4)='cov_k               0.785 0.0 0.0  0.03'
         thvr(jv+3)='Hc_kappa                 3   1 0 '
         thvr(jv+4)='cov_k                    4   0 1 '
   
        ntrmt(jm+3)='t2g_function matrix=(2,2)   include=[n]'
        ctrmt(jm+3)='two angle describe the 1-electron t2g states'
         thpa(jp+5)='phi_t2g            , 45.0  0.0 0.0  1.0'
         thpa(jp+6)='theta_t2g          , 54.74 0.0 0.0   1.0'
         thvr(jv+5)='phi_t2g                  5  1 0 '
         thvr(jv+6)='theta_t2g                6  0 1 '

        ntrmt(jm+4)='orient_PAS   matrix=(3,3)   include=[n]'
        ctrmt(jm+4)='Euler angle of the PAS in the crystal system'
         thpa(jp+7)='phi_t                0.0  0.0 0.0  1.0'
         thpa(jp+8)='theta_t              0.0 0.0 0.0   1.0'
         thpa(jp+9)='psi_t                0.0 0.0 0.0   1.0 '
         thvr(jv+7)='phi_t                    9   1 0 0'
         thvr(jv+8)='theta_t                  10   0 1 0'
         thvr(jv+9)='psi_t                    11   0 0 1'
        jm=jm+4
        jp=jp+9
        jv=jv+9
       end if

      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end




