      subroutine frstr_syndoubleSC(l_nfrtheo,lstruct1,lstruct2,
     &                                   cmch,nhelpentry)

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer   l_nfrtheo,lstruct1,lstruct2
      character*132 nhelpentry,cmch*4,chth*8
 
      if(cmch.eq.'name') then
c####################################################
       nhelpentry  ='Synchrotron spectrum of two scatterers' 
       ntheory(1)='Synchrotron source-double scattering'

       n_device=2
       ndevice(1)='1  (12=GF or FG as selected)'
       ndevice(2)='2  (12=FG or GF as selected)'
c####################################################
       return
      end if

c      calling by l_nfrtheo=1,2,3,4
c      nameth(1)='Nuclear forward/specular scattering'
c      nameth(2)='Nuclear specular/forward scattering'

      chth='fr'//nhelpentry(1:6)

      ldevice=lstruct1    
      if(m_device.gt.0)then
       jdevice=mdevf-1+m_device
       if(lstruct1.ge.m_device)ldevice=m_device
       if(lstruct1.gt.jdevice)ldevice=lstruct1-(mdevf-1)
      end if
c      write(6,'(a,2i4)')' lstruct1,ldevice=',lstruct1,ldevice
      goto(100,200,300)ldevice+1
c------------------------------------------------------------------------
 100  continue
       
c      common/acstrf/acsp,wavelength,uthick,uthick_A,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,t0_norm,

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=4   chth='//chth
c      reading wavelength
       return
      end if

c     variables: source,absorber and detector orientation
c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta
c                      PAxsi,PAeta,PAzeta,t_shift,graz_angle,phi_z

       call conmatpar('coll',jc,jm,jp,jv,chth)

c                    1        0         012345
      ntrmt(jm+1)='counts     matrix=(1,1)   include= y  '
      ctrmt(jm+1)='frame parameter total counts'
       thpa(jp+1)='counts            , 10000.0  0.0 0.0 10.0'! sum of counts
       thvr(jv+1)='counts                    1    1   '

      ntrmt(jm+2)='background   matrix=(1,1) from_data=[n]'
      ctrmt(jm+2)='frame parameter background'
       thpa(jp+2)='background        , 0.0 0.0 0.0 1.0'  ! background/channel
       thvr(jv+2)='background                2    1  '
      
      ntrmt(jm+3)='Poincare_beam  matrix=(3,3) from_data=[n]'
      ctrmt(jm+3)='Poincare vector of the Synchrotron beam'
       thpa(jp+3)='P_xsi           , -1.0  0.0 1.0  0.05'
       thpa(jp+4)='P_eta           , 0.0  0.0 0.0   0.05'
       thpa(jp+5)='P_zeta          , 0.0  0.0 0.0   0.05'
       thvr(jv+3)='P_xsi                     3    1 0 0 '
       thvr(jv+4)='P_eta                     4    0 1 0 '
       thvr(jv+5)='P_zeta                    5    0 0 1 '
      jm=jm+3
      jp=jp+5
      jv=jv+5

      ntrmt(jm+1)='Poincare_analyser   matrix=(3,3) from_data=[n]'
      ctrmt(jm+1)='Poincare vector of the analyser '
       thpa(jp+1)='PAxsi           , 0.0  0.0 0.0   0.05'
       thpa(jp+2)='PAeta           , 0.0  0.0 0.0   0.05'
       thpa(jp+3)='PAzeta          , 0.0  0.0 0.0   0.05'
       thvr(jv+1)='PAxsi                     6    1 0 0 '
       thvr(jv+2)='PAeta                     7    0 1 0 '
       thvr(jv+3)='PAzeta                    8    0 0 1 '
      jm=jm+1
      jp=jp+3
      jv=jv+3



      if(l_nfrtheo.eq.1)
     &strcmt(1)='forward_grazing_scatterer     n_set=[fg]   2  0' 
      if(l_nfrtheo.eq.2)
     &strcmt(1)='grazing_forward_scatterer     n_set=[gf]   2  0' 
      strcmt(2)='global name of the spectrum '
      strcmt(3)='xxx '
      strcmt(4)='theory/'//chth//'/forward_grazing_scatterer/go'
      strcmt(5)='theory/'//chth//'/grazing_forward_scatterer/layer'

      call conmatpar('dev1',jc,jm,jp,jv,chth) 
      return
c-------------------------------------------------------------------------
 200  continue
c     first scattering device
      if(lstruct2.gt.0) goto 210

      if(cmch.eq.'hdbk') then
        nstruct=' '
       return
      end if
      call conmatpar('coll',jc,jm,jp,jv,chth) 

c      common/cfr1trf/ inc_frac,Hext,thetaHe,phiHe,phi,theta,psi


      if(l_nfrtheo.eq.1) then
       strcmt(1)='forward_scatterer  n_device=[fs] mijk=co;sw;su [1] 1'
c                                           cover sandwich substrate
       strcmt(2)='two letters for the forward scatterer'
       strcmt(3)='number of layers of the  forward scatterer '
       strcmt(4)='distribution of parameters at sites of the layer'
       strcmt(5)='theory/'//chth//'/forward_scatterer/layer'
      end if

      if(l_nfrtheo.eq.2) then
       strcmt(1)='grazing_incidence  n_device=[gs] mijk=co;sw;su [2] 1'
c                                           cover sandwich substrate
       strcmt(2)='two letters for the grazing incidence scatterer'
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='distribution of parameters at sites of the layer'
       strcmt(5)='theory/'//chth//'/grazing_scatterer/layer'
      end if

      if(l_nfrtheo.eq.2) then
c      the external field and orientation for the scatterer are defined 
c      on level fr1: one field and orientation for all layers  
c      !! transfer of fr1 values to all layers(fr2) in the loop lstruct2
c         in the scattering theories 
       ntrmt(jm+1)='H_extern   matrix=(3,3)   include=[n]'
       ctrmt(jm+1)='external magnetic field at the scatterer'
        thpa(jp+1)='Hext            , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='thetaHe         , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='phiHe           , 0.0 0.0 0.0   1.0 '
        thvr(jv+1)='Hext                    2       1 0 0 '
        thvr(jv+2)='thetaHe                 3       0 1 0 '
        thvr(jv+3)='phiHe                   4       0 0 1 '
        
       
       ntrmt(jm+2)='orientation   matrix=(3,3)   include=[n]'
       ctrmt(jm+2)='Euler angle of the absorber in the LAB'
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0'
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 '
        thvr(jv+4)='phi                     5    1 0 0'
        thvr(jv+5)='theta                   6    0 1 0'
        thvr(jv+6)='psi                     7    0 0 1'
       jm=jm+2
       jp=jp+6
       jv=jv+6
      end if

      call conmatpar('dev2',jc,jm,jp,jv,chth)
      return
c     --------------------------------------------------
 210  continue
c     layers of device  common/acfr2trf/    /avfr2trf/ 
c     for common/acfritrf/    /avfritrf/ 

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

c     common/acfr2trf/ repeat_group
c     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,eta_domain

       call conmatpar('coll',jc,jm,jp,jv,chth)

       thco(jc+1)='iset_powder                2 #n  0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       thco(jc+2)='isymmetry                  3 #n  10 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       thco(jc+3)='n_psi_powder               4 #n  0 '
                ! 3rd Euler angle, rotation around S_lab(z)
                ! neccessary if Hext not parallel S_lab(z)
       jc=jc+3

      if(l_nfrtheo.eq.1) then
c      :forward scattering 
       ntrmt(jm+1)='Hextern   matrix=(3,3)   include=[n]'
       ctrmt(jm+1)=
     &     'external magnetic field (Lab) at the forward scatterer'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0'
        thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0'
        thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 '
        thvr(jv+1)='Hext                     6    1 0 0  '
        thvr(jv+2)='thetaHe                  7    0 1 0 '
        thvr(jv+3)='phiHe                    8    0 0 1'
         
       ntrmt(jm+2)='orientation    matrix=(3,3)   include=[n]'
       ctrmt(jm+2)='Euler angle of the forward scatterer in the LAB'
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0'
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 '
        thvr(jv+4)='phi                      9    1 0 0'
        thvr(jv+5)='theta                   10    0 1 0'
        thvr(jv+6)='psi                     11    0 0 1'       
       jm=jm+2
       jp=jp+6      
       jv=jv+6  

       strcmt(1)='scatterer_layer  n_cmpt=[s]  [1]  0'
       strcmt(2)=' one letter for name of the site '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='distribution of parameters of site number'
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites'
      end if

      call conmatpar('lay2',jc,jm,jp,jv,chth)
      return
c------------------------------------------------------------------------
 300  continue
c     second scattering device
c     only for l_nfrtheo=3,4

      if(lstruct2.gt.0) goto 310

      if(cmch.eq.'hdbk') then
        nstruct=' '
       return
      end if
      call conmatpar('coll',jc,jm,jp,jv,chth) 

      if(l_nfrtheo.eq.1) then
       strcmt(1)='grazing_incidence  n_device=[gs] mijk=co;sw;su [2] 1'
c                                           cover sandwich substrate
       strcmt(2)='two letters for the grazing incidence scatterer'
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)='distribution of parameters at sites of the layer'
       strcmt(5)='theory/'//chth//'/grazing_scatterer/layer'
      end if

      if(l_nfrtheo.eq.2) then
       strcmt(1)='forward_scatterer  n_device=[fs] mijk=co;sw;su [2] 1'
c                                           cover sandwich substrate
       strcmt(2)='two letters for the forward scatterer'
       strcmt(3)='number of layers of the  forward scatterer '
       strcmt(4)='distribution of parameters at sites of the layer'
       strcmt(5)='theory/'//chth//'/forward_scatterer/layer'
      end if

c      common/cfr1trf/ inc_frac,Hext,thetaHe,phiHe,phi,theta,psi

c                                                              def/llimit
      if(l_nfrtheo.eq.2) then
c      the external field and orientation for the scatterer are defined 
c      on level fr1: one field and orientation for all layers  
c      !! transfer of fr1 values to all layers(fr2) in the loop lstruct2
c         in the scattering theories 
       ntrmt(jm+1)='H_extern    matrix=(3,3)   include=[n]'
       ctrmt(jm+1)='external magnetic field at the scatterer'
        thpa(jp+1)='Hext            , 0.0  0.0 0.0  1.0'
        thpa(jp+2)='thetaHe         , 0.0 0.0 0.0   1.0'
        thpa(jp+3)='phiHe           , 0.0 0.0 0.0   1.0 '
        thvr(jv+1)='Hext                    2       1 0 0 '
        thvr(jv+2)='thetaHe                 3       0 1 0 '
        thvr(jv+3)='phiHe                   4       0 0 1 '
        
       
       ntrmt(jm+2)='orientation  matrix=(3,3)   include=[n]'
       ctrmt(jm+2)='Euler angle of the absorber in the LAB'
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0'
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 '
        thvr(jv+4)='phi                     5    1 0 0'
        thvr(jv+5)='theta                   6    0 1 0'
        thvr(jv+6)='psi                     7    0 0 1'
       jm=jm+2
       jp=jp+6
       jv=jv+6
      end if

       call conmatpar('dev2',jc,jm,jp,jv,chth)
      return
c     --------------------------------------------------
 310  continue
c     layers of device  common/acfr2trf/    /avfr2trf/ 
c     for common/acfritrf/    /avfritrf/ 

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

c     common/acfr2trf/ repeat_group
c     common/avfr2trf/avfr2,thicklay,re_chilay,ai_chilay,roughness,eta_domain

       call conmatpar('coll',jc,jm,jp,jv,chth)

      if(l_nfrtheo.eq.1) then
       thco(jc+1)='rep.grp       i_pos=1    include= y     1.1 '
           ! layer belongs to a group which repeat with period
       jc=jc+1
      end if
      if(l_nfrtheo.eq.2) then
       thco(jc+1)='iset_powder   i_pos=2 include= n  0 '
                ! iset=1-6 for 4-128 points on 1/48 of the sphere
       thco(jc+2)='isymmetry     i_pos=3 include= n  10 '
                ! isymmetry =11-15 (z||C_4) and 21-25 (z||C_3)
       thco(jc+3)='n_psi_powder  i_pos=4 include= n  0 '
                ! 3rd Euler angle, rotation around S_lab(z)
                ! neccessary if Hext not parallel S_lab(z)
       jc=jc+3
      end if

      if(l_nfrtheo.eq.2) then
c      4: second device forward scattering
       ntrmt(jm+1)='Hextern   matrix=(3,3)   include=[n]'
       ctrmt(jm+1)=
     &        'external magnetic field (Lab) at the forward scatterer'
        thpa(jp+1)='Hext             , 0.0  0.0 0.0   1.0'
        thpa(jp+2)='thetaHe          , 0.0  0.0 0.0   1.0'
        thpa(jp+3)='phiHe            , 0.0  0.0 0.0   1.0 '
        thvr(jv+1)='Hext                     6    1 0 0  '
        thvr(jv+2)='thetaHe                  7    0 1 0 '
        thvr(jv+3)='phiHe                    8    0 0 1'
         
       ntrmt(jm+2)='orientation matrix=(3,3)   include=[n]'
       ctrmt(jm+2)='Euler angle of the forward scatterer in the LAB'
        thpa(jp+4)='phi             , 0.0  0.0 0.0  1.0'
        thpa(jp+5)='theta           , 0.0 0.0 0.0   1.0'
        thpa(jp+6)='psi             , 0.0 0.0 0.0   1.0 '
        thvr(jv+4)='phi                      9    1 0 0'
        thvr(jv+5)='theta                   10    0 1 0'
        thvr(jv+6)='psi                     11    0 0 1'       
       jm=jm+2
       jp=jp+6      
       jv=jv+6  

       strcmt(1)='scatterer_layer   n_cmpt=[s]   [1] 1'
       strcmt(2)=' one letter for name of the site '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='distribution of parameters of site number'
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites'
      end if

      if(l_nfrtheo.eq.1) then
c                    1        0         01234567
       ntrmt(jm+1)='thickn_lay   matrix=(1,1)   include= y '
       ctrmt(jm+1)='thickness of the layer'
        thpa(jp+1)='thicklay        , 100.0  0.0 0.0  0.1'
        thvr(jv+1)='thicklay                1    , 1  '

       ntrmt(jm+2)='chi_electronic  matrix=(2,2)   include= y '
       ctrmt(jm+2)='chi_electronic of the layer  '
        thpa(jp+2)='r_chilay        , -14.50  0.0 0.0  0.1'  ! iron
        thpa(jp+3)='i_chilay        ,   0.70  0.0 0.0  0.1'  ! iron'
        thvr(jv+2)='r_chilay                2    1 0'
        thvr(jv+3)='i_chilay                3    0 1'

       ntrmt(jm+3)='roughness     matrix=(1,1)   include=[y]'
       ctrmt(jm+3)='roughness of the layer  '
        thpa(jp+4)='roughness        , 0.0  0.0 0.0  0.1'
        thvr(jv+4)='roughness               4    1 '
       jm=jm+3
       jp=jp+4
       jv=jv+4


       strcmt(1)='scatterer_layer   n_cmpt=[s]  [1]  0'
       strcmt(2)='one letter for name of the site '
       strcmt(3)='number of inequivalent sites of the scatterer layer'
       strcmt(4)='distribution of parameters of site number'
       strcmt(5)='theory/'//chth//'/scatterer/layer/sites'
      end if
 
      call conmatpar('lay2',jc,jm,jp,jv,chth)

      return
      end


c    ###################################################################
c                                thstr


      subroutine thstr_syndoubleSC(l_jth,cmch,nhelpentry)

c     case time domain spectrum,
c          time integral - rocking curve
c          prompt - rocking curve
c     for  Synchrotron reflection

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for' 

      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo


      if(cmch.eq.'name')then
       nhelpentry='Synchrotron source-double scattering (distribute)'       
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='Nuclear forward/specular scattering'
       nameth(2)='Nuclear specular/forward scattering'
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Synchrotron source-double scattering'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=2
      end if

      return
      end

      subroutine thstr_synFGscattering(l_jth,cmch,nhelpentry)
c     scattering forward -scpecular grazing incidence
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      ndevice(1)='forward scatterer'
      ndevice(2)='grazing incidence scatterer'

      if(cmch.eq.'name')then
       nhelpentry='Nuclear forward/specular scattering (distribute)'
c      names for child theories , mthchild=1 <= max_nth 
       nameth(1)='Nuclear double FG scattering'
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear forward/specular scattering'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=1
       return
      end if

      chth='th'//nhelpentry(1:6)
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=1,2   chth='//chth
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
      
c      common/acstrf/ acsp,wavelength,uthick,uthick_A,            
c     &               unit_chi,                                        1
c     &               aiT_max,v_max,ak_extension,                      4
c     &               T_bunch,scale,                                   6
c     &               channels,ch_angle,graz_beg,graz_end,            10
c     &               t0_norm,flag_basis                              12

       thco(jc+1)='i_T_max          i_pos=2 include= y    0 '
                ! Time window for display
       thco(jc+2)='v_max[mm/s]     i_pos=3 include= y    8 '
                ! v_max of the nuclear energies
       thco(jc+3)='k_extension_2**k i_pos=4  include= y   0 '
                ! times v_max
       jc=jc+3
       thco(jc+1)='T0_NormInt       i_pos=11 include= y   10'
                 ! integration for normalizing from t0
       thco(jc+2)='T_bunch          i_pos=5  from_data=[y] 160'
                 ! bunch distance in ns
       thco(jc+3)='nu_channels      i_pos=7  from_data=y 256'
                ! number of channels for for angles
       thco(jc+4)='scale            i_pos=6  from_data=[y] 1'
                ! determines function for channel to time conversion
       thco(jc+5)='unit_chi         i_pos=1   include= y   1.0e-6 '
               ! susceptibility multiplied by

       thco(jc+6)='flag_basis       i_pos=12  include= y   1 '
                 ! switch for circular-linear basis 
       jc=jc+6

c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      t_shif
       ntrmt(jm+1)='calibration    matrix=(1,1) from_data=[y]'
       ctrmt(jm+1)='frame parameter t_shift'
        thpa(jp+1)='t_shift           , 0.0 0.0 0.0 0.1'
        thvr(jv+1)='t_shift                  1     1  '

       ntrmt(jm+2)='orientation    matrix=(2,2) from_data=[y]'
       ctrmt(jm+2)='(2) grazing angle of the scatterer'
        thpa(jp+2)='graz_angle        , 5.0 0.0 0.0   1.0'
        thpa(jp+3)='phi_z             , 0.0  0.0 0.0  1.0'
        thvr(jv+2)='graz_angle                2    1 0 '
        thvr(jv+3)='phi_z                     3    0 1 '
       jm=jm+2
       jp=jp+3
       jv=jv+3

      ntrmt(jm+1)='placeholders    matrix=(2,2) from_data= y'
      ctrmt(jm+2)='frame parameter detekt_eff,counts_bunch'
       thpa(jp+1)='detekt_eff             , 0.9 0.0 0.0 0.1'
       thpa(jp+2)='counts_bunch           , 1.0 0.0 0.0 0.1'
       thvr(jv+1)='detekt_eff                4     1 0 '
       thvr(jv+2)='counts_bunch              5     0 1 '
      jm=jm+1
      jp=jp+2
      jv=jv+2      

      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end


      subroutine thstr_synGFscattering(l_jth,cmch,nhelpentry)
c     scattering: scpecular grazing incidence-forward 
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='Nuclear specular/forward scattering (distribute)'
c      names for child theories , mthchild=1 <= max_nth
       nameth(1)='Nuclear double GF scattering'
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Nuclear specular/forward scattering'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=1
       return
      end if

      chth='th'//nhelpentry(1:6)
      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=1,2   chth='//chth
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)
      
c      common/acstrf/ acsp,wavelength,uthick,uthick_A,            
c     &               unit_chi,                                        1
c     &               aiT_max,v_max,ak_extension,                      4
c     &               T_bunch,scale,                                   6
c     &               channels,ch_angle,graz_beg,graz_end,            10
c     &               t0_norm,flag_basis                              12

       thco(jc+1)='i_T_max          i_pos=2 include= y    0 '
                ! Time window for display
       thco(jc+2)='v_max[mm/s]     i_pos=3 include= y    8 '
                ! v_max of the nuclear energies
       thco(jc+3)='k_extension_2**k i_pos=4  include= y   0 '
                ! times v_max
       jc=jc+3
       thco(jc+1)='T0_NormInt       i_pos=11 include= y   10'
                 ! integration for normalizing from t0
       thco(jc+2)='T_bunch          i_pos=5  from_data=[y] 160'
                 ! bunch distance in ns
       thco(jc+3)='nu_channels      i_pos=7  from_data=y 256'
                ! number of channels for for angles
       thco(jc+4)='scale            i_pos=6  from_data=[y] 1'
                ! determines function for channel to time conversion
       thco(jc+5)='unit_chi         i_pos=1   include= y   1.0e-6 '
               ! susceptibility multiplied by

       thco(jc+6)='flag_basis       i_pos=12  include= y   1 '
                 ! switch for circular-linear basis 
       jc=jc+6

c      common/cvsptrf/ counts,background,Pxsi,Peta,Pzeta,
c                      t_shif
       ntrmt(jm+1)='calibration    matrix=(1,1) from_data=[y]'
       ctrmt(jm+1)='frame parameter t_shift'
        thpa(jp+1)='t_shift           , 0.0 0.0 0.0 0.1'
        thvr(jv+1)='t_shift                  1     1  '

       ntrmt(jm+2)='orientation    matrix=(2,2) from_data=[y]'
       ctrmt(jm+2)='(2) grazing angle of the scatterer'
        thpa(jp+2)='graz_angle        , 5.0 0.0 0.0   1.0'
        thpa(jp+3)='phi_z             , 0.0  0.0 0.0  1.0'
        thvr(jv+2)='graz_angle                2    1 0 '
        thvr(jv+3)='phi_z                     3    0 1 '
       jm=jm+2
       jp=jp+3
       jv=jv+3

      ntrmt(jm+1)='placeholders    matrix=(2,2) from_data= y'
      ctrmt(jm+2)='frame parameter detekt_eff,counts_bunch'
       thpa(jp+1)='detekt_eff             , 0.9 0.0 0.0 0.1'
       thpa(jp+2)='counts_bunch           , 1.0 0.0 0.0 0.1'
       thvr(jv+1)='detekt_eff                4     1 0 '
       thvr(jv+2)='counts_bunch              5     0 1 '
      jm=jm+1
      jp=jp+2
      jv=jv+2      

      call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end

