      subroutine th_11index(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'
c called by    stroboscopic transmission spectrum_3
c              stroboscopic reflection spectrum_3

      integer isubthe,icase,iput,iget,info,dstr,istr,idex,
     &        idum,nAS,idum1,nsampling,idum2,idum3
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),                                         !13.9.05 
     &              idum(3),nAS,idum1,nsampling,idum2,idum3,srw8,idex(7)      

      logical       b_vs,b_v_max,b_dumvsp
      common/bvstrf/b_vs(4),b_v_max,b_dumvsp(ivstrf-5)


      real          c1,gamnat,e_xsi,dumcm
      common/acmaps/c1,gamnat,e_xsi,dumcm(icstrf-3)
      real          avm,shift,dumvm         
      common/avmaps/avm(2),shift,dumvm(ivstrf-3)
      logical       b_vm,b_shift,b_dumvm
      common/bvmaps/b_vm(2),b_shift,b_dumvm(ivstrf-3)


      integer      i1,i2
      real         rtr,w_Lorentz,w_Gauss
      dimension    w_Lorentz(maxjge),w_Gauss(maxjge)
      dimension    rtr(maxjge)
      
      integer    idumscrd
      parameter (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real      sTr,dumscrd
      complex   cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)
      
      logical   b_pc,b_Gauss
      integer   iflag_Voigt,i,n,ni
      real      hti,srw
      complex   hc,hci

      if(isubthe.lt.0) then
       theoryname='1x1_ref_index_static     v=101'
       c1=2*(nAS+1)
       return
      end if


c     storage use n_sampling=1,2,4,8 for 4 complex numbers of r_ik

      hci=cmplx(0.,1.)
      iflag_Voigt=0

       call get_theory(isubthe,info)
       if(info.gt.0)return
c       write(6,'(a,2i4)') 'th_11refindex avsstrf 2 jge=',jge
c       write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz     

        b_pc=b_v_max.or.isubthe.ge.0.or.b_vm(1)
        if(.not.b_pc) then
         isubthe=-abs(isubthe)
         return
        end if  
        isubthe=abs(isubthe)

       i1=iget+1
       jge=real(array_fr(i1))
       i2=i1+jge
       do i=1,jge
        Eagd(i)=real(array_fr(i1+i))+shift
        rtr(i)=aimag(array_fr(i1+i))
        w_Gauss(i)=real(array_fr(i2+i))
        w_Lorentz(i)=aimag(array_fr(i2+i))
       end do
c       write(6,'(8f10.3)') (Eagd(i),i=1,jge)
c       write(6,'(8f10.3)') (rtr(i),i=1,jge)
       b_Gauss=.true.
c      b_trans=.true.



        do n=iput+1,iput+(nAS+1)*2
         array_fr(n)=(0.,0.)
        end do
        srw=srw8*float(nsampling)
        do i=1,jge
         if(rtr(i).gt.1.e-5) then
          call aLORGAU(Eagd(i),gamnat,e_xsi,
     &               srw,w_Lorentz(i),w_Gauss(i),nAS,iflag_Voigt)

c         write(6,'(a,3i5)')' nAS,iflag_Voigt=',nAS,iflag_Voigt,iput
c         write(6,'(6g12.4)') (cLG(j),j=-5,5),       
c     &          srw,gamnat,w_Lorentz(1),w_Gauss(1)     

          hti=rtr(i)/2.0
          do n=0,nAS
           ni=iput+2*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           hc=conjg(cLG(-n))
           array_fr(ni+2)=array_fr(ni+2)-hc*hti
          end do       ! n loop
         end if
        end do        ! i=1,jge
c       write(6,'(a,2i6)') ' theory9 - absorber,iput=',iput,nAS
c       write(6,'(6f12.6)') (aimag(array_fr(iput+n)),n=0,nAS,16)

      return
      end



