      subroutine th_11indexsad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      include 'comnuc.for'

c     sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)
      
      integer isubthe,icase,iput,iget,info,dstr,istr,idex,
     &        iduma,nAS,nSC,idum
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),iduma(3),                             !13.9.05 
     &              nAS,nSC,idum(3),srw8,idex(8)      

      logical       b_vs,b_v_max,b_dumvsp
      common/bvstrf/b_vs(4),b_v_max,b_dumvsp(ivstrf-5)


      real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumcm
      common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumcm(icstrf-5)
      real          avm,shift,dumvm         
      common/avmaps/avm(2),shift,dumvm(ivstrf-3)
      logical       b_vm,b_shift,b_dumvm
      common/bvmaps/b_vm(2),b_shift,b_dumvm(ivstrf-3)


      integer      i1,i2
      real         rtr,w_Lorentz,w_Gauss
      dimension    w_Lorentz(maxjge),w_Gauss(maxjge)
      dimension    rtr(maxjge)
      
      integer    idumscrd
      parameter (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real      sTr,dumscrd
      complex   cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)
      
      logical   b_pc,b_Gauss
      integer   iflag_Voigt,i,j,n,ni,sk2,nst
      real      hr,hi,hti,srw
      complex   hc,hci

      if(isubthe.lt.0) then
       theoryname='1x1_ref_index_static_sad       v=100'
       if(-isubthe.eq.1) then
        c1=2*(nSC+1)+1
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       end if
       if(-isubthe.eq.2) c1=2*(nAS+1)
       if(-isubthe.eq.3) c1=2*(nSC+1)
c       write(6,'(a,3i6,f12.2)')'th_11refindex :',-isubthe,nSC,nAS,c1      
       return
      end if
c      write(6,'(a,12f10.3)')'th_11refindex acmaps:',c1,gamnat
      
c     storage use nst2_8 for 4 complex numbers of r_ik
       
      hci=cmplx(0.,1.)
      iflag_Voigt=flag_Voigt
      nst=4

c     only line positions are taken
c       write(6,'(a,2i4)') 'th_11refindex avsstrf 1 jge=',jge
c       write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz      
       call get_theory(isubthe,info)
       if(info.gt.0) return
c       write(6,'(a,2i4)') 'th_11refindex avsstrf 2 jge=',jge
c       write(6,'(10f10.2)') avss,shift,fr_Gauss,fr_Lorentz     

        b_pc=b_v_max.or.isubthe.ge.0.or.b_vm(1)
        if(.not.b_pc) then
         isubthe=-abs(isubthe)
         goto 400
        end if  
        isubthe=abs(isubthe)

       i1=iget+1
       jge=real(array_fr(i1))
       i2=i1+jge
       do i=1,jge
        Eagd(i)=real(array_fr(i1+i))+shift
        rtr(i)=aimag(array_fr(i1+i))
        w_Gauss(i)=real(array_fr(i2+i))
        w_Lorentz(i)=aimag(array_fr(i2+i))
       end do
c       write(6,'(8f10.3)') (Eagd(i),i=1,jge)
c       write(6,'(8f10.3)') (rtr(i),i=1,jge)
       b_Gauss=.true.
      
       goto(100,200,300),lstr1case
c-------------------------------------------------------------
      
 100   continue
c      source
c       write(6,'(a,i7)') 'ch_case(1:6).eq.source iput=',iput
        do n=iput+1,iput+(nSC+1)*2
         array_fr(n)=(0.,0.)
        end do
      
        srw=4.0*srw8
        do i=1,jge
         call aLORGAU(Eagd(i),gamnat,e_xsi,
     &                  srw,w_Lorentz(i),w_Gauss(i),nSC,iflag_Voigt)
c        write(6,'(a,i2,i5,a,6f12.4)')'i,nSC=',i,nSC,
c     &  ' th_subrmoss gamnat,srw,w_Lorentz,w_Gauss=',
c     &    gamnat,srw,w_Lorentz(i),w_Gauss(i)

         do n=0,nSC
          ni=iput+2*n
          array_fr(ni+1)=array_fr(ni+1)+cmplx(0.,aimag(cLG(n))*rtr(i))
          array_fr(ni+2)=array_fr(ni+2)+cmplx(0.,aimag(cLG(-n))*rtr(i))
         end do       ! n loop
        end do        ! i=1,jge
      
c       write(6,'(a,2i6)') ' th_11ref - source, iput,nSC=',iput,nSC
c       write(6,'(4f15.6)') (rtr(i),i=1,jge)
c       write(6,'(6f12.6)') (aimag(array_fr(iput+i)),i=0,12)
      
c       The sum of the Lorentz-Gauss curves of the jge lines
c       have to be normalized to 1 for each subspectrum of the source
c       iscpi=iscpr+2*nSC+1
      
        do i=0,nSC
         ni=iput+2*i
         sTr(i)=aimag(array_fr(ni+1))
         sTr(-i)=aimag(array_fr(ni+2))
        end do
c        write(6,'(8f10.3)') (sTr(n),n=0,64)
      
c       write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',
c     &    sTr(i),sTr(-i),i=0,5)
      
        ni=iput+2*(nSC+1)+1
        if(nAS.lt.nSC) then
         sk2=nSC-nAS
         do i=0,sk2,2
          hr=0.
          hi=0.
          do j=-nAS+1,nAS-1,2
           hr=hr+ sTr(i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hr=hr+ sTr(i+j)
          end do
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i)
      
          do j=-nAS+1,nAS-1,2
           hi=hi+ sTr(-i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hi=hi+ sTr(-i+j)
          end do
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i)
          array_fr(ni+i/2)=cmplx(hr,hi)/3.
         end do
c       write(6,'(a,4i5)')'theomoss nAS,NSC,sk2=',nAS,NSC,sk2
c        write(6,'(8f10.3)') (array_fr(ni+i),i=0,sk2,16)
        else
         hr=0.
         do n=-nSC+1,nSC-1,2
          hr=hr+ sTr(n)*2
         end do
         do n=-nSC+2,nSC-2,2
          hr=hr+sTr(n)
         end do
         hr=hr*2.+ sTr(-nSC)+sTr(nSC)
         array_fr(ni)=cmplx(hr/3.,0.0)
c        write(6,'(a,i6,a,2f15.8)') '----th=',ni,' hr/3.=',hr/3.
        
        end if
        
        goto 400
c----------------------------------------------------------
 200    continue
c       absorber
        do n=iput+1,iput+(nAS+1)*2
         array_fr(n)=0.
        end do
        srw=srw8*float(nst)
        do i=1,jge
         if(rtr(i).gt.1.e-5) then
          call aLORGAU(Eagd(i),gamnat,e_xsi,
     &                 srw,w_Lorentz(i),w_Gauss(i),nAS,iflag_Voigt)
      
          hti=rtr(i)/2.0          ! ? donot remember why 30.6.05
          do n=0,nAS
           ni=iput+2*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           hc=conjg(cLG(-n))
           array_fr(ni+2)=array_fr(ni+2)-hc*hti
          end do       ! n loop
         end if
        end do        ! i=1,jge

c       write(6,'(a,2i6)') ' th_11ref - absorber, iput,nAS=',iput,nAS
c       write(6,'(4f15.6)') (rtr(i),i=1,jge)
c       write(6,'(6f12.6)') (aimag(array_fr(iput+i)),i=0,12)

       goto 400
c--------------------------------------------------------------
 300   continue
c       detector
      
        do n=iput+1,iput+(nSC+1)
         array_fr(n)=(0.,0.)
        end do
        do i=1,jge
         call aLORGAU(Eagd(i),gamnat,e_xsi,
     &                  srw8,w_Lorentz(i),w_Gauss(i),nSC,iflag_Voigt)
         do n=0,nSC
          ni=iput+n+1
          array_fr(ni)=array_fr(ni)+
     &     cmplx(aimag(cLG(n)),aimag(cLG(-n)))*rtr(i)
         end do       ! n loop
        end do     ! i=1,jge
      
 400   return
        end



      subroutine th_relaxglobalsad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

c     sad= source,absorber,detector : lstr1case=1,2,3  (comthe.for) 
      
      integer isubthe,icase,iput,iget,info,istr,dstr,idex,
     &        idum,nLG,nAS,nSC,nsampling,ak8,sk8,nRL
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)
      common/struct/dstr(istr),idum(2),                      !13.9.05 
     &              nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,idex(7)    

      integer     mAS,idumscrd
      parameter  (mAS=2*maxn,idumscrd=maxscrd-4*(mAS+1))
      real        sTr,yyr,dumscrd
      common/scrd/sTr(-mAS:mAS+1),yyr(-mAS:mAS+1),dumscrd(idumscrd)
      
      real      ym0,ym1,yp1,yp2,as,bs,cs,hr,hi
      integer   i,i1,j,n,ni,sk2
      logical   b_pc

      real          avm,dumvm
      common/avmaps/avm(10),dumvm(ivstrf-10)
      real          c1,dumc
      common/acmaps/c1,dumc(ivstrf-1)
 
      if(isubthe.lt.0) then
       theoryname='1x1_ref_index_dynamic_sad'
c      if(ak2.gt.sk2) then
c       nAS=sk2+ak2+ib2
c       nSC=sk2+ib2
c      else
c       nSC=sk2+ak2+ib2
c       nAS=ak2+ib2
c      end if
       if(-isubthe.eq.1) then
        c1=2*(nSC+1)+1
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       end if
       if(-isubthe.eq.2) c1=2*(nAS+1)
       if(-isubthe.eq.3) c1=2*(nSC+1)
       return
      end if

c     storage use nst2_8 for 4 complex numbers of r_ik
       idex(1)=icase      
       goto(100,200,100),lstr1case
c-------------------------------------------------------------
      
 100   continue
c      source,detector

c      srw=4.0*srw8
c      half srw for convolution
c      calculation with 4*srw and interpolation for the slow subroutines
c      nRL half number of channels

       if(icase.eq.1) then
        nRL=nSC/4
       else
        nRL=nSC
       end if 
       call get_theory(isubthe,info)

       b_pc=isubthe.gt.0
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

      
       i1=iget+1
       if(icase.eq.1)then 
        do n=0,nRL+1
         yyr(n)=real(array_fr(i1+n))
         yyr(-n)=aimag(array_fr(i1+n))
        end do
        do n=-nRL,nRL-1
c        h=f(yyr(n/4-1),yyr(n/4),yyr(n/4+1))
         ym0=yyr(n) 
         yp2=yyr(n+2)-ym0
         yp1=yyr(n+1)-ym0
         ym1=yyr(n-1)-ym0
         
         as=(yp2-3.0*yp1-ym1)/24.0
         bs=(ym1+yp1)/8.0
         cs=-(yp2-6.0*yp1+2.0*ym1)/24.0

         sTr(4*n)=ym0
         sTr(4*n+1)=ym0+     as+    bs+    cs
         sTr(4*n+2)=ym0+ 8.0*as+4.0*bs+2.0*cs
         sTr(4*n+3)=ym0+27.0*as+9.0*bs+3.0*cs
        end do       ! n loop
        sTr(4*nRL)=yyr(nRL)
       else
        do n=0,nRL
         sTr(n)=real(array_fr(i1+n))
         sTr(-n)=aimag(array_fr(i1+n))
        end do
       end if
       do n=0,nSC
        ni=iput+2*n
        array_fr(ni+1)=cmplx(0.0,sTr(n))
        array_fr(ni+2)=cmplx(0.0,sTr(-n))
       end do       ! n loop
c       write(6,'(8f10.3)') (sTr(n),n=0,64)
      
c       The sum of the Lorentz-Gauss curves of the jge lines
c       have to be normalized to 1 for each subspectrum of the source
c       iscpi=iscpr+2*nSC+1
      
      
        ni=iput+2*(nSC+1)+1
        if(nAS.lt.nSC) then
         sk2=nSC-nAS
         do i=0,sk2,2
          hr=0.
          hi=0.
          do j=-nAS+1,nAS-1,2
           hr=hr+ sTr(i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hr=hr+ sTr(i+j)
          end do
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i)
      
          do j=-nAS+1,nAS-1,2
           hi=hi+ sTr(-i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hi=hi+ sTr(-i+j)
          end do
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i)
          array_fr(ni+i/2)=cmplx(hr,hi)/3.
         end do
c       write(6,'(a,4i5)')'theomoss nAS,NSC,sk2=',nAS,NSC,sk2
c       write(6,'(8f10.3)') (array_fr(iscn+i),i=0,sk2,16)
        else
         hr=0.
         do n=-nSC+1,nSC-1,2
          hr=hr+ sTr(n)*2
         end do
         do n=-nSC+2,nSC-2,2
          hr=hr+sTr(n)
         end do
         hr=hr*2.+ sTr(-nSC)+sTr(nSC)
         array_fr(ni)=cmplx(hr/3.,0.0)
c        write(6,'(a,i6,a,2f15.8)') '----th=',ni,' hr/3.=',hr/3.
c        write(6,'(a,i6,2f15.8)') 'isource_sp snorm:i=',
c    &      isource_sp,array_fr(isource_sp+1)
        end if
        goto 400
c----------------------------------------------------------
 200    continue
c       absorber
c       srw=4.0*srw8
c       half srw for convolution
c       calculation with 4*srw and interpolation for the slow subroutines
c       nRL half number of channels
c       write(6,'(a,2i4)') 'th_mossrelax avmap 1 '
c       write(6,'(10f10.2)')avm

        if(icase.eq.1) then
         nRL=nAS/4
        else
         nRL=nAS
        end if 
        call get_theory(isubthe,info)
c       write(6,'(a,2i4)') 'th_mossrelax avmap 2 '
c       write(6,'(10f10.2)')avm

       b_pc=isubthe.gt.0
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

      
       i1=iget+1
       if(icase.eq.1) then
        do n=0,nRL+1
         yyr(n)=real(array_fr(i1+n))
         yyr(-n)=aimag(array_fr(i1+n))
        end do
c        write(6,'(a)') 'yyr='
c        write(6,'(8f10.3)')(yyr(i),i=-nRL,nRL)
        do n=-nRL,nRL-1
c        h=f(yyr(n/4-1),yyr(n/4),yyr(n/4+1))
         ym0=yyr(n) 
         yp2=yyr(n+2)-ym0
         yp1=yyr(n+1)-ym0
         ym1=yyr(n-1)-ym0
         
         as=(yp2-3.0*yp1-ym1)/24.0
         bs=(ym1+yp1)/8.0
         cs=-(yp2-6.0*yp1+2.0*ym1)/24.0

         sTr(4*n)=ym0
         sTr(4*n+1)=ym0+     as+    bs+    cs
         sTr(4*n+2)=ym0+ 8.0*as+4.0*bs+2.0*cs
         sTr(4*n+3)=ym0+27.0*as+9.0*bs+3.0*cs
c        write(6,'(i4,4f12.4)')4*n,ym0,sTr(4*n+1),sTr(4*n+2),sTr(4*n+3)
        end do       ! n loop
        sTr(4*nRL)=yyr(nRL)
       else
        do n=0,nRL
         sTr(n)=real(array_fr(i1+n))
         sTr(-n)=aimag(array_fr(i1+n))
        end do
       end if
       do n=0,nAS
        ni=iput+2*n
        array_fr(ni+1)=cmplx(0.0,sTr(n))
        array_fr(ni+2)=cmplx(0.0,sTr(-n))
       end do       ! n loop
      

c       write(6,'(a,2i6)') ' theory3 - absorber,iput=',iput,nAS
      
 400   continue
c        write(6,'(8f10.3)') (sTr(n)*1000.0,n=0,64)

        return
        end
      subroutine th_relaxspinhalfsad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

c     sad= source,absorber,detector 
      
      integer isubthe,icase,iput,iget,info,istr,dstr,idex,
     &        idum,nLG,nAS,nSC,nsampling,ak8,sk8,nRL
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)           
      common/struct/dstr(istr),idum(2),                            !13.9.05 
     &              nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,idex(7)      

      logical         b_vfr1trf
      common/bvfr1trf/b_vfr1trf(ivfr1trf)
      
      real          avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p,dumvssp
c     &             ax,ay,az,gx,gy,gz
c     &             dl,eod,cube,fort,AL,BE,GA
      common/avmaps/avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p(7),
     &              dumvssp(ivstrf-14)
      logical       b_vm,b_Lwidth,b_matrix,
     &              b_iso,b_h0,b_dq,b_eta,b_gml,b_p,b_dumvssp
      common/bvmaps/b_vm,b_Lwidth,b_iso,b_h0,b_dq,b_eta,b_gml,b_p(7),
     &              b_dumvssp(ivstrf-14)
      
      real          c1,gamnat,e_xsi,aiset,aisym,temperature,dumc
      common/acmaps/c1,gamnat,e_xsi,aiset,aisym,temperature,
     &              dumc(icstrf-6)
      logical       b_c1,b_dumc,b_pc
      common/bcmaps/b_c1,b_dumc(icstrf-1)      
c     if one of the  constants changed the value all logical are .true.
c     nuclear parameters are not used. Problem is solved only for iron57.

c--------------------------------------------------------------------
      real*8 dq,eta,gml,ax,ay,az,a_hyp,orf,
     *       dl,eod,cube,fort,AL,BE,GA,te,dl21,dl31,dl32,rom,
     &       gx3(3),gy3(3),gz3(3),ax3(3),ay3(3),az3(3),
     &       eq3(3),qx3(3),qy3(3),qz3(3),eta3(3),
     *       crys(3,3),ct(3,3),cti(3,3),cl(3,3),cli(3,3),
     &       cr(3),cri(3),aw(3),bw(3),cw(3)
      real*8 dtheta,dphi,zero,one,two,three,pt5,
     &       pi,pi2,gwidth,w,exp21,exp31,
     &       vxx,vxy,vxz,vyz,vyy,vzz,qxx,qyy,qzz

c--------------------------------------------------------------------
      integer    mAS,isym,iset,nm,nm2,idumscrd,iepk
      parameter (nm=48,nm2=96,mAS=2*maxn,
     &           idumscrd=maxscrd-2*(mAS+1)-6144*3-128*3-9*24-
     &                    13*256-nm*nm*2*6-256-5*nm*2-2*nm2*nm2-7*nm2)
      real sTr,phi,theta,psiOM,weight,pwr,pwi,wrs,wis,h,h1,h2,
     &     eh,mat,dumscrd
      real*8 hf,r,t,u,tl,ul,epk1,epk2,epk3,epk4,epk55,
     &       h11,h22,h33,wr,wi
      complex*16 d,dsum,vl1,vl2,vl3,vl4,vl5,vl6,
     &                  vr1,vr2,vr3,vr4,vr5,vr6,pw,hc,z
      common/scrd/sTr(-mAS:mAS+1), 
     &           phi(6144),theta(6144),psiOM(6144),
     &           d(8,8),dsum(8,8),wr(nm),wi(nm),
     &           pwr(nm),pwi(nm),wrs(nm),wis(nm),pw(nm),
     &           vl1(8,8),vl2(8,8),vl3(8,8),vl4(8,8),
     &           vl5(8,8),vl6(8,8),vr1(8,8),vr2(8,8),
     &           vr3(8,8),vr4(8,8),vr5(8,8),vr6(8,8),
     &           hf(nm,nm),r(nm,nm),t(nm,nm),u(nm,nm),
     &           tl(nm,nm),ul(nm,nm),epk1(nm),epk2(nm),
     &           epk3(nm),epk4(nm2),epk55(nm2,nm2),iepk(nm2),
     &           eh(3,128),mat(3,3,24),dumscrd(idumscrd)      
c                eh(3,128),mat(3,3,24) is used inside sphere()

      integer    nop,npoints,ipoint,i,i1,j,j1,k,l,n
      parameter( zero=0.d0, one=1.d0, two=2.d0,three=3.d0,pt5=0.5d0)
      real dw

      if(isubthe.lt.0) then
       theoryname='spin_half_refindex_dynamic'
c      if(ak2.gt.sk2) then
c       nAS=sk2+ak2+ib2
c       nSC=sk2+ib2
c      else
c       nSC=sk2+ak2+ib2
c       nAS=ak2+ib2
c      end if
c       D2 symmetry 6, D3 symmetry 4 out of 48 
       iset=3
       npoints=6*2**(iset+1) 
       if(icase.eq.1) then
        n=1+npoints+16*2*npoints       ! storage for relaxation matrices
       else
        n=1+npoints+48*2*npoints       ! storage for relaxation matrices
       end if                               ! and theta,phi
       if(-isubthe.eq.1) then
        c1=2*(nSC+1)+3+n
        if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       end if
       if(-isubthe.eq.2) c1=2*(nAS+1)+2+n
       if(-isubthe.eq.3) c1=2*(nSC+1)+2+n
       return
      end if

c      write(6,'(a,6f12.3)')' acmaps=',c1,aiset,aisym,temperature,gamnat
      
       b_pc=b_vm
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

c       write(6,'(a,2i5)') 'th_mossrelax avmaps:: nRL=',nRL
c       write(6,'(10f10.2)')avm,a_Lwidth,a_iso,a_h0,a_dq,a_eta,a_gml,a_p

      isym=aisym
      iset=aiset
      nop=nRL+1
      if(idex(1).eq.2) then
       dw=4.0*srw8
      else
       dw=16.0*srw8
      end if
c      write(6,'(a,i4,2f12.3)')'th-mossrelax nop,dw=',nop,dw
c     write(6,'(a,4i4)')'th-mossrelax  isym,iset=',isym,iset

      b_matrix=b_h0.or.b_dq.or.b_eta.or.b_gml
      do k=1,7
       b_matrix=b_matrix.or.b_p(k)
      end do


c      subroutine sphere(iset,isym,iOM,tetah,phih)
c      parameter (niset=128*24)
c      dimension wh4(8),wh8(16),wh16(32),wh32(64),wh64(128),wh128(256),
c     &          eh(3,128),tetah(niset),phih(niset),hmat(3,3)

c     symmetry of the hamiltonian (subgroup of O)
c      data  nd4/1,5,8/                          ! D4 (C4 || z-axis)
c      data  nd2/1,2,5,8,17,18/                  ! D2
c      data  nc2/1,2,3,4,5,7,8,13,17,18,19,22/   ! C2 (z-axis)
c      data  nd3/1,2,3,4/                        ! D3 (C3 || {111}=z-axis)  
c      data nc2y/1,2,3,4,5,7,8,10,13,14,15,16/   ! c2 (y-axis)
      
c     Directions  whi(teta,phi)  for the integration
c     over the sphere.
c     Optimized values are calculated by K. Knese and H. Spiering

c     definition of isym (spezified by the calling routine):
c     C4 || z-axis                     C3 || z-axis
c     cubic    isym=11                 cubic     isym=21
c     D4       isym=12                 D3             22
c     D2            13                 C2             23
c     C2            14                 C1             24
c     C1            15                

c     iOM  (i-Omega) number of points, equal weights  dOM=1./iOM

c     np: number of points on 1/48 sphere,  np=2**(iset+1)
c       iset=3
c       npoints=6*2**(iset+1) 
c       n=1+npoints+16*2*npoints       ! storage for relaxation matrices

      i1=iput+1+nop+1
      if(b_c1) then
       if (isym.gt.0) then
        call sphere(iset,isym,.false.,npoints,phi,theta,psiOM,eh,mat)

c        call sphere(iset,isym,npoints,theta,phi) 
c       write(6,'(8f10.4)')(theta(i),phi(i),i=1,npoints)
        if(npoints.gt.96) then
c        i=npoints/2**(iset+1)
         i=96*2**(iset+1)/npoints/2
         iset=-1
         do while(i.gt.0)
          i=i/2    
          iset=iset+1 
         end do
        call sphere(iset,isym,.false.,npoints,phi,theta,psiOM,eh,mat)
c         call sphere(iset,isym,npoints,theta,phi) 
         write(nwr,'(a,i2)') '**warning** iset is reduced to ',iset
        end if
       else
        npoints=1
        theta(1)=0.0
        phi(1)=0.0
       end if
       weight=dw/6.28318/npoints
c       write(6,'(a,2i6,g12.5)') 'theomoss3 i1,npoints,weight=',
c     &                i1,npoints,weight
       array_fr(i1) =cmplx(float(npoints),weight)
       do ipoint=1,npoints
        array_fr(i1+ipoint) =cmplx(theta(ipoint),phi(ipoint))
       end do
      else
       npoints=real(array_fr(i1))
       weight=aimag(array_fr(i1))
c       write(6,'(a,2i6)') 'theomoss3 i1,npoints=',i1,npoints
c       write(6,'(8f10.4)')(array_fr(i1+i),i=1,npoints)
       do ipoint=1,npoints
        theta(ipoint)=real(array_fr(i1+ipoint))
        phi(ipoint)=aimag(array_fr(i1+ipoint))
       end do
      end if 

       a_hyp= dble(a_h0)        ! hyperfine splitting, mm/s
       dq= dble(a_dq)           ! quadrupole splitting, mm/s
       eta=dble(a_eta)          ! quadrupole assymetry
       gml=dble(a_gml)          ! relaxation rate, mm/s (*11.625 MHz)
       gwidth=pt5*dble(gamnat*(1.0+a_Lwidth))    ! linewidth, mm/s

       pi    = 3.14159265358979324
       pi2=  pt5*pi     

c       write(6,'(a,5g10.3)')'a_hyp,dq,eta,gml,gwidth=',
c     &                       a_hyp,dq,eta,gml,gwidth
       do i=-nop,nop
        sTr(i)=0.0
       end do


      if(b_matrix) then
       goto (100,100,200),icase

 100   continue        ! S=1/2 Kramers doublet
       if(icase.eq.1) then
       do i=1,3
        gx3(i)=zero
        gy3(i)=zero
        gz3(i)=zero
        aw(i)=zero
        bw(i)=zero
        cw(i)=zero
       end do
        ax= dble(a_p(1))         ! A-tensor
        ay= dble(a_p(2)) 
        az= dble(a_p(3)) 
        gx3(1)=dble(a_p(4))      ! g-tensor
        gy3(1)=dble(a_p(5)) 
        gz3(1)=dble(a_p(6))

c       write(6,'(a,6g12.5)')'ax,ay,az,gx,gy,gz=',
c     &                       ax,ay,az,gx3(1),gy3(1),gz3(1)
c       CALCULATION OF THE QUADRUPOLE TENSOR
        qzz=dq*pt5/dsqrt(one+eta**2/three)
        qxx=pt5*qzz*(eta-one)                                      
        qyy=-qxx-qzz                                               

       else
c       CALCULATE CRYSTAL FIELD HAMILTONIAN, GRIFFITH
        dl=dble(a_p(1))
        rom=dble(a_p(2)) 
        call split(dl,rom,crys)
        n=3
        call diag(crys,ct,cti,cl,cli,
     &          n,hf,r,wr,wi,t,u,tl,ul,
     &          epk1,epk2,epk3,epk4,epk55,iepk)

c        write(6,'(/,a)')'t'
c        write(6,'(16g8.2)')((t(i,k),k=1,n),i=1,n)      
c        write(6,'(/,a)')'u'
c        write(6,'(16g8.2)')((u(i,k),k=1,n),i=1,n)      

        do i=1,3
         cr(i)=wr(i)
         cri(i)=wi(i)
        end do
        call  sort(cr,cri,ct,cti,dl21,dl31,dl32)
 
        orf=1.d0
        call sptensor(ct,orf,gx3,gy3,gz3,ax3,ay3,az3,qx3,qy3,qz3,eta3)
        do i=1,3
         eq3(i)=dq*pt5/sqrt(qz3(i)**2+(qx3(i)-qy3(i))**2/three)
         qx3(i)=qx3(i)*eq3(i)
         qy3(i)=qy3(i)*eq3(i)
         qz3(i)=qz3(i)*eq3(i)
        enddo
        ax=ax3(1)
        ay=ay3(1)
        az=az3(1)
        qzz=qz3(1)
        qxx=qx3(1)
        qyy=-qxx-qzz                                               
       end if
c       write(6,'(a,6g12.5)')'ax,ay,az,gx,gy,gz=',
c     &                       ax,ay,az,gx3(1),gy3(1),gz3(1)

c      THIS SUBROUTINE CALCULATES Q-TENSOR IN  THE CASE OF PAS ROTATION
c      VS. MOLECULAR SYSTEM. THE ROTATION ANGLES ALFA, BETA,GAMMA SHOULD 
c      BE GIVEN THEN IN THE INPUT FILE
      
c      alfa=zero    !Euler angles 
c      beta=zero
c      gamma=zero

       call tens(qxx,qyy,qzz,zero,zero,zero,
     *                    vxx,vyy,vzz,vxy,vxz,vyz)  

c       write(6,*) 'vii',vxx,vyy,vzz,vxy,vxz,vyz

c      POWDER AVERAGING 

       i1=iput+1+nop+1+npoints
       do ipoint=1,npoints                               
c        write(6,'(a,2f10.4)')'theta,phi=',theta(ipoint),phi(ipoint)
        j1=i1+(ipoint-1)*32


c       CALCULATION OF THE INTENSITY MATRIX OF NUCLEAR TRANSITIONS   

c       EXTERNAL MAGNETIC FIELD IS PERPENDICULAR TO THE GAMMA-BEAM
c       two direction for the average in the plane 

        dtheta=dble(theta(ipoint))+pi2
        dphi=dble(phi(ipoint))
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=d(i,k)
         end do
        end do

        dtheta=pi2
        dphi=dble(phi(ipoint))+pi2
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=dsum(i,k)+d(i,k)
         end do
        end do
        dtheta=dble(theta(ipoint))
        dphi=dble(phi(ipoint))

        n=16
c ------------------------------------------------------
        call relax(dtheta,dphi,gx3,gy3,gz3,ax,ay,az,a_hyp,
     &             aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,
     &             n,hf,r,wr,wi,t,u,tl,ul,
     &             epk1,epk2,epk3,epk4,epk55,iepk,
     &             vl1,vl2,vl3,vl4,vl5,vl6,
     &             vr1,vr2,vr3,vr4,vr5,vr6)
c -----------------------------        

c        write(6,'(a)')'((vl1(i,k)),k=1,8),i=1,8)' 
c        write(6,'(8g10.2)')((dreal(vl1(i,k)),k=1,8),i=1,8) 
c        write(6,'(8g10.2)')((dimag(vl1(i,k)),k=1,8),i=1,8) 
     
c        write(6,'(a)')'((vr2(i,k)),k=1,8),i=1,8)' 
c        write(6,'(8g10.2)')((dreal(vl2(i,k)),k=1,8),i=1,8) 
c        write(6,'(8g10.2)')((dimag(vl2(i,k)),k=1,8),i=1,8) 

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr1(l,i)
          end do
          z=z+hc*vl1(i,k)
         end do
         pw(i)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr2(l,i)
          end do
          z=z+hc*vl2(i,k)
         end do
         pw(i+8)=z*0.75d0
        end do
        
c        z=(0.,0.)
c        do k=1,16
c         z=z+pw(k)
c        end do

c        write(6,'(a,2g12.5)') ' wr,wi='
c        write(6,'(8g10.2)')(wr(k),k=1,n) 
c        write(6,'(8g10.2)')(wi(k),k=1,n) 
c        write(6,'(a,2g10.3)')' pw=',z
c        write(6,'(8g10.2)')(dreal(pw(i)),i=1,n)
c        write(6,'(8g10.2)')(dimag(pw(i)),i=1,n)

c        CALCULATION OF THE SPECTRUM ITSELF
        do j=1,n
         wrs(j)=sngl(wr(j))
         wis(j)=sngl(wi(j))
         pwr(j)=sngl(dreal(pw(j)))
         pwi(j)=sngl(dimag(pw(j)))
        end do

        do i=1,n
         array_fr(j1+i)=cmplx(wrs(i),wis(i))
        end do
        j=j1+n
        do i=1,n
         array_fr(j+i)=cmplx(pwr(i),pwi(i))
        end do

        do i=-nop,nop
         w=dw*float(i)-a_iso
         h=0.0
         do j=1,n
          h1=w-wrs(j)
          h2=gwidth-wis(j)
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2)
         end do
         sTr(i)=sTr(i)+h*weight
        end do

       end do   ! ipoint
       goto 300

 200   continue        ! S=5/2 3 Kramers doublets

       dl  = dble(a_p(1))        !D
       eod = dble(a_p(2))        !E/D
       cube= dble(a_p(3))         !a
       fort= dble(a_p(4))         !F
       AL  = dble(a_p(5))       !
       BE  = dble(a_p(6))       ! EULER ANGLES
       GA  = dble(a_p(7))       !
       rom   = eod*dl

C      CALCULATION OF THE ZERO-FIELD HAMILTONIAN
       call splith(dl,rom,cube,fort,crys)

       n=3
       call diag(crys,ct,cti,cl,cli,
     &          n,hf,r,wr,wi,t,u,tl,ul,
     &          epk1,epk2,epk3,epk4,epk55,iepk)
      
       do i=1,3
        cr(i)=wr(i)
        cri(i)=wi(i)
       end do
 
C      ORDERING OF THE ZERO-FIELD DOUBLETS IN ASCENDING ORDER 
C      AND CALCULATION OF THE ENERGY INTERVALS BETWEEN THE DOUBLETS 

       call  sort(cr,cri,ct,cti,dl21,dl31,dl32)	
c      write(6,*)'E(1),E(2),E(3)'
c      write(6,*) cri(1),cri(2),cri(3) 
c      write(6,*)'dl21,dl31,dl32'
c      write(6,*)dl21,dl31,dl32 

       do i=1,3
        gx3(i)=zero
        gy3(i)=zero
        gz3(i)=zero
        aw(i)=zero
        bw(i)=zero
        cw(i)=zero
       end do

C      CALCULATION OF THE G-TENSORS OF ALL KRAMERS DOUBLETS
       call tenshs(cti,gx3,gy3,gz3,aw,bw,cw)

c      write(6,*)'gx3,gy3,gz3'
c      do i=1,3
c      write(6,*) i,abs(gx3(i)),abs(gy3(i)),abs(gz3(i))
c      enddo

C      BOLTZMANN POPULATION    
       te=dble(0.695*temperature)
       exp21=exp(-dl21/te)
       exp31=exp(-dl31/te)
       h11=1.d0/(1.d0+exp21+exp31)
       h22=exp21*h11
       h33=exp31*h11

c      CALCULATION OF THE QUADRUPOLE TENSOR

       qzz=dq*pt5/dsqrt(one+eta**2/three)
       qxx=pt5*qzz*(eta-one)                                      
       qyy=-qxx-qzz                                               

c      THIS SUBROUTINE CALCULATES Q-TENSOR IN  THE CASE OF PAS ROTATION
c      VS. MOLECULAR SYSTEM. THE ROTATION ANGLES ALFA, BETA,GAMMA SHOULD 
c      BE GIVEN THEN IN THE INPUT FILE
      
       call tens(qxx,qyy,qzz,AL,BE,GA,
     *                    vxx,vyy,vzz,vxy,vxz,vyz)  
c      write(nout,*) 'vii',vxx,vyy,vzz,vxy,vxz,vyz


c      POWDER AVERAGING 

       i1=iput+1+nop+1+npoints
       do ipoint=1,npoints                               
c        write(6,'(a,2f10.4)')'theta,phi=',theta(ipoint),phi(ipoint)
        j1=i1+(ipoint-1)*96


c       CALCULATION OF THE INTENSITY MATRIX OF NUCLEAR TRANSITIONS   

c       EXTERNAL MAGNETIC FIELD IS PERPENDICULAR TO THE GAMMA-BEAM
c       two direction for the average in the plane 
        dtheta=dble(theta(ipoint))+pi2
        dphi=dble(phi(ipoint))
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=d(i,k)
         end do
        end do

        dtheta=pi2
        dphi=dble(phi(ipoint))+pi2
        call dddd(dtheta,dphi,d)
        do i=1,8
         do k=1,8
          dsum(i,k)=dsum(i,k)+d(i,k)
         end do
        end do

        dtheta=dble(theta(ipoint))
        dphi=dble(phi(ipoint))
        n=48
c ------------------------------------------------------
        call relax(dtheta,dphi,gx3,gy3,gz3,h11,h22,h33,a_hyp,
     &             aw,bw,cw,vxx,vyy,vzz,vxy,vxz,vyz,gml,
     &             n,hf,r,wr,wi,t,u,tl,ul,
     &             epk1,epk2,epk3,epk4,epk55,iepk,
     &             vl1,vl2,vl3,vl4,vl5,vl6,
     &             vr1,vr2,vr3,vr4,vr5,vr6)
c -----------------------------        

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr1(l,i)
          end do
          z=z+hc*vl1(i,k)
         end do
         pw(i)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr2(l,i)
          end do
          z=z+hc*vl2(i,k)
         end do
         pw(i+8)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr3(l,i)
          end do
          z=z+hc*vl3(i,k)
         end do
         pw(i+16)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr4(l,i)
          end do
          z=z+hc*vl4(i,k)
         end do
         pw(i+24)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr5(l,i)
          end do
          z=z+hc*vl5(i,k)
         end do
         pw(i+32)=z*0.75d0
        end do

        do i=1,8
         z=zero
         do k=1,8
          hc=zero
          do l=1,8
           hc=hc+dsum(k,l)*vr6(l,i)
          end do
          z=z+hc*vl6(i,k)
         end do
         pw(i+40)=z*0.75d0
        end do

c        hc=(0.0,0.0)
c        do k=1,n
c         hc=hc+pw(k)
c        end do
c        write(6,'(a,2g12.5)') ' sum pw=',hc
c        write(6,'(8g10.2)')(real(pw(k)),k=1,48) 
c        write(6,'(8g10.2)')(dimag(pw(k)),k=1,48) 

c       CALCULATION OF THE SPECTRUM ITSELF
        do j=1,n
         wrs(j)=sngl(wr(j))
         wis(j)=sngl(wi(j))
         pwr(j)=sngl(dreal(pw(j)))
         pwi(j)=sngl(dimag(pw(j)))
        end do

        do i=1,n
         array_fr(j1+i)=cmplx(wrs(i),wis(i))
        end do
        j=j1+n
        do i=1,n
         array_fr(j+i)=cmplx(pwr(i),pwi(i))
        end do

        do i=-nop,nop
         w=dw*float(i)-a_iso
         h=0.0
         do j=1,n
          h1=w-wrs(j)
          h2=gwidth-wis(j)
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2)
         end do
         sTr(i)=sTr(i)+h*weight
        end do

       end do  ! ipoint loop
 300   continue

      else   
c      take aa,bb,pwi,wrs,weight from array_fr

       do i=-nop,nop
        sTr(i)=0.0
       end do
       if(icase.eq.1) n=16
       if(icase.eq.2) n=48
        
       i1=iput+1+nop+1+npoints
       do ipoint=1,npoints
        j1=i1+(ipoint-1)*2*n
        do i=1,n
         wrs(i)=real(array_fr(j1+i))
         wis(i)=aimag(array_fr(j1+i))
        end do
        j=j1+n
        do i=1,n
         pwr(i)=real(array_fr(j+i))
         pwi(i)=aimag(array_fr(j+i))
        end do
        do i=-nop,nop
         w=dw*float(i)-a_iso
         h=0.0
         do j=1,n
          h1=w-wrs(j)
          h2=gwidth-wis(j)
          h=h+(pwr(j)*h2-pwi(j)*h1)/(h1**2+h2**2)
         end do
         sTr(i)=sTr(i)+h*weight
        end do

       end do   ! ipoint loop
      end if

c      h=0.0
c      do i=-nop,nop
c       h=h+sTr(i)
c      end do
c      write(6,'(i5,a,f12.4)') nop,'Sum sTr=',h
c      write(6,'(8f10.5)')(sTr(i),i=-nop,nop)

c-----------------------------------------------------------------
      i1=iput+1
      do n=0,nop
       array_fr(i1+n)=cmplx(sTr(n),sTr(-n))
      end do

      return     
      end


      subroutine th_relaxtwostatesad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'

c     sad= source,absorber,detector 
      
      integer isubthe,icase,iput,iget,info,istr,dstr,idex,
     &        idum,nLG,nAS,nSC,nsampling,ak8,sk8,nRL
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+16)           
      common/struct/dstr(istr),idum(2),                            !13.9.05 
     &              nLG,nAS,nSC,nsampling,ak8,sk8,srw8,nRL,idex(7)      
      real            avfr1,dfr1,B_ext,dumfr1
      common/avfr1trf/avfr1,dfr1,B_ext,dumfr1(ivfr1trf-3)
      logical         b_vfr1trf
      common/bvfr1trf/b_vfr1trf(ivfr1trf)
      real            acfr2,unufr2,temperature,dumfr2
      common/acfr2trf/acfr2,unufr2(4),temperature,dumfr2(ivfr2trf-6)

      real          avm,a_iso,hz1,hz2,dq,t_rate,popmom,forMofT,ai0,
     &              dumvssp
      common/avmaps/avm,a_iso,hz1,hz2,dq,t_rate,popmom,forMofT,ai0,
     &              dumvssp(ivstrf-9)
      logical       b_vm,b_dumvssp
      common/bvmaps/b_vm,b_dumvssp(ivstrf-1)
      
      real          c1,gamnat,e_xsi,cTms,ajg,aje,amueg,amuee,QgdQe,
     &              E2dM1,e1m1,Treference,dumc
      common/acmaps/c1,gamnat,e_xsi,cTms,ajg,aje,amueg,amuee,QgdQe,
     &              E2dM1,e1m1,Treference,dumc(icstrf-12)
      logical       b_c1,b_dumc,b_pc
      common/bcmaps/b_c1,b_dumc(icstrf-1)      
c     if one of the  constants changed the value all logical are .true.
c     nuclear parameters are not used. Problem is solved only for iron57.

c--------------------------------------------------------------------
      integer     mAS,idumscrd
      real        sTr,yyr,pi,dumscrd
      parameter  (mAS=2*maxn,idumscrd=maxscrd-4*(mAS+1),pi=3.141593)
      common/scrd/sTr(-mAS:mAS+1),yyr(-mAS:mAS+1),dumscrd(idumscrd)
      integer nop,je,jg,me,mg,n,i1
      real h,ug,ue,de1,de2,qh,qe,qg,ra11,ra22,ai,gam,
     &     pi12,pi21,dw,clebsch,popr,dipole_T,hz1_T,hz2_T,fT
      complex*8 a11,a22,aint,denom

      if(isubthe.lt.0) then
       theoryname='two_state_refindex_dynamic_pert'
       c1=2*(nSC+1)+3
       if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
       return
      end if

c      write(6,'(a,6f12.4)')'avfr1,dfr1,B_ext,dumfr1=',
c     &          avfr1,dfr1,B_ext,dumfr1(1),dumfr1(2),dumfr1(3)

       b_pc=b_vm.or.b_vfr1trf(1)
       if(.not.b_pc) then
        isubthe=-abs(isubthe)
        return
       end if

       if(icase.eq.1)then
        popr=popmom 
        hz1_T=hz1
        hz2_T=hz2
       else
        if(temperature.le.0.) then
         info=1
         infotext(1)=' '
         infotext(2)='temperature has zero value (not included)'
         infotext(3)='set up: include constant temperature for  ... [y]'  
         infotext(3)=' '
         return
        end if
        fT=1.0+forMofT*
     &      (1.0-((temperature-Treference)/(300-Treference))**2)
        hz1_T=hz1*fT
        hz2_T=hz2*fT
        dipole_T=(hz1_T+hz2_T)/2.0
        popr=exp(2.*popmom*(B_ext+dipole_T)/temperature)
c        write(6,'(a,6f12.4)')'fT, popr,t_rate,H1,2=',fT,popr,t_rate,
c     &               hz1_T+B_ext,hz2_T+B_ext
       end if
c       0.0467 *B[kG]cm**-1 ; 0.695*T cm**-1 ; 2.24^=10**4 mu-Bohr*1kG/300K

       nop=nRL+1
       ug=amueg/ajg/cTms/2.
       ue=amuee/aje/cTms/2.
       jg=2.*ajg+0.001
       je=2.*aje+0.001
       gam=popr/(1.0+popr)     !     gam=pop1, 1-gam=pop2
       pi12=(1.-gam)*t_rate    !     t_rate=pi12+pi21
       pi21=gam*t_rate
c       write(6,'(a,2f10.3)')' pi12,pi21=',pi12,pi21
c        write(6,'(a,8f12.4)')'fT, popr,t_rate,H1,2=',fT,popr,t_rate,
c     &               hz1_T+B_ext,hz2_T+B_ext,pi12,pi21
c       dq=0.
       qe=dq/4.
       qg=QgdQe*qe
       qh=-qg*jg*(jg+2)+qe*je*(je+2)                
       ra11=gamnat/2.+pi12
       ra22=gamnat/2.+pi21

       if(idex(1).eq.2) then
        dw=4.0*srw8
       else
        dw=16.0*srw8
       end if

       do n=-nop,nop
        sTr(n)=0.0
       end do
c      (am+bm=cm)       
       do mg=-jg,jg,2
        do me=-je,je,2
         if(mg-me.eq.0) then         
          ai=clebsch(1.0,0.,
     &           ajg,float(mg)/2.,aje,float(me)/2.)**2*ai0
c         write(6,'(a,2i3,2x,f10.3)')'0 mg,me, ai=',mg,me, ai
         else if(abs(me-mg).eq.2) then
          ai= clebsch(1.0,float(me-mg)/2.,
     &           ajg,float(mg)/2.,aje,float(me)/2.)**2
c         write(6,'(a,2i3,2x,f10.3)')'2 mg,me, ai=',mg,me, ai
         else if(abs(me-mg).gt.2) then        
          ai=0.
         end if
         if(ai.gt.0) then
          h=qh+3.*(qg*mg**2-qe*me**2)-a_iso
          de1=(ug*mg-ue*me)*(hz1_T+B_ext)+h
          de2=(ug*mg-ue*me)*(hz2_T+B_ext)+h
          do n=-nop,nop
           a11=cmplx(ra11,-n*dw+de1)
           a22=cmplx(ra22,-n*dw+de2)
           denom=a11*a22-cmplx(pi12*pi21,0.)
           aint=gam*(a22+cmplx(pi12,0.))+(1.-gam)*(a11+cmplx(pi21,0.))
           sTr(n)=sTr(n)+real(aint/denom)*ai   
          end do
         end if
        end do
       end do

       h=0.
       do n=-nop+1,nop-1,2
        h=h+ sTr(n)*2
       end do
       do n=-nop+2,nop-2,2
        h=h+sTr(n)
       end do
       h=h*2.+ sTr(-nop)+sTr(nop)
       h=h/3.*dw*4.*pi

       i1=iput+1
       do n=0,nop
        array_fr(i1+n)=cmplx(sTr(n),sTr(-n))/h
       end do
c       write(6,'(8f10.3)')(sTr(n),n=-128,128,8)
       return
       end 



