c     ######################################################################

      subroutine th_22indexsad(isubthe,icase,iput,iget,info)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
      
c     sad= source,absorber,detector : lstr1case=1,2,3 (comthe.for)
                                     
      integer isubthe,icase,iput,iget,info,istr,dstr,idex,
     &        ipLG,idum11,iflag_basis,l_Poincare,nLG,nAS,nSC,
     &        idum2,ak8,sk8
      real    srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss+4)
      common/struct/dstr(istr),ipLG,idum11(11),iflag_basis,l_Poincare,            !13.9.05 
     &              nLG,nAS,nSC,idum2,ak8,sk8,srw8,idex(7)       

      
      logical       b_vsp,b_v_max,b_dumvsp
      common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5)

c     storage use nst2_8 for 4 complex numbers of r_ik
      real          c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumc
      common/acmaps/c1,gamnat,e_xsi,flag_SAMP,flag_Voigt,dumc(icstrf-5)
      real          avm,sftr,aisom,w_Gauss,w_Lorentz,dumv
      logical       b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,b_dumv
      common/avmaps/avm,sftr,aisom,w_Gauss,w_Lorentz,dumv(ivstrf-5)
      common/bvmaps/b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz,
     &              b_dumv(ivstrf-5)
         
      integer     idumscrd
      parameter  (idumscrd=maxscrd-2*(2*mLG+1)-2*(mLG+1))
      real        sTr,dumscrd
      complex     cLG
      common/scrd/sTr(-mLG:mLG+1),cLG(-mLG:mLG),dumscrd(idumscrd)

      logical   b_pc,b_polisp,bxx
      
      integer   nE,iflag_SAMP,iflag_Voigt,jge,jn,ip,
     &          i,j,k,l,n,ni,nd,nn,nget,nall,n_all,iposLG,sk2,nst
      
      real      Eagd,hr,hi,hti,sqrt2,satrace_r,satrace_i,
     &          azz,d_x2,aszz,dsx2,fd,srw,ppmm,pp_mm,fs
      
      complex   hrtr,hrpm,ctr,cpm,cmp,hc,hci,
     &          trv(2,2),TSPCA(2,2),sph(2,2)
      

      b_polisp=.false.
      if(icase.eq.1) b_polisp=.true.

      if(isubthe.lt.0) then
       theoryname='2x2_ref_index_static_sad    v=101'
       if(ifrcase.le.4) then
        i=2
        if(b_polisp) i=4
        if(-isubthe.eq.1) then
         c1=i*(nSC+1)+1
         if(nSC-nAS.gt.0) c1=c1+(nSC-nAS)/2  ! source norm array
        end if
        if(-isubthe.eq.2) then
         c1=2*(nAS+1)
         if(b_polisp)c1=c1*4
        end if
        if(-isubthe.eq.3) c1=i*(nSC+1)
       end if
       if(ifrcase.eq.5) then
         c1=2*(nAS+1)
         if(b_polisp) c1=c1*4
        end if
c        write(6,'(a,f10.2,2i6,2i3)') 
c     &    'th_22refindex c1,nSC,nAS,ifrcase,isubthe=',
c     &    c1,nSC,nAS,ifrcase,isubthe
       return
      end if
c       write(6,'(a,6f10.2)') 
c     &  'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',
c     &                  avm,sftr,aisom,w_Gauss,w_Lorentz

      hci=cmplx(0.,1.)
      iflag_SAMP=flag_SAMP
      iflag_Voigt=flag_Voigt

      
      nst=4

      call get_theory(isubthe,info)
      if(info.gt.0) return     
c       write(6,'(a,5f10.4,/,50x,5l5)') 
c     &  'th_22refindexf avm,sftr,aisom,w_Gauss,w_Lorentz=',
c     &                  avm,sftr,aisom,w_Gauss,w_Lorentz,
c     &             b_vm,b_sftr,b_isom,b_w_Gauss,b_w_Lorentz

      b_pc=b_v_max.or.b_isom.or.b_w_Gauss.or.b_w_Lorentz.or.isubthe.gt.0
      if(.not.b_pc.or.info.gt.0) then
       isubthe=-abs(isubthe)
       goto 400
      else
        isubthe=abs(isubthe)
      end if 

      nget=real(array_fr(iget+1))
      n_all=real(array_fr(nget+1))
      jge=aimag(array_fr(nget+1))
      bxx=real(array_fr(nget+2)).gt.0.01


       if (iflag_basis.eq.-1) then
       sqrt2=1./sqrt(2.)
       TSPCA(1,1)=cmplx( sqrt2,0.)
       TSPCA(1,2)=cmplx(-sqrt2,0.)
       TSPCA(2,1)=cmplx(0.,-sqrt2)
       TSPCA(2,2)=cmplx(0.,-sqrt2)
c      transformation matrix from spherical basis to (sigma,pi)-basis
       do nall=1,n_all
        ip=nget+2+3*jge*(nall-1)
        do jn=ip,ip+jge*3-2,3
         pp_mm=real(array_fr(jn+2)) 
         ppmm =aimag(array_fr(jn+2))

         sph(1,1)= pp_mm+ppmm
         sph(2,2)=-pp_mm+ppmm
         sph(1,2)= array_fr(jn+3)
         sph(2,1)= conjg(sph(1,2))

         do i=1,2
         do k=1,2
          hc=cmplx(0.,0.)
          do j=1,2
          do l=1,2
           hc=hc+TSPCA(i,l)*sph(l,j)*conjg(TSPCA(k,j))
          end do
          end do
          trv(i,k)=hc
         end do
         end do
         array_fr(jn+2)=cmplx(real(trv(1,1)-trv(2,2)),
     &                  real(trv(1,1)+trv(2,2)))/2.
         array_fr(jn+3)=trv(1,2)
        end do   ! jn=
       end do   ! nall=1,n_all
      end if   
      

c      write(6,'(a,5i8)')'  2x2_ref_index_static_f iget,nget,iput=',
c     &              iget,nget,iput,lstr1case

      goto (100,200,300),lstr1case
c---------------------- source ------------------------------------
      
 100  continue
      
      do nall=1,n_all
       ip=nget+2+3*jge*(nall-1)

       if(enwr(7).eq.'fani') then
        if(bxx) then
         aszz=aimag(array_fr(ip+1))
         dsx2=aimag(array_fr(ip+4))
         azz =aimag(array_fr(ip+7))
         d_x2=aimag(array_fr(ip+10))
         fd=exp(-azz*d_x2-aszz*dsx2)
        else
         fd=exp(-aimag(array_fr(ip+13)))
        end if
        fs=fs+fd
        write(nwr,'(a,i2,a2,f10.3)')
     &     'anisotropic part of the f-source(',nall,')=',fd
       end if

       do jn=ip+1,ip+jge*3-2,3
        Eagd=real(array_fr(jn))+aisom
        nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
        if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')
     &    '**** E(source)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'
       end do   ! jn=
      end do   ! nall=1,n_all
      if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')
     &  'average over all sites and directions of f-source=',fs/n_all

       i=2
       if(b_polisp) i=4
       do n=iput+1,iput+(nSC+1)*i
        array_fr(n)=(0.,0.)
       end do   

      if(iflag_SAMP.eq.1) then
     
       call cLORGAU(gamnat,e_xsi,
     &     srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipLG,iposLG)
       
c       write(6,'(a,i6,/,4f12.5)')
c     & ' *source* iposLG,array_fr(iposLG,+1)=',
c     & iposLG,array_fr(iposLG),array_fr(iposLG+1)
      

       if(b_polisp) then
     
        do nall=1,n_all
         ip=nget+2+3*jge*(nall-1)

         if(bxx) then
          aszz=aimag(array_fr(ip+1))
          dsx2=aimag(array_fr(ip+4))
          azz =aimag(array_fr(ip+7))
          d_x2=aimag(array_fr(ip+10))
          fd=exp(-azz*d_x2-aszz*dsx2)
         else
          fd=exp(-aimag(array_fr(ip+13)))
         end if

        do jn=ip,ip+jge*3-3,3
          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)
            
          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd 
                    

         do n=0,nSC
          ni=iput+4*n 
         
          nd=abs(4*n-nE)
          if(nd.le.nLG) then
c          Sum;ab rpq(ab)/2*LG(E-Eab)  LG(E-Eab) on 1,3,...,2n+1
           hi=aimag(array_fr(iposLG+nd))
           array_fr(ni+1)=array_fr(ni+1)+hi*hrtr
           array_fr(ni+2)=array_fr(ni+2)+hi*hrpm
          end if

          nd=abs(-4*n-nE)
          if(nd.le.nLG) then
           hi=aimag(array_fr(iposLG+nd))
           array_fr(ni+3)=array_fr(ni+3)+hi*hrtr
           array_fr(ni+4)=array_fr(ni+4)+hi*hrpm
          end if
         end do
         end do     ! jn=jge
        end do      ! n_all
       else
     
        do nall=1,n_all
         ip=nget+2+3*jge*(nall-1) 

         if(bxx) then
          aszz=aimag(array_fr(ip+1))
          dsx2=aimag(array_fr(ip+4))
          azz =aimag(array_fr(ip+7))
          d_x2=aimag(array_fr(ip+10))
          fd=exp(-azz*d_x2-aszz*dsx2)
         else
          fd=exp(-aimag(array_fr(ip+13)))
         end if

         do jn=ip,ip+jge*3-3,3
          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)

          hrtr=array_fr(jn+2)*fd 

         do n=0,nSC
          ni=iput+4*n           

          nd=abs(4*n-nE)
          if(nd.le.nLG) then
           array_fr(ni+1)=array_fr(ni+1)+hrtr*aimag(array_fr(iposLG+nd))
          end if
          nd=abs(-4*n-nE)
          if(nd.le.nLG) then
           array_fr(ni+2)=array_fr(ni+2)+hrtr*aimag(array_fr(iposLG+nd))
          end if
         end do
 
        end do     ! jn=
       end do      ! n_all
     
       end if
      
      else   ! if(iflag_SAMP.eq.0) then

       srw=4.0*srw8

       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 

        if(bxx) then
         aszz=aimag(array_fr(ip+1))
         dsx2=aimag(array_fr(ip+4))
         azz =aimag(array_fr(ip+7))
         d_x2=aimag(array_fr(ip+10))
         fd=exp(-azz*d_x2-aszz*dsx2)
        else
         fd=exp(-aimag(array_fr(ip+13)))
        end if

        do jn=ip,ip+jge*3-3,3
         hrtr=array_fr(jn+2)*fd 
         hrpm=array_fr(jn+3)*fd  

         hti= aimag(hrtr)/2.0
         ctr= real(hrtr)*hci/2.0
         cpm= hrpm*hci/2.0
         cmp= conjg(hrpm)*hci/2.0


c         Eagd=real(array_fr(jn+1))+aisom
c         nE=ifix(Eagd/srw8+0.5)
c         write(nwr,'(i8,a,8f10.2)')jn,' Esource=',Eagd,hrtr,hrpm
         call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,
     &                       srw,w_Lorentz,w_Gauss,nSC,iflag_Voigt)
     
         if(b_polisp) then
          do n=0,nSC
           nn=iput+4*n
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(n ))*hrpm
           array_fr(nn+3)=array_fr(nn+3)+ aimag(cLG(-n))*hrtr
           array_fr(nn+4)=array_fr(nn+4)+ aimag(cLG(-n))*hrpm
          end do
         else
          do n=0,nSC
           nn=iput+2*n
           array_fr(nn+1)=array_fr(nn+1)+ aimag(cLG(n ))*hrtr
           array_fr(nn+2)=array_fr(nn+2)+ aimag(cLG(-n))*hrtr
          end do
         end if

        end do        ! jn=
       end do        ! n_all
      end if         ! iflag_SAMP
      
      
c     The sum of the Lorentz-Gauss curves of the jge lines
c     have to be normalized to 1 for each subspectrum of the source
c     iscpi=iscpr+2*nSC+1
      
c     write(6,'(a,i5,5x,2f15.8)')
c    &           ' isc3,sTr(0)=',isc3,array_fr(isc3+1)
        if(b_polisp) then
         do i=0,nSC
          nn=iput+4*i
          sTr(i)=aimag(array_fr(nn+1))
          sTr(-i)=aimag(array_fr(nn+3))
         end do
        else
         do i=0,nSC
          nn=iput+2*i
          sTr(i)=aimag(array_fr(nn+1))
          sTr(-i)=aimag(array_fr(nn+2))
         end do
        end if
c         write(6,'(a,i4,a,2f15.5)') (' i=',i,'sTr(+-i)=',
c     &    sTr(i),sTr(-i),i=0,5)
      
        i=2
        if(b_polisp) i=4
        ni=iput+(nSC+1)*i+1
        if(nAS.lt.nSC) then
         sk2=nSC-nAS
         do i=0,sk2,2
          hr=0.
          hi=0.
          do j=-nAS+1,nAS-1,2
           hr=hr+ sTr(i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hr=hr+ sTr(i+j)
          end do
          hr=hr*2.+sTr(-nAS+i)+sTr(nAS+i)
      
          do j=-nAS+1,nAS-1,2
           hi=hi+ sTr(-i+j)*2
          end do
          do j=-nAS+2,nAS-2,2
           hi=hi+ sTr(-i+j)
          end do
          hi=hi*2.+sTr(-nAS-i)+sTr(nAS-i)
          array_fr(ni+i/2)=cmplx(hr,hi)/3.
         end do
        else
         hr=0.
         do n=-nSC+1,nSC-1,2
          hr=hr+ sTr(n)*2
         end do
         do n=-nSC+2,nSC-2,2
          hr=hr+sTr(n)
         end do
         hr=hr*2.+ sTr(-nSC)+sTr(nSC)
         array_fr(ni)=cmplx(hr/3.,0.0)
c        write(6,'(a,i6,f8.3)')'-------th-----iscn_nr,snorm=',ni,hr/3.
        end if
       goto 400
c------------------------ absorber ----------------------------------
 200   continue
c      write(6,'(a,2i8)') '2x2_ref n_all=',n_all
       fs=0.
       do nall=1,n_all
        ip=nget+2+3*jge*(nall-1)

        if(enwr(7).eq.'fani') then
         if(bxx) then
          aszz=aimag(array_fr(ip+1))
          dsx2=aimag(array_fr(ip+4))
          azz =aimag(array_fr(ip+7))
          d_x2=aimag(array_fr(ip+10))
          fd=exp(-azz*d_x2-aszz*dsx2)
c          fd=-azz*d_x2-aszz*dsx2
         else
          fd=exp(-aimag(array_fr(ip+13)))
c          fd=-aimag(array_fr(ip+13))
         end if
         fs=fs+fd
         write(nwr,'(a,i2,a2,f10.3)')
     &     'anisotropic part of the f-absorber(',nall,')=',fd
        end if

        do jn=ip+1,ip+jge*3-2,3
         Eagd=real(array_fr(jn))+aisom
         nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
        if (abs(nE).gt.ak8) write(nwr,'(2(a,f10.4),a)')
     &    '**** E(absorber)=',Eagd,' out of range ',ak8*srw8,'[mm/s]'
        end do   ! jn=
       end do   !  nall=1,n_all
       if(enwr(7).eq.'fani') write(nwr,'(a,f10.3)')
     &  'average over all sites and directions of f-absorber=',fs/n_all

        i=2
        if(b_polisp) i=8
        do n=iput+1,iput+(nAS+1)*i
         array_fr(n)=(0.,0.)
        end do

       if(iflag_SAMP.eq.1) then

       call cLORGAU(gamnat,e_xsi,
     &      srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipLG,iposLG)
c       write(6,'(2a,/,5f10.4,5i8)')'gamnat,e_xsi,',
c     & 'srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipLG,iposLG=',
c     & gamnat,e_xsi,srw8*1000,w_Lorentz,w_Gauss,
c     & nLG,iflag_Voigt,ipLG,iposLG

       if(b_polisp) then
    
        do nall=1,n_all 
         ip=nget+2+3*jge*(nall-1) 

         if(bxx) then
          aszz=aimag(array_fr(ip+1))
          dsx2=aimag(array_fr(ip+4))
          azz =aimag(array_fr(ip+7))
          d_x2=aimag(array_fr(ip+10))
          fd=exp(-azz*d_x2-aszz*dsx2)
         else
          fd=exp(-aimag(array_fr(ip+13)))
         end if

         do jn=ip,ip+jge*3-3,3

          hrtr=array_fr(jn+2)*fd 
          hrpm=array_fr(jn+3)*fd  

c         for Poincare decomposition of rho (mossbauer)
          hti= aimag(hrtr)/2.0
          ctr= real(hrtr)*hci/2.0
          cpm= hrpm*hci/2.0
          cmp= conjg(hrpm)*hci/2.0

c         nkz=kz*I-Sum;ab rpq(ab)/2*(-i+(E-Eab)/hga)*LG(E-Eab)
c         nkz=kz*I-Sum;ab rpq(ab)/2*(-i*LGi(E-Eab)+LGr(E-Eab))
c         b1=1/2 kz*(npm+nmp)
c         b2=1/2 kz*(npm-nmp)*i
c         b3=1/2 kz*(npp-nmm)
c         the factor 1/4 is the factor in 1/2 kz*(...) and in npq ( 1/2rpq )
c         fLG=(4*n-nE)*srw8/(hga/2.) is written as

          Eagd=real(array_fr(jn+1))+aisom
          nE=ifix(Eagd/srw8+0.5)
c         write(6,'(2i8,a,8f10.4)')ip,jn,' E,p=',Eagd,hrtr,hrpm

          do n=0,nAS
           ni=iput+8*n
           nd=nst*n-nE                  ! +n
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            array_fr(ni+1)=array_fr(ni+1)-hc*hti
            array_fr(ni+2)=array_fr(ni+2)-hc*ctr
            array_fr(ni+3)=array_fr(ni+3)-hc*cpm
            array_fr(ni+4)=array_fr(ni+4)-hc*cmp
           end if

           nd=-nst*n-nE                  ! -n
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            array_fr(ni+5)=array_fr(ni+5)-hc*hti
            array_fr(ni+6)=array_fr(ni+6)-hc*ctr
            array_fr(ni+7)=array_fr(ni+7)-hc*cpm
            array_fr(ni+8)=array_fr(ni+8)-hc*cmp
           end if
          end do      ! nAS

         end do       ! jn=
        end do        ! n_all 

       else           ! if .not.polarized

        do nall=1,n_all 
         ip=nget+2+3*jge*(nall-1) 

         if(bxx) then
          aszz=aimag(array_fr(ip+1))
          dsx2=aimag(array_fr(ip+4))
          azz =aimag(array_fr(ip+7))
          d_x2=aimag(array_fr(ip+10))
          fd=exp(-azz*d_x2-aszz*dsx2)
         else
          fd=exp(-aimag(array_fr(ip+13)))
         end if

         do jn=ip,ip+jge*3-3,3

          hrtr=array_fr(jn+2)*fd 
          hti = aimag(hrtr)/2.0

          Eagd=real(array_fr(jn))+aisom
          nE=ifix(Eagd/srw8+0.5)

          do n=0,nAS
           ni=iput+8*n
           nd=nst*n-nE                  ! +n
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            array_fr(ni+1)=array_fr(ni+1)-hc*hti
c           if(n.lt.5) write(6,'(3i6,8f9.4)')iposLG,nd,nE,hc*100.,hti
           end if

           nd=-nst*n-nE                  ! -n
           if(abs(nd).le.nLG) then
            if(nd.gt.0) then
             hc=conjg(array_fr(iposLG+nd))
            else
             hc=-array_fr(iposLG-nd)
            end if
            array_fr(ni+2)=array_fr(ni+2)-hc*hti
           end if
          end do      ! nAS

         end do       ! jn=
        end do        ! n_all 
       end if         ! polarized
      

      else     !flag sampling
     
       srw=srw8*float(nst)

       do nall=1,n_all 
        ip=nget+2+3*jge*(nall-1) 

        if(bxx) then
         aszz=aimag(array_fr(ip+1))
         dsx2=aimag(array_fr(ip+4))
         azz =aimag(array_fr(ip+7))
         d_x2=aimag(array_fr(ip+10))
         fd=exp(-azz*d_x2-aszz*dsx2)
        else
         fd=exp(-aimag(array_fr(ip+13)))
        end if

        do jn=ip,ip+jge*3-3,3
         hrtr=array_fr(jn+2)*fd 
         hrpm=array_fr(jn+3)*fd  

         hti= aimag(hrtr)/2.0
         ctr= real(hrtr)*hci/2.0
         cpm= hrpm*hci/2.0
         cmp= conjg(hrpm)*hci/2.0

         Eagd=real(array_fr(jn+1))+aisom
c         write(6,'(8f10.5)')Eagd,hrtr,hrpm
         call aLORGAU(Eagd,gamnat,e_xsi,
     &                   srw,w_Lorentz,w_Gauss,nAS,iflag_Voigt)
     
c         write(6,'(2a,/,5f10.4,5i8)')'gamnat,e_xsi,',
c     &   'srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipLG,iposLG=',
c     &    gamnat,e_xsi,srw*250,w_Lorentz,w_Gauss,nAS,iflag_Voigt

         if(b_polisp) then
          do n=0,nAS
           ni=iput+8*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           array_fr(ni+2)=array_fr(ni+2)-hc*ctr
           array_fr(ni+3)=array_fr(ni+3)-hc*cpm
           array_fr(ni+4)=array_fr(ni+4)-hc*cmp
           hc=conjg(cLG(-n))
           array_fr(ni+5)=array_fr(ni+5)-hc*hti
           array_fr(ni+6)=array_fr(ni+6)-hc*ctr
           array_fr(ni+7)=array_fr(ni+7)-hc*cpm
           array_fr(ni+8)=array_fr(ni+8)-hc*cmp
          end do
         else
          do n=0,nAS 
           ni=iput+2*n
           hc=conjg(cLG(n))
           array_fr(ni+1)=array_fr(ni+1)-hc*hti
           hc=conjg(cLG(-n))
           array_fr(ni+2)=array_fr(ni+2)-hc*hti
          end do
         end if

        end do       !   jn=
       end do        ! nall=1,n_all
      end if         ! iflag_SAMP
      goto 400
     
c--------------------------------------------------------------------
 300   continue
c      detector
      n_all=real(array_fr(nget+1))
      jge=real(array_fr(nget+2))
      bxx=aimag(array_fr(nget+2)).gt.0.01
      
    
       do n=iput+1,iput+(nSC+1)
        array_fr(n)=(0.,0.)
       end do
      
      if(iflag_SAMP.eq.1) then

       do nall=1,n_all
        ip=nget+2+3*jge*(nall-1)
        do jn=ip+1,ip+jge*3-2,3
         Eagd=real(array_fr(jn))+aisom
         nE=ifix(Eagd/srw8+0.5)          ! nE <= sk8
         if (abs(nE).gt.sk8) write(nwr,'(2(a,f10.2),a)')
     &    '**** E(detector)=',Eagd,' out of range ',sk8*srw8,'[mm/s]'
        end do   ! jn=
       end do   ! nall=1,n_all
     
       call cLORGAU(gamnat,e_xsi,
     &    srw8,w_Lorentz,w_Gauss,nLG,iflag_Voigt,ipLG,iposLG)
      
c      write(6,'(a,i6,/,4f12.5)')
c    &  ' *detector* iposLG,array_fr(iposLG,+1)=',
c    &  iposLG,array_fr(iposLG),array_fr(iposLG+1)
      

        do nall=1,n_all
         ip=nget+2+3*jge*(nall-1)

         if(bxx) then
          aszz=aimag(array_fr(ip+1))
          dsx2=aimag(array_fr(ip+4))
          azz =aimag(array_fr(ip+7))
          d_x2=aimag(array_fr(ip+10))
          fd=exp(-azz*d_x2-aszz*dsx2)
         else
          fd=exp(-aimag(array_fr(ip+13)))
         end if

         do jn=ip,ip+jge*3-3,3
          nE=ifix((real(array_fr(jn+1))+aisom)/srw8+0.5)


          hrtr=array_fr(jn+2)*fd 
c         Sum;ab rpq(ab)/2*LG(E-Eab)

          do n=0,nSC
           ni=iput+n+1

           nd=abs(4*n-nE)
           if(nd.le.nLG) 
     &     satrace_r=aimag(array_fr(iposLG+nd))*aimag(hrtr)
           nd=abs(-4*n-nE)
           if(nd.le.nLG)
     &     satrace_i=aimag(array_fr(iposLG+nd))*aimag(hrtr)
           array_fr(ni)=array_fr(ni)+cmplx(satrace_r,satrace_i)
          end do
         end do     ! jn=
        end do     !  nall=1,n_all

      else  ! if(iflag_SAMP.eq.1) then

      
       do nall=1,n_all
        ip=nget+2+3*jge*(nall-1)

        if(bxx) then
         aszz=aimag(array_fr(ip+1))
         dsx2=aimag(array_fr(ip+4))
         azz =aimag(array_fr(ip+7))
         d_x2=aimag(array_fr(ip+10))
         fd=exp(-azz*d_x2-aszz*dsx2)
        else
         fd=exp(-aimag(array_fr(ip+13)))
        end if

        do jn=ip,ip+jge*3-3,3
         hrtr=array_fr(jn+2)*fd 
         call aLORGAU(real(array_fr(jn+1))+aisom,gamnat,e_xsi,
     &                         srw8,w_Lorentz,w_Gauss,nSC,iflag_Voigt)
         do n=0,nSC
          ni=iput+n+1
          array_fr(ni)=array_fr(ni)+
     &     cmplx(aimag(cLG(n)),aimag(cLG(-n)))*aimag(hrtr)
         end do       ! n 
        end do     ! jn=
       end do     !  nall=1,n_all
      end if        ! iflag_SAMP
      
 400  return
      end
