      subroutine syn_plot(cmch)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comthe.for'
      include 'comdas.for'

      integer     ifrth,idex,dstr,istr,iaddr,
     &            idum1,nstorTH1,nTH1,nCP,idum2,nsrw,idum
      real       srw8
      parameter (istr=38+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),idum1,nstorTH1,iaddr(6),                 !13.9.05
     &              nTH1,nCP,idum2,nsrw,ifrth(4),idum(8),srw8,idex(7)

      integer      max8subn,n_subspectra,idumpl,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         plotx,ploty,ploterry,plotres,plotxx,plotyy,plotsub,
     &             xyzdz,vtxt,vtxtp
      character*24 axesname,abscissa,ordinata,bgcolor,fgcolor,datacolor,
     &             thcolor,rescolor,auxcolor1,auxcolor2,auxcolor3,
     &             cmch*4,namechan*4,kform*8,chardum*4,axisformat*16,
     &             title*132,datfile*80,plotstrdef*80,plotstrpu*132
      parameter   (max8subn=maxsub*max8,
     &            idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188)
      common/plot/plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &            plotxx(max8),plotyy(max8),plotsub(max8subn),
     &            xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &            int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),
     &            npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &            n_subspectra,logx,logy,logf,
     &            namechan(infplot),kform(infplot),axisformat(3),
     &            axesname(3),title,plotstrdef,plotstrpu,
     &            bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &            auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl)

c      real          acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,dumcsp
c      common/acstrf/acsp,wavelength,uthick,
c     &              unit_chi,aiT_max,v_max,
c     &              ak_extension,T_bunch,scale,channels,
c     &              ch_angle,graz_beg,graz_end,dumcsp(icstrf-13)

      real          avsp,counts,background,Pdum,
     &              t_shift,dumvsp
      common/avstrf/avsp,counts,background,Pdum(6),
     &              t_shift,dumvsp(ivstrf-10)

      integer    idumscrt,idumsc,max4
      logical    b_12,b_34
      parameter(max4=max8/2, idumscrt=maxscrt-max4*maxsub-5*max4)
      real        datx,errx,sym,subspectrum,daty,erry
      common/scrt/datx(max4),errx(max4),sym(max4),
     &            subspectrum(max4,maxsub),
     &            daty(max4),erry(max4),idumsc(idumscrt)

      integer   ib_df,kana,ibmisfit,nexp,nthe,isd
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      real          x_exp,xb_exp,dx_exp,xb_the,dx_the
      common/ascale/x_exp(max8),nexp,xb_exp,dx_exp,nthe,xb_the,dx_the

      integer   mscale,n_plotsub,nresidue,ny,nyy,ns,i,ii,j,jj,k
      real      h,hm,htr,schrw,resmin,resmax,xmin,xmax,ymin,ymax,hd

      character       chsub*9
      logical         b_logx,b_logy
      character*1     chx,chbx,chlr,chy,chby,chbt,ch0
      character*80    CTEXT,CXTEXT,CYTEXT,frcolor*24 
      integer         nformx,nformy,i0
      real            chh,chw,syw,syh


      i0=ichar('0')
      ch0=char(0)


      if(cmch.eq.'dstr') then
c      format  reading data
       formdata(1)='y,dy'         ! scale=1
       formdata(2)='y,dy,x'       ! scale=2
       return
      end if
      if(cmch.eq.'dmod') then
c      format  writing data and theory  
       namechan(1)='x'
       namechan(2)='y'
       namechan(3)='dy'
       namechan(4)='res'
       namechan(5)='xt'
       namechan(6)='yt'
       namechan(7)='su'
       namechan(8)=' '
       plotstrdef='(x,y,dy)'
       if(b_theory) plotstrdef='(xt,yt)'
c      if there is not the standard xd,yd,erry a d(...) identifies data 
       if(b_theory.and.b_data)then
        plotstrdef='(x,y,dy) (xt,yt)'
        j=21
       end if
       if(ifrcase.ge.22) then
        display_mode(1)='angle scale, log(counts)'
        display_mode(2)='angle scale, residual counts'
        display_mode(3)='channel scale, counts'
        display_mode(4)='channel scale,residual counts'
        if(b_theory)then
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then
          plotstrdef='(x,y,dy) (xt,yt) (x,res)'
          j=30
         end if
         if(n_subset.gt.0)then
          do i=1,n_subset
           chsub=' (xt,su'//char(i+i0)//')'
           k=j+(i-1)*9
           plotstrdef(k:)=chsub
          end do
         end if
        end if
       else
        display_mode(1)='time scale, log(counts)'
        display_mode(2)='time scale, residual counts'
        display_mode(3)='channel scale, counts'
        display_mode(4)='channel scale,residual counts'
        display_mode(5)='velocity scale, cross section'
        display_mode(6)='channel scale, cross section'
        if(b_theory)then
         if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4)then
          plotstrdef='(x,y,dy) (xt,yt) (x,res)'
          j=30
         end if
         if(n_subset.gt.0)then
          do i=1,n_subset
           chsub=' (xt,su'//char(i+i0)//')'
           k=j+(i-1)*9
           plotstrdef(k:)=chsub
          end do
         end if
        end if
       end if

       return
      end if

      ii=index(file_data,'.')
      if(ii.eq.0) then
       datfile='Ptheory_nodata.ps'//char(0)
      else
       datfile='P'//file_data(1:ii)//'ps'//char(0)
      end if

      b_logy=.false.
      b_logx=.false.
      b_12=.false.
      b_34=.false.
      if(ifrcase.ge.22.and.ndisplay_mode.gt.4) ndisplay_mode=4
      goto(1,2,3,4,1,2,3,4,5,6), ndisplay_mode
c       display_mode(1)='angle, time scale'
 1     b_12=.true.
       if(ifrcase.ge.22) then
        abscissa='theta[mrad] '
        axisformat(1)='%6.2f '
       else
        abscissa='T[ns] '
        axisformat(1)='%6.1f '
       end if
       ordinata='log count'//ch0
       axisformat(2)='%6.2f '
       b_logy=.true.
       nformx=0
       nformy=2       
       goto 7
c       display_mode(2)='angle, time scale, residual counts'
 2      b_12=.true.
        if(ifrcase.ge.22) then
        abscissa='theta[mrad] '
        axisformat(1)='%6.2f '
       else
        abscissa='T[ns] '
        axisformat(1)='%6.1f '
       end if
       ordinata='log count'//ch0
       axisformat(2)='%6.2f '
       b_logy=.true.
       nformx=0
       nformy=2     
       goto 7
c       display_mode(3)='channel scale'
 3     b_34=.true.
       abscissa='channel '
       ordinata='counts '
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       nformx=0
       nformy=0     
       goto 7
c       display_mode(4)='-channel scale, residual counts'
 4      b_34=.true.
        abscissa='channel '
       ordinata='counts '
       axisformat(1)='%6.0f '
       axisformat(2)='%8.0f '
       b_logy=.false.
       nformx=0
       nformy=0    
       goto 7
c      display_mode(5)='velocity scale, cross section'
 5      abscissa='[mm/s] '
       ordinata='cross section '
       axisformat(1)='%6.1f '
       axisformat(2)='%10.2f '
       nformx=1
       nformy=2     
       goto 7
c      display_mode(6)='channel scale, cross section'
 6     abscissa='channels '
       ordinata='cross section '
       axisformat(1)='%6.0f '
       axisformat(2)='%10.2f '
       nformx=0
       nformy=2     
 7     continue



      if(b_12.or.ndisplay_mode.eq.5) then
       kform(1)='f7.2'
       kform(2)='f10.4'
       kform(3)='f12.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
       nformy=2
      else
       kform(1)='f6.0'
       kform(2)='f12.0'
       kform(3)='f9.1'
       kform(4)='f9.1'
       kform(5)='f6.0'
       kform(6)='f12.0'
       kform(7)='f12.0'
       nformy=0
      end if
      kform(8)=' '

      bgcolor='LightYellow'//char(0)
      fgcolor='black'//char(0)
      datacolor=fgcolor
      thcolor=fgcolor
      rescolor='blue'//char(0)
      do j=1,maxsub
       ncolor(j)=icolor_sub(j)
      end do

      n_subspectra=n_subset
      
      n_plotsub=n_subspectra
      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

c      write(6,'(a,i4)')'frame02 plot nexp=',nexp
     
      isd=nexp/1024
      if(nexp-isd*1024.gt.0)isd=isd+1
      if(isd.eq.0)isd=1
      if(b_data) then
       do i=1,nexp
        daty(i)=real_fr(mfpt+i)
       end do
       do i=1,nexp
        erry(i)=real_fr(mdfpt+i)
       end do   
      end if

      nresidue=0
      do ii=1,infplot
       nchanplot(ii)=0
      end do

c       write(6,'(4(a,f10.3))')'counts=',counts,
c     &   ' T_bunch=',T_bunch, '  background=',background
c       write(6,'(6g12.2)') (thfk(i),i=1,256)
c      do j=1,nexp
c       write(11,'(i4,4x,2f15.6)') j,daty(j),erry(j)
c      end do
c      do j=1,nexp
c       write(11,'(i4,4x,2f15.6)') j,thfk(j)
c      end do
c      close(unit=11)
c      do j=240,250
c      write(6,'(i4,4x,f15.6)') j,thfk(j)
c      end do
c       write(6,'(a,20i4)')' ichanks=',(ichanks(i),i=0,ichanks(0))


      nyy=0
      ny=0
      if(b_12) then
c       call x_scale(mscale)
       if(b_data) then
        if(ndisplay_mode.eq.1)then
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k),isd
           ny=ny+1
           plotx(ny)=x_exp(j)
           h=abs(daty(j))
           if(h.lt.0.1) then
            ploty(ny)=0.
            ploterry(ny)=1.
            ny=ny-1
           else
            ploty(ny)=LOG10(h)
            ploterry(ny)=1./erry(j)
           end if
          end do
         end do
        else
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k),isd
           ny=ny+1
           plotx(ny)=x_exp(j)
           ploty(ny)=daty(j)
           ploterry(ny)=erry(j)
          end do
         end do
         if(b_theory)then
          nresidue=1
          ns=0
          do k=2,ichanks(0),2
           do j=ichanks(k-1),ichanks(k),isd
            ns=ns+1
            plotres(ns)=daty(j)-thfk(j)
           end do
          end do
         end if
        end if
       end if ! b_data

       if(b_theory) then
        if(ndisplay_mode.eq.1)then
         nyy=nthe
         do ii=1,nyy
          plotxx(ii)=xb_the+(ii-1)*dx_the
          plotyy(ii)=LOG10(abs(thfk(ii)+0.1))
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=LOG10(abs(subspectrum(ii,j)+0.1))
           end do
          end do
         end if
        else
         nyy=nexp
         do ii=1,nyy
          plotxx(ii)=x_exp(ii)
          plotyy(ii)=thfk(ii)
         end do
         if(n_subspectra.gt.0) then
          do j=1,n_subspectra
           ns=(j-1)*max8
           nchanplot(6+j)=nyy
           do ii=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
           end do
          end do
         end if
        end if
       end if  ! b_theory
      end if ! log scale


      if(b_34) then
c       call x_scale(mscale)
       if(b_data) then
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k),isd
          ny=ny+1
          plotx(ny)=ny
          ploty(ny)=daty(j)
          ploterry(ny)=erry(j)
c          if(daty(j).lt.0.1) ny=ny-1
         end do
        end do
        if(b_theory.and.ndisplay_mode.eq.4)then
         nresidue=1
         ns=0
         do k=2,ichanks(0),2
          do j=ichanks(k-1),ichanks(k),isd
           ns=ns+1
           plotres(ns)=daty(j)-thfk(j)
          end do
         end do
        end if
       end if ! b_data

       if(b_theory) then
        nyy=0 
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k),isd
         nyy=nyy+1
         plotxx(nyy)=nyy
         plotyy(nyy)=thfk(j)
        end do
        end do
        if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*max8
          nchanplot(6+j)=nyy
          do i=1,nyy
            ns=ns+1
            plotsub(ns)=subspectrum(ii,j)
          end do
         end do
        end if
       end if  ! b_theory
      end if ! counts

c      display_mode(5)='velocity scale, cross section'
c      abscissa='[mm/s]'
c      ordinata='cross section'

c      display_mode(5)='channel scale, cross section'
c      abscissa='channels'
c       ordinata='cross section'

      if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6) then
       schrw=1.0
       nresidue=0
c       cv_ET=100.*wavelength
c       iT_max=aiT_max
c       iT_max2=2**iT_max

       if(ndisplay_mode.eq.5) schrw=8*srw8
c       if(ndisplay_mode.eq.9) schrw=cv_ET/abs(T_bunch*iT_max2)
       schrw=schrw*nsrw
c       write(6,'(a,2i8,f10.4)')
c     &   'array_fr( nn+),nCP,nsrw,schrw=',nCP,nsrw,schrw

       nyy=0
       hm=0.
       do ii=-nCP,nCP-1
        jj=nstorTH1+(nCP+ii)*4
        nyy=nyy+1
        plotxx(nyy)=schrw*ii
        htr=0.0
c        do k=1,4
c         htr=htr+array_fr(jj+k)*conjg(array_fr(jj+k))
        do k=1,4,3
         htr=htr+real(array_fr(jj+k))
        end do
        if(hm.lt.htr) hm=htr
        plotyy(nyy)=htr
       end do
       plotyy(nyy-1)=hm
       plotyy(nyy)=-hm/2.

c      write(6,'(a,2i4,f10.4)') ' nyy,nCP,schrw=',nyy,nCP,schrw
       n_plotsub=8
       n_subspectra=n_plotsub
       do j=1,n_plotsub/2
        ns=2*(j-1)*max8
        nchanplot(5+2*j)=nyy
        do ii=-nCP,nCP-1
         jj=nstorTH1+(nCP+ii)*4
         ns=ns+1
         plotsub(ns)=real(array_fr(jj+j))
        end do
c       write(6,'(a,4i8)') ' real nstorTH1,j,nyy=',nstorTH1,j,nyy
        ns=(2*j-1)*max8
        nchanplot(6+2*j)=nyy
        do ii=-nCP,nCP-1
         jj=nstorTH1+(nCP+ii)*4
         ns=ns+1
         plotsub(ns)=aimag(array_fr(jj+j))
        end do


c       write(6,'(a,2i6)') ' aimag nstorTH1,j=',nstorTH1,j
c       write(6,'(8f10.4)') (plotsub(ii),ii=(2*j-1)*nyy+1,2*j*nyy)
       end do
      end if ! 5,6

      xmin=1.e30
      xmax=-xmin
      ymin=xmin
      ymax=0.                       ! counts > 0
      if(b_data.and.ndisplay_mode.lt.5) then
       do ii=1,3
        nchanplot(ii)=ny
       end do
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i)
       end do
       do i=1,ny
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i)
       end do
      else
       do ii=1,4
        nchanplot(ii)=0
       end do
      end if
c      write(6,'(a,4g12.2)')'m=',xmin,xmax,ymin,ymax

      if(b_theory) then
       nchanplot(5)=nyy
       nchanplot(6)=nyy
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 
       do i=1,nyy-2
        if(ymin.gt.plotyy(i))ymin=plotyy(i)
       end do
       do i=1,nyy-2
        if(ymax.lt.plotyy(i))ymax=plotyy(i)
       end do
       if(n_subspectra.gt.0) then
         do j=1,n_subspectra
          ns=(j-1)*max8
          do i=1,nyy
           if(ymin.gt.plotsub(ns+i))ymin=plotsub(ns+i)
          end do
         end do
       end if
      end if

      if(nresidue.eq.1) then
        nchanplot(4)=ny
        resmin=0.
        resmax=0.
        do i=1,ny
         hd= plotres(i)-ploterry(i)           
         if(resmin.gt.hd) resmin=hd
        end do
        do i=1,ny
         hd= plotres(i)+ploterry(i)           
         if(resmax.lt.hd) resmax=hd
        end do
         hd= resmax-2.0*resmin 
        do i=1,ny
         plotres(i)=plotres(i)+ymax-resmin
        end do
        ymax=ymax-resmin+resmax
      end if

       xyzdz(1)=xmin
       xyzdz(2)=xmax
       xyzdz(3)=ymin
       xyzdz(4)=ymax

       bgcolor='Ivory'//char(0)     ! color background  (0...) [0]
       fgcolor='black'//char(0)
       datacolor=fgcolor
       thcolor=fgcolor
       rescolor='blue'//char(0)
       do j=1,maxsub
        ncolor(j)=icolor_sub(j)
       end do
       
       logx=0
       logy=0
       if(b_logx)logx=1
       logf=0
       if(b_logy)logf=1

c      definitions taken from allplo
c      x
       chx='b'                 ! (none,Both,bottom,top)  [B]
       chbx='n'                ! (none,bottom,top)  [n]
       chlr='l'                ! (left,right)  [r]
c      y
       chy='B'                 ! (none,Both,left,right)  [B]
       chby='r'                ! (none,left,right)  [r] 
       chbt='t'                ! (bottom,top)  [t]
       chh=0.3                 ! 
       chw=0.25                ! character cw,ch  [0.40,0.40]         
       syw=0.1                 !
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]
       frcolor=fgcolor         ! color frame       [black]
       frcolor='blue'//char(0) 
       CTEXT=title
       CXTEXT=abscissa
       CYTEXT=ordinata
         
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,
     &            chh,chw,syw,syh,
     &          CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)

c       write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax

c      write(6,'(a,f15.5)') ' in frame in plotf plotyy(2)=',plotyy(2)
c       write(6,'(8f10.4)') (plotx(ii),ii=1,ny,16)
c       write(6,'(8f10.4)') (ploty(ii),ii=1,ny,16)
c      write(6,'(a,3i8)') 'syn_plot xx nexp,nyy=',nexp,nyy
c      write(6,'(8f10.4)') (plotxx(ii),ii=1,nyy,16)
c      write(6,'(a,3i8)') 'syn_plot yy nexp,nyy=',nexp,nyy
c      write(6,'(8f10.4)') (plotyy(ii),ii=1,nyy)

      return
      end

      subroutine offspec_plot(cmch,n5_offspec,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comthe.for'
      include 'comdat.for'
      include 'complt.for'
      include 'comdas.for'

      integer    info,n5_offspec
      dimension  n5_offspec(5)
      
      integer      n_subspectra,idumpl,logx,logy,logf,
     &             int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor
      real         parray,xyzdz,vtxt,vtxtp
      character*24 axesname,abscissa,ordinata,bgcolor,fgcolor,datacolor,
     &             thcolor,rescolor,auxcolor1,auxcolor2,auxcolor3,
     &             cmch*4,namechan*4,kform*8,chardum*4,axisformat*16,
     &             title*132,datfile*80,plotstrdef*80,plotstrpu*132
      parameter  (idumpl=MDBPLFT*2-140*maxn-8*39-5*infplot-maxsub-188)
      common/plot/ parray(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &             int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),
     &             npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &             n_subspectra,logx,logy,logf,
     &             namechan(infplot),kform(infplot),axisformat(3),
     &             axesname(3),title,plotstrdef,plotstrpu,
     &             bgcolor,fgcolor,datacolor,thcolor,rescolor,
     &             auxcolor1,auxcolor2,auxcolor3,datfile,chardum(idumpl)

      integer    idumscrt,idumsc,max4
      parameter(max4=max8/2, idumscrt=maxscrt-max4*maxsub-5*max4)
      real        datx,errx,sym,subspectrum,daty,erry
      common/scrt/datx(max4),errx(max4),sym(max4),
     &            subspectrum(max4,maxsub),
     &            daty(max4),erry(max4),idumsc(idumscrt)

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      real x_exp,x_the
      common/scale3d/  x_exp(maxn),x_the(maxn)
      character TEXT*80,chl*24,chr*24,form*7,ch4*4,bsl*1,dbsl*2
      integer   i,i0,ii,j,jj,k,ISTEU,j6th,j9th,nchannel,ny,isd,
     &          icase,n_omega,n_theta,nstorTH,i_angle,i_angp1,k_omega,
     &          nn,im,i_theta,ntxt,l1_get0,n_anglepair
      real      h,h1,Xl,Yl,Zl,BREITE,HOEHE,alpha,rad,
     &          thmax,damax,damin,scmin,
     &          omega,omega_beg,domega,omega_end,omegaend,omegabeg,
     &          theta,dtheta,theta_beg,theta_end,thetaend,thetabeg,
     &          anglemax,grazinc,grazout,
     &          xend,yend,xbeg,ybeg,vxend,vyend,vxbeg,vybeg,
     &          counts,background
      logical   omgtheta,log_mode,b_showangles

      real         plotx,ploty,ploterry,plotres,plotxx,plotyy,OP
      dimension    plotx(max8),ploty(max8),ploterry(max8),plotres(max8),
     &             plotxx(max8),plotyy(max8),OP(0:8)
      equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),
     &             (parray(max8*2+1),ploterry(1)), 
     &             (parray(max8*3+1),plotres(1)), 
     &             (parray(max8*4+1),plotxx(1)),
     &             (parray(max8*5+1),plotyy(1))

      logical         b_logx,b_logy
      character*1     chx,chbx,chlr,chy,chby,chbt
      character*80    CTEXT,CXTEXT,CYTEXT,frcolor*24 
      integer         nformx,nformy
      real            chh,chw,syw,syh

      if(cmch.eq.'dstr') then
c      format  reading data 
       formdata(1)='z,dz,x y'         ! scale=1
       return
      end if

      l1_get0 =n5_offspec(1)
      icase=int(real(array_fr(l1_get0+1)))
      if(cmch.eq.'dmod') then
c      format  writing data and theory  
       namechan(1)='xd'
       namechan(2)='yd'
       namechan(3)='zd'
       namechan(4)='dz'
       namechan(5)='res'
       namechan(6)='xt'
       namechan(7)='yt'
       namechan(8)='zt'
       namechan(9)='  '
       display_mode(1)='angle scale (linear scale)'
       display_mode(2)='angle scale-(log scale)'
       if(icase.lt.3.or.icase.eq.5)then
        display_mode(3)='channel scale (2d) (linear scale)'
        display_mode(4)='channel scale (2d) (log scale)'
       end if
       return
      end if

      nchannel    =n5_offspec(2)
      n_anglepair=n5_offspec(3)
      counts      =n5_offspec(4)
      background  =n5_offspec(5)

      isd=nchannel/1024
      if(nchannel-isd*1024.gt.0)isd=isd+1
      if(isd.eq.0)isd=1

      b_showangles=n_anglepair.eq.1
      i0=ichar('0')
      j6th=max8*6
      j9th=max8*9
      do k=1,infplot
       nchanplot(k)=0 
      end do      

      if(.not.b_theory) then
       info=10
       infotext(1)='effi/3dplot/notheory'
       infotext(2)=
     & '*** no theory calculated -> no dimensions of the plot'
       infotext(3)='calculate dummy (z=0) to obtaine x,y grid '       
       infotext(4)=' '
       return
      end if

      nformx=1
      nformy=1
      b_logx=.false.
      b_logy=.false.
      log_mode=ndisplay_mode.eq.2.or.ndisplay_mode.eq.4
      if(log_mode) then
       kform(1)='f7.2'
       kform(2)='f8.4'
       kform(3)='f8.6'
       kform(4)='f10.6'
       kform(5)='f7.2'
       kform(6)='f8.4'
       kform(7)='f8.4'
       kform(8)='f8.4'
       b_logy=.true.
      else
       kform(1)='f10.3'
       kform(2)='f10.3'
       kform(3)='f8.1'
       kform(4)='f8.1'
       kform(5)='f6.0'
       kform(6)='f10.3'
       kform(7)='f10.3'
       kform(8)='f10.0'
      end if
      kform(9)=' '
      plotstrdef='(xd,yd,zd,dz) (xt,yt,zt)'

      ii=index(file_data,'.')
      datfile='P'//file_data(1:ii)//'ps'//char(0)

      bgcolor='Ivory'//char(0)
      fgcolor='black'//char(0)
      datacolor=fgcolor
      thcolor=fgcolor
      rescolor='blue'//char(0)
      do j=1,maxsub
       ncolor(j)=icolor_sub(j)
      end do

      rad=0.0174533
      do i=1,16
       ltext(i)=0
      end do


c      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega
       n_omega=int(real(array_fr(l1_get0+2)))
       n_theta=int(aimag(array_fr(l1_get0+2)))
       omgtheta= n_omega.ge.n_theta 
       omega_beg=real(array_fr(l1_get0+3))
       domega=aimag(array_fr(l1_get0+3))
       theta_beg=real(array_fr(l1_get0+4))
       dtheta=aimag(array_fr(l1_get0+4))
       omega_end=real(array_fr(l1_get0+5))
       theta_end=aimag(array_fr(l1_get0+5))

       nstorTH=l1_get0+6               ! see th_scanmode()

c       write(6,'(a,i4,4x,3f10.4)')
c     &  'n_theta,theta_beg,dtheta,theta_end=',
c     &   n_theta,theta_beg,dtheta,theta_end
c       write(6,'(a,i4,4x,3f10.4)')
c     &   'n_omega,omega_beg,domega,omega_end=',
c     &   n_omega,omega_beg,domega,omega_end

       if(ndisplay_mode.ge.3) goto 1000         
c        display_mode(1)='angle scale (linear scale)'
c        display_mode(2)='angle scale-(log scale)'
c        display_mode(3)='channel scale (2d) (linear scale)'
c        display_mode(4)='channel scale (2d) (log scale)'
        if(icase.eq.1.or.icase.eq.4)then
         h=(omega_end-omega_beg)
         h1=(theta_end-theta_beg)
         if(h.lt.h1)h=h1 
         xyzdz(1)=omega_beg-1. 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1.
         xyzdz(4)=xyzdz(2)
         anglemax=theta_end
         if(theta_end.lt.omega_end) anglemax=omega_end
         thetabeg=theta_beg
         omegabeg=omega_beg
         thetaend=theta_end*1.01
         omegaend=theta_end*1.01
        else if(icase.eq.2.or.icase.eq.3)then
         xyzdz(1)=omega_beg 
         xyzdz(2)=(theta_end-omega_beg)/2. 
         xyzdz(3)=omega_beg 
         xyzdz(4)=(theta_end-omega_beg)/2.
         anglemax=theta_end 
         thetaend=theta_end*1.01
         omegaend=theta_end*1.01
         thetabeg=omega_beg
         omegabeg=omega_beg
        else if(icase.eq.5)then
         h=omega_end
         xyzdz(1)=omega_beg-1 
         xyzdz(2)=(h+2.)/2. 
         xyzdz(3)=theta_beg-1
         xyzdz(4)=xyzdz(2)
         anglemax=theta_end
         if(theta_end.lt.omega_end) anglemax=omega_end
         thetabeg=theta_beg
         omegabeg=omega_beg
         thetaend=omega_end*1.01
         omegaend=omega_end*1.01
        end if

       i_angle=0
       i_angp1=0
       j=0
c      ------caculation of the specular angles (red line)-------
       omega=omega_beg-domega
       do while(omega.lt.anglemax)       
        omega=omega+domega
        i_angp1=i_angp1+1
        j=3*(i_angp1-1)+j6th
        parray(j+1)=omega
        parray(j+2)=omega
c        write(6,'(a,6f12.2)')'omega, omega_beg/end Theta_beg/end=',
c     &               omega,omegabeg,omegaend,thetabeg,thetaend
        if(omega.gt.thetaend.or.omega.lt.thetabeg .or.
     &     omega.gt.omegaend.or.omega.lt.omegabeg)i_angp1=i_angp1-1
        parray(j+3)=0.0
        if(log_mode) parray(j+3)=1.0 
       end do     ! n_omega
       i_angp1=i_angp1+1
       j=3*(i_angp1-1)+j6th
       parray(j+1)=i_angle
       parray(j+2)=0
       parray(j+3)=-1.
c      ------ end of caculation of the specular angles (red line)-------


      do i_theta=1,n_theta
       theta=theta_beg+dtheta*(i_theta-1)

       do k_omega=1,n_omega        
        omega=omega_beg+domega*(k_omega-1)

        if(icase.eq.1.or.icase.eq.4) then
          grazinc=omega
          grazout=theta
        else if(icase.eq.2.or.icase.eq.3) then
           grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta
           grazout=2*omega_beg+domega*(n_omega-1)+
     &       (i_theta-1)*dtheta*2-grazinc
        else if(icase.eq.5) then
c        PHI_s=omega N_s=n_omega
         j=i_theta/2
         if(2*j.eq.i_theta) then
c         + dTheta_out
          grazinc=omega
          grazout=(omega+dtheta*j)
         else
c         + dTheta_out
          grazinc=(omega+dtheta*j)
          grazout=omega
         end if
         if(omega+dtheta*j.gt.omega_end)goto 77
        end if
        i_angle=i_angle+1   
        i_angp1=i_angp1+1
        j=3*(i_angp1-1)+j6th
        parray(j+1)=grazinc
        parray(j+2)=grazout


        if(b_showangles) then
         parray(j+3)=0.01
        else
         h=real_fr(2*nstorTH+i_angle)*counts+background
c         write(6,'(2i8,3g12.3)')2*nstorTH+i_angle,i_angle,
c     &                  real_fr(2*nstorTH+i_angle)
         if(log_mode)then
          parray(j+3)=alog10(h)
c         write(6,'(i8,2g12.3)')j,h, parray(j+3)
         else
          parray(j+3)=h
         end if
        end if
 77     continue

c       write(6,'(i4,2f12.1)')i_angle,grazinc,grazout
       end do     ! n_omega
        i_angp1=i_angp1+1
        j=3*(i_angp1-1)+j6th
        parray(j+1)=i_angle
        parray(j+2)=0
        parray(j+3)=-1.
       end do     ! n_theta

       i_angp1=i_angp1+1
       j=3*(i_angp1-1)+j6th
       parray(j+1)=-1.
       parray(j+2)=-1.
       parray(j+3)=-1.

c       write(6,'(3f10.3)')(parray(j6th+i),i=1,3*i_angp1+3) ! ####

       if(icase.eq.2.or.icase.eq.3) then
        xbeg =0.02
        vxbeg=omega_beg
        xend=1.02
        vxend=omega_end+dtheta*(n_theta-1)/1.4142
        ybeg =0.02
        vybeg=omega_beg
        yend =xend
        vyend=vxend
       else ! icase.eq.1 or 4 or 5
        ybeg=0.02
        vybeg=theta_beg
        yend=1.02
        xbeg=0.02
        vxbeg=omega_beg
        xend=1.02
        if(theta_end-theta_beg.lt.omega_end-omega_beg) then
         vyend=theta_beg+omega_end-omega_beg
         vxend=omega_end
        else
         vyend=theta_end
         vxend=omega_beg+theta_end-theta_beg
        end if
       end if

c      decission for points or line
       npnt3d(1)=1
       if(b_showangles) npnt3d(1)=0
c      
      if(log_mode)then
       abscissa='omega[mrad]'
       axisformat(1)='%5.1f '
       ordinata='log counts'
       axisformat(2)='%12.2f '
      else
       abscissa='omega [mrad]'
       axisformat(1)='%5.1f '
       ordinata='counts'
       axisformat(2)='%12.2f '
      end if

      xyzdz(5)=1.e10
      scmin=1.e10
      xyzdz(6)=0.
      if(b_showangles) then
       xyzdz(5)=-0.1
       xyzdz(6)=1.0
      end if

      if(b_theory)then
       j=j6th
       thmax=0.
       do k=1,i_angp1
        if(parray(j+3).gt.thmax)thmax=parray(j+3)
        j=j+3 
       end do
       nchanplot(6)=i_angp1
       if(thmax.gt.xyzdz(6))xyzdz(6)=thmax
       j=j6th
       do k=1,i_angp1
        if(parray(j+3).lt.thmax)thmax=parray(j+3)
        j=j+3 
       end do
       if(thmax.lt.xyzdz(5))xyzdz(5)=thmax
       scmin=thmax
      end if
c       write(6,'(a,f12.5)') ' th_min=',scmin

      if(b_data)then
       j=j9th
       if(log_mode)then
        ny=0
        do k=2,ichanks(0),2
         do jj=ichanks(k-1),ichanks(k),isd
         ny=ny+1
c        do k=1,nchannel
         parray(j+1)=real_fr(mxpt+jj)
         parray(j+2)=real_fr(mypt+jj)
         if(real_fr(mfpt+jj).le.0)then
          ny=ny-1
          j=j-5
         else
          parray(j+3)=alog10(real_fr(mfpt+jj))
          parray(j+4)=real_fr(mdfpt+jj)/(real_fr(mfpt+jj)+2)
c          write(6,'(a,5f10.3)') ' real_fr(mypt+jj)=',parray(j+1),
c     &    parray(j+2),real_fr(mfpt+jj),parray(j+3),parray(j+4)
         end if

         parray(j+5)=1.
         j=j+5
         end do
        end do
c       residual not yet implemented        
       else
        ny=0
        do k=2,ichanks(0),2
         do jj=ichanks(k-1),ichanks(k),isd
         ny=ny+1
c        do k=1,nchannel
         parray(j+1)=real_fr(mxpt+jj)
         parray(j+2)=real_fr(mypt+jj)
         parray(j+3)=real_fr(mfpt+jj)
         parray(j+4)=real_fr(mdfpt+jj)
         parray(j+5)=thfk(jj)-parray(j+3)
         j=j+5
         end do
        end do

        if(n_anglepair.gt.1.) then
         j=j9th
         do k=2,ichanks(0),2
          do jj=ichanks(k-1),ichanks(k),isd
           parray(j+3)=0.01
           j=j+5
          end do
         end do
         
        end if
       end if
 
       j=j9th
       damax=0.        
       do k=1,ny
c        write(6,'(i8,2f12.2)')j,parray(j+3),parray(j+4)
        if(parray(j+3)+parray(j+4).gt.damax)
     &            damax=parray(j+3)+parray(j+4)
        j=j+5 
       end do
       j=j9th
       damin=damax
       do k=1,ny
        if(parray(j+3)-parray(j+4).lt.damin)
     &            damin=parray(j+3)-parray(j+4)
        j=j+5 
       end do
       if(damax.gt.xyzdz(6)) xyzdz(6)=damax
       if(damin.lt.xyzdz(5)) xyzdz(5)=damin
       nchanplot(1)=ny

       j=j9th
       do k=1,ny
        if(parray(j+3).lt.scmin) scmin=parray(j+3)
         j=j+5 
       end do

      end if    ! b_data

      if(n_anglepair.gt.1) then
        xyzdz(5)=0.
        xyzdz(6)=1.
      end if          

c      ------ begin of correction the specular angles (red line)-------
c      the z-component of the first point (used for all z-values i xmosplo.c)
       if(log_mode)parray(j6th+3)=xyzdz(4)
c      ------ end of correction of the specular angles (red line)-------

       i_angp1=i_angp1+1
       j=3*(i_angp1-1)+j6th
       parray(j+1)=i_angle
       parray(j+2)=0
       parray(j+3)=-1.
c      ------ end of caculation of the specular angles (red line)-------

       axesname(1)=abscissa
       axesname(2)='theta [mrad]'
       axesname(3)=ordinata
       auxcolor1='red'//char(0)
       auxcolor2='yellow'//char(0)

       title=name_data
       if(.not.b_data) then
        call stringlength(name_theory,i)
        if(icase.eq.1) title=name_theory(:i)//': @4 detector scan@ '
        if(icase.eq.2) title=name_theory(:i)//': omega scan'
        if(icase.eq.3) title=name_theory(:i)//': omega scan (3d)'
        if(icase.eq.4) title=name_theory(:i)//': theta1/theta2 (3d)'
        if(icase.eq.5) title=name_theory(:i)//': parallel scan'
       end if

       ISTEU=1
       BREITE=0.5
       HOEHE=0.6
       call stringlength(title,ntxt)
c       write(6,'(i4,a)')ntxt,title
       TEXT=title
       alpha=90.
       OP(0)=0.            ! no rotation around z-axis of inscription
       OP(1)=0.            ! phix
       OP(2)=0.            ! phiz
       OP(3)=0.            ! phiy
       OP(4)=10.            ! Xb
       OP(5)=10.            ! Yb
       OP(6)=0.0           ! Zb
       OP(7)=0.            ! strsx
       OP(8)=0.            ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

c       -------- omega axis -------------------------------
       OP(0)=1
       bsl=char(92)
       dbsl='$'//bsl
       form='f5.2'
       alpha=0.
       BREITE=0.4
       HOEHE=0.4
       TEXT=bsl//'gW'
       ntxt=3
       if(icase.eq.4)then
          TEXT=bsl//'gq$_1$ '
          ntxt=8
       end if
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=1.           ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-1.3*HOEHE   ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       BREITE=0.2
       HOEHE=0.25
       TEXT=bsl//'r   [mrad]'
       ntxt=11       
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=1.           ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-2.6*HOEHE   ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       BREITE=0.3
       HOEHE=0.3
       call trlnu(form,vxbeg,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=xbeg         ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=Xl           ! strsx
       OP(8)=-0.4*HOEHE   ! strsy      
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       call trlnu(form,vxend,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       OP(1)=-90.*rad     ! phix
       OP(2)=-90.*rad     ! phiz
       OP(3)=0.           ! phiy
       OP(4)=xend         ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-0.4*HOEHE   ! strsy      
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)

c      -------- theta axis -------------------------------

       ISTEU=1
       alpha=0.
       BREITE=0.4
       HOEHE=0.5
       TEXT=bsl//'gQ'
       ntxt=3
       if(icase.eq.4)then
         TEXT=bsl//'gq$_2$ '
         ntxt=8
       end if
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=0.87           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-1.6*HOEHE     ! strsx
       OP(8)=-Xl          ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

    
       BREITE=0.2
       HOEHE=0.25
       TEXT=bsl//'r   [mrad]'
       ntxt=11
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=1.           ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-3.5*HOEHE     ! strsx
       OP(8)=-Xl          ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       BREITE=0.3
       HOEHE=0.3
       call trlnu(form,vybeg,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=ybeg          ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-0.4*HOEHE   ! strsx
       OP(8)=0.0             ! strsy
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)


       call trlnu(form,vyend,chr,nn,chl,im)
       if(chr(nn:nn).eq.'0')nn=nn-1
       TEXT=chr(:nn)
       call TXTPLO(OP,-1,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=-90.*rad     ! phiy
       OP(4)=0            ! Xb
       OP(5)=yend         ! Yb
       OP(6)=0.           ! Zb
       OP(7)=-0.4*HOEHE   ! strsx
       OP(8)=-Xl          ! strsy
       call TXTPLO(OP,ISTEU,TEXT,nn,BREITE,HOEHE,alpha,Xl,Yl,Zl)

c      -------- z axis -------------------------------
       BREITE=0.21
       HOEHE=0.25
       if(log_mode)then
        i=0.8*int(xyzdz(6)+1.)
        ii=i/10
        jj=i-10*ii
        ch4=' '//char(jj+i0)//'.0'
        if(ii.gt.0)ch4(1:1)=char(ii+i0)
        TEXT='lg(counts)'
        ntxt=10
       else
        i=int(alog(xyzdz(6)+1.)/alog(10.))
        TEXT='counts[10$^'//char(i+i0)//'$ ]'
        ntxt=16
        form='f4.1'
        h=0.8*xyzdz(6)/10**i
        call trlnu(form,h,chr,nn,chl,im)       
        ch4=chl
       end if
       alpha=90.
       OP(0)=0.           ! no rotation around z-axis of inscription
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=0.           ! phiy
       OP(4)=-0.05        ! Xb
       OP(5)=-0.05        ! Yb
       OP(6)=0.4         ! Zb
       OP(7)=0.           ! strsx
       OP(8)=0.           ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       TEXT=ch4
       ntxt=4
       alpha=0.
       call TXTPLO(OP,-1,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       OP(0)=0.            ! no rotation around z-axis of inscription
       OP(1)=0.            ! phix
       OP(2)=0.            ! phiz
       OP(3)=0.            ! phiy
       OP(4)=0.            ! Xb
       OP(5)=0.            ! Yb
       OP(6)=0.75           ! Zb
       OP(7)=0.            ! strsx
       OP(8)=-Xl-0.4*HOEHE ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)

       if(log_mode)then
        i=int(scmin)
c        write(6,'(a,i4)')'  log mode i=',i
         jj=abs(i)
         ch4='-'//char(jj+i0)//'.0'
         ii=10*(abs(scmin)-jj)
         ch4(4:4)=char(ii+i0) 
        if(i.lt.0) then       
         TEXT=ch4
         ntxt=4
        else
         ch4(1:1)=' '
         TEXT=ch4(2:4)
         ntxt=3
        end if
       alpha=0.
       OP(0)=0.           ! no rotation around z-axis of inscription
       OP(1)=0.           ! phix
       OP(2)=0.           ! phiz
       OP(3)=0.           ! phiy
       OP(4)=0.           ! Xb
       OP(5)=0.           ! Yb
       OP(6)=0.02         ! Zb
       OP(7)=0.           ! strsx
       OP(8)=-XL-0.4*BREITE ! strsy
       call TXTPLO(OP,ISTEU,TEXT,ntxt,BREITE,HOEHE,alpha,Xl,Yl,Zl)
       end if



c       write(6,'(a,8g12.6)')' min-max=',
c     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)
     

c      write(6,'(8f10.3)')(vtxtx(i),i=1,ltext(2))
c      write(6,'(a,2f10.3)') ' X2,Y2=',X2,Y2
c     fill in test data
      return

 1000 continue

       i_angle=0
       i_angp1=0
       do i_theta=1,n_theta
        theta=theta_beg+dtheta*(i_theta-1)
        do k_omega=1,n_omega        
         omega=omega_beg+domega*(k_omega-1)
         
         if(icase.eq.2.or.icase.eq.3) then
            grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta
            grazout=2*omega_beg+domega*(n_omega-1)+
     &        (i_theta-1)*dtheta*2-grazinc
         else if(icase.eq.5) then
c         PHI_s=omega N_s=n_omega
          j=i_theta/2
          if(2*j.eq.i_theta) then
c          + dTheta_out
           grazinc=omega
           grazout=(omega+dtheta*j)
          else
c          + dTheta_out
           grazinc=(omega+dtheta*j)
           grazout=omega
          end if
          if(omega+dtheta*j.gt.omega_end)goto 777
         end if
         i_angle=i_angle+1   
         i_angp1=i_angp1+1
              
         if(.not.b_showangles)then
          h=real_fr(2*nstorTH+i_angle)*counts+background
          if(log_mode)then
            plotyy(i_angp1)=alog10(h)
          else
           plotyy(i_angp1)=h
          end if
          plotxx(i_angp1)=i_angp1
         end if
 777     continue
        end do     ! n_omega
        i_angp1=i_angp1+1
        plotxx(i_angp1)=i_angp1
        plotyy(i_angp1)=-1.
        nchanplot(5)=i_angp1
       end do     ! n_theta


c      write(6,'(2f12.2)') (real_fr(mfpt+j),real_fr(2*nstorTH+j),j=1,12)
      if(log_mode)then
       abscissa='channel'
       axisformat(1)='%5.1f '
       ordinata='lg(counts)'
       axisformat(2)='%12.2f '
      else
       abscissa='channel'
       axisformat(1)='%5.1f '
       ordinata='counts'
       axisformat(2)='%12.2f '
      end if

      xyzdz(1)=1
      xyzdz(2)=0.
      xyzdz(3)=1.e10
      xyzdz(4)=0.

      if(b_data) then 
       if(log_mode)then
        ny=0     
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k),isd
          ny=ny+1
          plotx(ny)=j
          if(real_fr(mfpt+j).lt.1.0) then
           ny=ny-1
          else
           ploty(ny)=alog10(real_fr(mfpt+j))
           ploterry(ny)=real_fr(mdfpt+j)/(real_fr(mfpt+j)+1)
c          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)
          end if
         end do
        end do
        nchanplot(1)=ny
       else
        ny=0     
        do k=2,ichanks(0),2
         do j=ichanks(k-1),ichanks(k),isd
          ny=ny+1
          plotx(ny)=j
          if(real_fr(mfpt+j).lt.0.0) then
           ny=ny-1
          else
           ploty(ny)=real_fr(mfpt+j)
           ploterry(ny)=real_fr(mdfpt+j)
c          write(6,'(2i6,a,4g12.6)')ny,j,' ploty(ny)=',ploty(ny)
          end if
         end do
        end do
        nchanplot(1)=ny
       end if
       xyzdz(1)=1
       xyzdz(2)=ny
       damax=0.
       do i=1,ny
        if(ploty(i)+ploterry(i).gt.damax)damax=ploty(i)+ploterry(i)
       end do
       if(damax.gt.xyzdz(4))xyzdz(4)=damax
       do i=1,ny
        if(ploty(i)-ploterry(i).lt.damax)damax=ploty(i)-ploterry(i)
       end do
       if(damax.lt.xyzdz(3))xyzdz(3)=damax
      end if   ! b_data


      if(b_showangles.and..not.b_data) then
       xyzdz(3)=-0.1
       xyzdz(4)=1.0
      end if


      thmax=-1.e10
      if(.not.b_showangles)then
       jj=nchanplot(5) 
       do i=1,jj
        if(plotyy(i).gt.thmax)thmax=plotyy(i)
       end do
       if(thmax.gt.xyzdz(4))xyzdz(4)=thmax
       xyzdz(2)=jj
       do i=1,jj
        if(plotyy(i).lt.thmax)thmax=plotyy(i)
       end do
       if(thmax.lt.xyzdz(3))xyzdz(3)=thmax
      end if
c       write(6,'(i6,a,8g12.6)')nchanplot(5),' min-max=',
c     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4),xyzdz(5),xyzdz(6)


      axesname(1)=abscissa
      axesname(2)=ordinata
      axesname(3)=' '
      title=name_data
      if(.not.b_data) title=name_theory

       bgcolor='Ivory'//char(0)     ! color background  (0...) [0]
       fgcolor='black'//char(0)
       datacolor=fgcolor
       thcolor=fgcolor
       rescolor='blue'//char(0)
       do j=1,maxsub
        ncolor(j)=icolor_sub(j)
       end do

       logx=0
       logy=0
       if(b_logx)logx=1
       logf=0
       if(b_logy)logf=1

c      definitions taken from allplo
       chx='B'                 ! (none,Both,bottom,top)  [B]
       chbx='n'                ! (none,bottom,top)  [n]
       chlr='l'                ! (left,right)  [r]
       chy='r'                 ! (none,Both,left,right)  [B]
       chby='r'                ! (none,left,right)  [r] 
       chbt='b'                ! (bottom,top)  [t]
       chh=0.3                 ! 
       chw=0.25                ! character cw,ch  [0.40,0.40]         
       syw=0.1                 !
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]
       frcolor=fgcolor         ! color frame       [black]
 
       CTEXT=title
       CXTEXT=abscissa
       CYTEXT=ordinata

       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,
     &            chh,chw,syw,syh,
     &            CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)
 

c      write(6,'(a,i5)') ' rdplpu3d nchannel=',nchannel
c       write(6,'(a,4g12.6)')' b min-max=',
c     &       xyzdz(1),xyzdz(2),xyzdz(3),xyzdz(4)
c      write(6,'(8f10.4)') (plotxx(ii),ii=1,nchannel)
c      write(6,'(8f10.4)') (plotyy(ii),ii=1,nchanplot(5))
c      write(6,'(8f10.4)') (ploterry(ii),ii=1,nchannel,16)

      return
      end

      subroutine syn_selsubset(text)

      include 'comglb.for'
      include 'complt.for'
      integer       i_array,iiarr
      real          r_array
      character     c_array*4
      parameter (iiarr=mi_scrd-maxscr)
      common/scrd/ npanum(maxscr),i_array(iiarr),
     &             r_array(mr_scrd),c_array(mc_scrd)

      integer     istruct0,mstruct1,istruct1,istruct2,
     &            l1_get,l2_get,l3_get,l1_put,l2_put,l3_put
      character*4 c1_prp,c2_prp,c3_prp,frthname*64
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),
     &              l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),
     &              l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),
     &              c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),
     &              frthname(2),istruct0(32)

      real      out(32)
      character ch132*132,cp132*132,htext*40,chp*4,chs*4

      logical b_inc

      character text(3)*40,chcom*132,ch1*1,ch2*2

      save

      i0=ichar('0')
c     mlay : number of layers
      if(mstruct1.gt.1) then
       htext=text(2)
       i=24
       do while(htext(i:i).eq.' ')
        i=i-1
       end do
       i=i+2

       do lstruct1=1,mstruct1
        j=0
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1)
         j=j+1
         lay=lstruct2
         is_a=istruct2(lay-1)+1
         is_e=istruct2(lay)
         ii=is_e-is_a
         if(j.eq.1) then
          if(ii.gt.0) then
           write(nwr,'(5x,a,i2,a,i2,a2,a,i2,a,i2)')
     &     htext(:i),lstruct1,'    layer(',lay,'):',
     &    '    sites from ',is_a,' to ',is_e
          else
           write(nwr,'(5x,a,i2,a,i2,a2,a,i2)')
     &     htext(:i),lstruct1,'    layer(',lay,'):','  with site ',is_a
          end if
         else
c         i+5+2 
          i10=(i+7)/10
          i1=i+7-10*i10
          ch2=char(i10+i0)//char(i1+i0)          
          if(ii.gt.0) then
           write(nwr,'('//ch2//'x,a,i2,a2,a,i2,a,i2)')
     &     '    layer(',lay,'):','    sites from ',is_a,' to ',is_e
          else
           write(nwr,'('//ch2//'x,a,i2,a2,a,i2)')
     &     '    layer(',lay,'):','  with site ',is_a
          end if

         end if
        end do
       end do
       b_inc=.true.
      else
       mlay=istruct1(mstruct1)
       iset_e=0
       iset_a=maxthss
       do lay=1,mlay
        is_a=istruct2(lay-1)+1
        is_e=istruct2(lay)
        htext=text(1)
        if(is_a.lt.iset_a) iset_a=is_a
        if(is_e.gt.iset_e) iset_e=is_e
        if(is_e.ge.is_a)
     &      write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',
     &      htext(1:24),' sites from ',is_a,' to ',is_e
       end do
       if(istruct2(mlay).lt.2) then
        write(nwr,'(a)') '**  there are no sub-spectra ** '
        return
       end if
       b_inc=.false.
      end if


  809 continue
      if(b_inc) then
       write(nwr,'(/,a,a)') ' sub-spectrum_j',
     & ' of incoherent parts(ji) of the scatterer sites(ki).',
     &    ' Number j (h-ide), p*art=j1...jn  s*ite=k1...kn'
      else
       write(nwr,'(/,a,a)') ' sub-spectrum_j',
     & ' of the scatterer. Number j (h), site: k1...kn'
      end if

  810  i=1
       n_subset=0
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0)
        ch1=' '
        j_int=n_int(i,0)
        if(j_int.lt.0) ch1='h'
        j_int=abs(j_int)
        if(b_inc) then
         jj=1
         do while(n_int(i,jj).gt.maxthss)            ! ?? 5.3
          jj=jj+1
         end do
         j_intp=jj-1
c         write(6,'(a,4i4)')'select j_intp,j_int=',j_intp,j_int
         jj=j_int-j_intp
         if(jj.gt.9) then
          i10=jj/10
          i1=jj-10*i10
          chs=char(i10+i0)//char(i1+i0)//'i4'
         else
          chs=char(jj+i0)//'i4'
         end if
         chp=char(j_intp+i0)//'i4'
         ch2='i1'
         if(i.gt.9) ch2='i2'
c         write(6,'(a,4(2x,a))')'select chs,chp,ch2=',chs,chp,ch2
         write(nwr,'(a,'//ch2//'a1,a,'//chp//',a,'//chs//')')
     &   ' sub-spectrum_',i,ch1,
     &   ' part=',(n_int(i,jj)-2*maxthss,jj=1,j_intp),       ! ?? 5.3
     &                  ' site=',(n_int(i,jj),jj=j_intp+1,j_int)
        else
         jj=j_int
         if(jj.gt.9) then
          i10=jj/10
          i1=jj-10*i10
          chs=char(i10+i0)//char(i1+i0)//'i4'
         else
          chs=char(jj+i0)//'i4'
         end if
         ch2='i1'
         if(i.gt.9) ch2='i2'
c         write(6,'(a,4(2x,a))')'select chs,ch2=',chs,ch2
         write(nwr,'(a,'//ch2//'a1,a1,'//chs//')')
     &   ' sub-spectrum_',i,ch1,' ',(n_int(i,jj),jj=1,j_int)
        end if

        if(ch1.eq.' ') n_subset=i
        i=i+1
        if(i-1.eq.maxsub) goto 811
       end do
 811   n_ssub=i-1

  820  read(nrd,'(a)') ch132
       call lc_character(ch132)
       if(ch132(1:2).eq.'he') then
        i=index(frthname(1),' ')
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/input'
        call help(chcom)
        goto 809
       end if
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then
        if (ch132(1:1).eq.'#') goto 810
        call nextchar(ch132,0,ipos,cp132,ii)
        call nextchar(cp132,ii,ipos,ch132,ia)
         
        call trlch(80,cp132,iout,out)
        iset=out(1)
        if(iset.gt.maxsub) then
          write(nwr,'(a,i3)') ' maximal number of sub-spectra ',maxsub
          goto 810
        end if
        if(iout.lt.1) then
          write(nwr,'(a)')
     &    ' q*uit or * to leave command ss'
          goto 820
        end if
        if(iout.eq.1) then
         if(ch132(1:1).eq.'h') then
          if(n_int(iset,0).lt.0) then
           n_int(iset,0)= abs(n_int(iset,0))
           do j=maxsub,2,-1
            do ji=0,maxthss
             n_int(j,ji)=n_int(j-1,ji)
            end do
           end do
           if(iset.lt.maxsub) then
            do ji=0,maxthss
             n_int(1,ji)=n_int(iset+1,ji)
             n_int(iset+1,ji)=0
            end do
           end if
          else
           n_int(iset,0)=-abs(n_int(iset,0))
           if(iset.lt.n_ssub) then
            j=n_ssub+1
            do ji=0,maxthss
             n_int(j,ji)=n_int(iset,ji)
             n_int(iset,ji)=0
            end do
           end if
           goto 840
          end if
         end if
c        remove a sub-spectrum
         if(ch132(1:2).eq.'rm') then
          if(iset.lt.maxsub) then
           do j=iset,maxsub-1
            do ji=0,maxthss
             n_int(j,ji)=n_int(j+1,ji)
            end do
           end do
          end if
          do ji=0,maxthss
           n_int(maxsub,ji)=0
          end do
c          write(6,'(8i3)')n_int
         end if
        end if

c       write(6,'(a,10i4)') ' 1 out=',(int(out(j)),j=1,iout)

c         write(6,'(2a)')'select ch132=',ch132(:60)
        ig1=index(ch132,'=')
        ig2=index(ch132(ig1+1:),'=')+ig1
        cp132=ch132(ig1+1:ig1+3)
c         write(6,'(a,2i4)')'select ig1,ig2=',ig1,ig2

        if(b_inc.and.(ig1.eq.0.or.ig2.eq.0)) then
         write(nwr,'(a)')
     &    '**** at least one part(=) and one scatterer site(=)'
          goto 820
        end if
        if(.not.b_inc) then
         max=iset_e-iset_a+1
c         write(6,'(a,2i4,2x,a)')'select iset_e,iset_a,ch132=',
c     &                  iset_e,iset_a,ch132(:40)
         call panum(ch132,max,1)
         iout=npanum(2)
         if(iout.ge.1) then
c         write(6,'(a,10i4)') ' 2 out=',(int(out(j)),j=1,iout)
          n_int(iset,0)=0
          jscatterer=0
          do j=1,iout
           nn=npanum(j+2)
           if(nn.gt.is_e) then
            write(nwr,'(a,i5,a)') ' ***',nn,' is not a site'
           else
            if(jscatterer.lt.maxss) then
             jscatterer=jscatterer+1
             n_int(iset,jscatterer)=nn
            else
             write(nwr,'(a,i5,a)') ' *** maximum number',maxthss,
     &                            ' of sites reached'
            end if
           end if
          end do
          n_int(iset,0)=jscatterer
          if(jscatterer.eq.0) then
           write(nwr,'(a)')
     &     '****  at least one site of the scatterer'
           goto 820
          end if
         end if
        else
c         write(6,'(2a)')'select ch132=',ch132(:60)
c         write(6,'(2a)')'select cp132=',cp132(:60)
         max=mstruct1
         call panum(cp132,max,1)
         iout=npanum(2)

         if(iout.eq.0) then
          write(nwr,'(a)')
     &    '****  at least one incoherent part of the scatterer'
          goto 820
         end if

         n_int(iset,0)=0
         j_intp=0
         do j=1,iout
          nn=npanum(2+j)
          if(nn.gt.mstruct1) then
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a part'
          else
           j_intp=j_intp+1
           n_int(iset,j_intp)=nn+2*maxthss                       ! ?? 5.3
c           maxss -> mathss 7.5.2007
          end if
         end do


         cp132=ch132(ig2+1:)
         lay=istruct1(mstruct1)
         is_e=istruct2(lay)
         max=is_e
         call panum(cp132,max,1)
         iout=npanum(2)
         if(iout.eq.0) then
          write(nwr,'(a)')
     &    '****  all sites of the incoherent parts are taken'
          iout=0
          do j=1,j_intp
           jj=n_int(iset,j)-2*maxthss                           ! ?? 5.3
c           maxss -> mathss 7.5.2007
           layb=istruct1(jj-1)+1
           laye=istruct1(jj)
           iout=iout+2
           npanum(2+2*j-1)=-istruct2(layb-1)-1
           npanum(2+2*j)=-istruct2(laye)
          end do
         end if
         j_int=0
         do j=1,iout
          nn=npanum(j+2)
          if(nn.gt.is_e) then
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a site'
          else
           if(j_int+j_intp.lt.maxthss) then                   ! ?? 5.3
            j_int=j_int+1
            n_int(iset,j_intp+j_int)=nn
           else
           write(nwr,'(a,i5,a)') ' *** maximum number',maxss-j_intp,
     &                            ' of sites reached'
           end if
          end if
         end do
         n_int(iset,0)=j_intp+j_int
        end if
c        write(6,'(a,10i4)')'n_int(1,0)=',(n_int(1,ji),ji=0,5)
         jj=n_ssub
         do i=1,maxsub-1
          if(n_int(i,0).lt.0.and.n_int(i+1,0).gt.0) then
           jj=jj+1
           if(jj.le.maxsub) then
            do ji=0,maxthss
             n_int(jj,ji)=n_int(i,ji)
            end do
           else
            do ji=0,maxthss
             n_int(i,ji)=0
            end do
           end if
          end if
         end do
         do i=1,maxsub
          if(n_int(i,0).eq.0) then
           do j=i,maxsub-1
            do ji=0,maxthss
             n_int(j,ji)=n_int(j+1,ji)
            end do
           end do
          end if
         end do
         goto 810
       end if  ! * out

 840  continue
      return
      end


      subroutine syn_subset(m1,m3,cmch,isub,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'complt.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'

      integer    m1,m3,isub,info,
     &           ifrth,idex,istr,dstr,iaddr,nTH1
      character frthname*64
      parameter (istr=6+4*(maxfr1+maxfr2)+3*maxthss)
      common/struct/dstr(istr),frthname(2),
     &              iaddr(8),nTH1,ifrth(7),idex(16)          !13.9.05

      integer   idumscrt,idumsc,max4
      parameter(max4=max8/2, idumscrt=maxscrt-max4*maxsub-5*max4)
      real        datx,errx,sym,subspectrum,daty,erry
      common/scrt/datx(max4),errx(max4),sym(max4),
     &            subspectrum(max4,maxsub),
     &            daty(max4),erry(max4),idumsc(idumscrt)

      real           dum,channels,dumcsp
      common/acstrf/dum(9),channels,dumcsp(icstrf-10)

      integer   ib_df,kana,ibmisfit
      real      thfk,dfdp,ddpk
      common/fr2fi/thfk(max8),dfdp(max8),ddpk,ib_df,kana,ibmisfit

      character cmch*4
      real      plold,plold1,plold3,p0
      dimension plold(maxthss),plold1(maxthss),plold3(maxthss)

      integer  i,ip,ia,ie,j,jj,k,k1,l,ll,llm,lj,n1,nexp,nthe
 
c      write(6,'(a,a)') '*********subroutine syn_subset********',cmch


       nexp=channels
       nthe=nTH1*2

      if(cmch.eq.'subs') then
       call calpl('test')

       do  i=1,m1
        plold1(i)=0.
       end do
       do  i=1,m3
        plold3(i)=0.0
       end do

       do  i=1,m1
        j=-(2*maxthss+i)
        call replace_wi(j,plold1(i),info)  ! - take out and write on plold(i)
       end do
       do  i=1,m3
        call replace_wi(-i,plold3(i),info)  ! - take out and write on plold(i)
       end do
c       write(6,'(a,10f8.2)')'frame02 plold1()=',(plold1(i),i=1,m1)
c       write(6,'(a,10f8.2)')'frame02 plold3()=',(plold3(i),i=1,m3)

       do  l=1,n_subset
        p0=0.0
        do  i=1,m1
         j=2*maxthss+i
         call replace_wi(j,p0,info)  ! + write 0 to wi values
        end do

        llm=n_int(l,0)
        ll=0
        do while(ll.lt.llm.and.n_int(l,ll).gt.0)
         ll=ll+1
        end do

c        write(6,'(a,2i4)')' frame02 ll,llm=',ll,llm
        if(ll.eq.llm.and.n_int(l,llm).gt.0) then
         do  i=1,m3
          call replace_wi(i,p0,info)  ! + write 0 to wi values
         end do
        end if
c      write(6,'(a,i4,a,5i4)')' l_subsp=',l,
c     &         ' n_int(l,ll)=',(n_int(l,ll),ll=1,4)
        ll=1
        do while(ll.le.llm.and.n_int(l,ll).gt.0 )
         ip=n_int(l,ll)
         if(ip.gt.maxthss) then
          i=ip-2*maxthss
c          write(6,'(a,2i4,f10.3)')'frame02 ip,plold1(i)=',ip,i,plold1(i)
          call replace_wi(ip,plold1(i),info)  ! + write plold(ip) to wi values
         else
c          write(6,'(a,2i4,f10.3)')'frame02 ip,plold3(i)=',ip,i,plold3(i)
          call replace_wi(ip,plold3(ip),info)  ! + write plold(ip) to wi values
         end if
         if(ll.eq.llm) goto 10 
         ll=ll+1
        end do
 10     continue
c       ll le llm is now guaranteed      8.2.06

        if(ll.lt.llm) then
         do lj=ll,llm,2
          ia=-n_int(l,lj)
          ie=-n_int(l,lj+1)
          do ip=ia,ie
c          write(6,'(a,i4,f10.3)')'frame02 ip,plold3(ip)=',ip,plold3(ip)
           call replace_wi(ip,plold3(ip),info)
          end do
         end do
        end if

        k1=3
        call syn_the2exp(k1,info)

        j=nexp
        if(ndisplay_mode.eq.1)j=nthe
         do  i=1,j
          subspectrum(i,l)=thfk(i)
         end do
c        end if
       end do

       do  i=1,m1
        j=2*maxthss+i
        call replace_wi(j,plold1(i),info)  ! + write plold(jj) to wi values
       end do
       do  i=1,m3
        call replace_wi(i,plold3(i),info)  ! + write plold(jj) to wi values
       end do
      end if  !  cmch=subs,test



      if(cmch.eq.'subt') then
c     write(6,'(a,i4)') ' ********** m1=',m1

       call calpl('test')
        do  i=1,m1
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold(i)
       end do
c      write(6,'(a,i2,a2,f15.5)') ' plold(',i,')=',plold(i)

c      subtract y - yy

c      absorber complete , source and detector window subtracted


       nexp=channels
       do k=1,nexp
        daty(k)=real_fr(mfpt+k)
       end do

       p0=0.0
       do j=1,isub
        do i=1,m1
         call replace_wi(i,p0,info)  ! + write 0 to wi values
        end do

        do i=1,n_sub(j,0)
         jj=abs(n_sub(j,i))
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
        end do

        k1=3
        call syn_the2exp(n1,info)

c      write(6,'(a)') ' ------1----back in subtract----------------'

        do i=1,nexp
         daty(i)=daty(i)-thfk(i)
        end do
       end do  ! isub

c      calculation of the theory of the stripped spectrum
       p0=0.0
       do i=1,m1
        call replace_wi(i,p0,info)  ! + write 0.0 to wi values
       end do

       do i=1,n_sub(0,0)
        jj=n_sub(0,i)
        call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi values
       end do

       k1=3
         ! values are not reset by calpl, written on theory-array
       call syn_the2exp(k1,info)

c      write(6,'(a)') ' ------2----back in subtract----------------'
c      restore parameters
       call calpl('test')
      end if    ! cmch='subt'

      k1=3
      call syn_the2exp(k1,info)

      return
      end


 


      SUBROUTINE INDEXi(N,IRRIN,INDX)
      DIMENSION IRRIN(N),INDX(N)
      DO 11 J=1,N
        INDX(J)=J
11    CONTINUE
      L=N/2+1
      IR=N
10    CONTINUE
        IF(L.GT.1)THEN
          L=L-1
          INDXT=INDX(L)
          Q=IRRIN(INDXT)
        ELSE
          INDXT=INDX(IR)
          Q=IRRIN(INDXT)
          INDX(IR)=INDX(1)
          IR=IR-1
          IF(IR.EQ.1)THEN
            INDX(1)=INDXT
            RETURN
          ENDIF
        ENDIF
        I=L
        J=L+L
20      IF(J.LE.IR)THEN
          IF(J.LT.IR)THEN
            IF(IRRIN(INDX(J)).LT.IRRIN(INDX(J+1)))J=J+1
          ENDIF
          IF(Q.LT.IRRIN(INDX(J)))THEN
            INDX(I)=INDX(J)
            I=J
            J=J+J
          ELSE
            J=IR+1
          ENDIF
        GO TO 20
        ENDIF
        INDX(I)=INDXT
      GO TO 10
      END




      subroutine channels_adjust(nvch,nhyperfine,nstrob_order,nomega,
     &                           iall)
c       the routine calculates channels needed for a nonequidistant
c       channel numbers for all later shifts +- nomega in the stoboscopic 
c       integration
c       iall is limited by maxn -> -maxn:maxn are the size of arrays
        include 'comglb.for'
        integer nvch,nhyperfine,nstrob_order,nomega,iall,ichall,
     &          inp,IRRIN,INDX,idumscrd
        parameter(nn=16*maxn)
        dimension ichh(0:nn),inp(-nn:nn),IRRIN(nn),
     &            INDX(nn)
        common/scrd/ichall(0:maxn*2),idumscrd(maxscrd-1-maxn*2)
        equivalence (idumscrd(1),ichh(0)),(idumscrd(nn+2),inp(-nn)),
     &     (idumscrd(3*nn+3),IRRIN(1)),(idumscrd(4*nn+3),INDX(1))
       iall=0  
       DO n=0,nstrob_order  
c       +-m =2m eqidistant steps,
        kom=n*nomega/2
         mcht=kom+nhyperfine
         do i=0,mcht
          inp(i)=i
         end do
         do i=1,mcht
          inp(mcht+i)=i+kom
         end do
         j=2*mcht+1
         do i=kom,mcht
          inp(j+i)=i-kom
         end do
         j=3*mcht-kom+1
         do i=1,nvch
          inp(j+i)=mcht+i*(i+1)/2+kom
         end do
         j=3*mcht-kom+1+nvch
         do i=1,nvch
          inp(j+i)=mcht+i*(i+1)/2-kom
         end do

         j=3*mcht-kom+1+nvch*2
         if(iall+j.gt.nn) then
          iall=-iall-j
          return
         end if
         do i=0,j
          IRRIN(i+1+iall)=inp(i)
         end do 
         iall=iall+j+1
         call INDEXi(iall,IRRIN,INDX)
         do k=1,iall
          ichh(k)=IRRIN(INDX(k))
         end do
c         print '(a )', 'before             elimination'
c         print '(20i5)',(ichh(i),i=1,iall)
c         print '(20i5)',(ichh(i),i=1,iall/2)
c         print '(20i5)',(ichh(i),i=iall/2+1,iall)
c         print '(20i5)',n,kj,m,nomega,nvch

         k=0
c        elimination of multiple indices
  400    k=k+1
         if(ichh(k).eq.ichh(k+1))then
          iall=iall-1
          do kk=k+1,iall
           ichh(kk)=ichh(kk+1)
          end do
          k=k-1
          ichh(iall+1)=0
         end if
         if(k.lt.iall-1) goto 400
         do i=1,iall
          IRRIN(i)=ichh(i)
         end do
c        print '(a )', 'after elimination'
c        print '(20i5)',(ichh(i),i=1,iall)
c        read(5,'(a)')
c        end do  ! +-nomega
c        write(6,'(a,i7)')' after  iall=',iall
        
c         write(6,'(a,i7)')'after iall=',iall
         close(unit=11)
       END DO  !for all nStrobo
c       print '(" order  ")'
c       print '(" iall,nvch,nhyperfine= ",5i6)',iall,nvch,nhyperfine
       ichall(0)=0
       if(iall.le.2*maxn)then
        do k=1,iall
         ichall(k)=ichh(k)
        end do
       else
        iall=-iall
       end if
c       write(6,'(18i4)')(ichall(k), k=1,iall)
       return
       end


      subroutine ot_theo(i_3d,ab_the,iaset,xb_the,dx_the,yb_the,dy_the)
      implicit none
      include 'comglb.for'
      include 'comthe.for'
     
      real        ab_the,xb_the,dx_the,yb_the,dy_the
      dimension   ab_the(128)
      integer     i_3d,icase,iaset,istruct1,istruct2,l1_get,
     &            mstruct1,nstorTH,nTH1,iaddr,idex,istr,idum
      dimension   iaset(128)
c                  istruct=2+4*maxfr1+4+4*maxfr2+3*maxthss+32+8+8+16,
      parameter   (istr=3*maxfr2+3*maxthss+2*(maxfr1+1)+32)
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     
     &              l1_get(0:maxfr1),idum(istr),
     &              nstorTH,iaddr(7),nTH1,idex(23)
      integer     k_omega,n_omega,i_theta,n_theta,i_angle,j,ig
      real        omega,omega_beg,domega,omega_end,grazinc,grazout,
     &            theta,theta_beg,dtheta,theta_end
      integer*4   idscrd,iscrd
      integer     jth
      parameter (iscrd=maxscrd-128*128)
      common/scrd/jth(-3:124,-3:124),idscrd(iscrd)

c      n_theta,theta_beg,dtheta,n_omega,omega_beg,domega
       icase=int(real(array_fr(l1_get(0)+1)))
       n_omega=int(real(array_fr(l1_get(0)+2)))
       n_theta=int(aimag(array_fr(l1_get(0)+2)))
       omega_beg=real(array_fr(l1_get(0)+3))
       domega=aimag(array_fr(l1_get(0)+3))
       theta_beg=real(array_fr(l1_get(0)+4))
       dtheta=aimag(array_fr(l1_get(0)+4))
       omega_end=real(array_fr(l1_get(0)+5))
       theta_end=aimag(array_fr(l1_get(0)+5))

c       write(6,'(6f10.1)')(array_fr(l1_get(0)+j),j=1,5) 
     
       nstorTH=l1_get(0)+6             ! see th_scanmode()
       nTH1=real(array_fr(l1_get(0)+6))
c       write(6,'(a,3f10.1)')'fr_synmos array_fr=',array_fr(l1_get(0)+6)
c       write(6,'(a,i4,4x,3f10.4)')
c     &  'n_theta,theta_beg,dtheta,theta_end=',
c     &   n_theta,theta_beg,dtheta,theta_end
c       write(6,'(a,i4,4x,3f10.4)')
c     &   'n_omega,omega_beg,domega,omega_end=',
c     &   n_omega,omega_beg,domega,omega_end

      do i_theta=-3,124
      do k_omega=-3,124
       jth(i_theta,k_omega)=0
      end do
      end do

      i_3d=0
      if(icase.eq.3) i_3d=1
      if(icase.eq.4) i_3d=-1 

      iaset(1)=0
      i_angle=0
      do i_theta=1,n_theta
       theta=theta_beg+dtheta*(i_theta-1)
       ig=0
       do k_omega=1,n_omega        
        omega=omega_beg+domega*(k_omega-1)

        if(icase.eq.1.or.icase.eq.4) then
          grazinc=omega
          grazout=theta
        else if(icase.eq.2.or.icase.eq.3) then
           grazinc=omega_beg+domega*(k_omega-1)+(i_theta-1)*dtheta
           grazout=2*omega_beg+domega*(n_omega-1)+
     &       (i_theta-1)*dtheta*2-grazinc
        else if(icase.eq.5) then
c        PHI_s=omega N_s=n_omega
         j=i_theta/2
         if(2*j.eq.i_theta) then
c         + dTheta_out
          grazinc=omega
          grazout=(omega+dtheta*j)
         else
c         + dTheta_out
          grazinc=(omega+dtheta*j)
          grazout=omega
         end if
         if(omega+dtheta*j.gt.omega_end)goto 77
        end if
        i_angle=i_angle+1   
        jth(k_omega-1,i_theta-1)=i_angle
 
        ig=ig+1
        if(ig.eq.1)then
         ab_the(i_theta)=grazinc
        end if

 77     continue
c       write(6,'(a,3i6)')'ot ',i_angle,k_omega-1,i_theta-1       
       end do     ! n_omega
       iaset(i_theta+1)=i_angle
       end do     ! n_theta
       xb_the=omega_beg
       dx_the=domega
       yb_the=theta_beg
       dy_the=dtheta
c       write(6,'(a,4f12.2)')'xb_the,dx_the,yb_the,dy_the=',
c     &      xb_the,dx_the,yb_the,dy_the
       return
       end



       subroutine opticN(mlay,b_Cm,MAXGRP,GEOSTR,SFI,
     &                      Kmatrix,roughlay,VKD,Rmatrix)
C
C ******************************************************************    
C
C                              OPTICS
C
C          Reflectivity calculation of anisotropic multilayers
C          in the Mossbauer case. 1mrad<FI<10mrad, K~1.E-5. 
C
C          (method of G. H. Borzbov et. al. - L. Deak et. al.)
C
C                         Laszlo Deak
C
C                         Budapest, 1995. July
C                         Mainz, 2002. October
C
C                         Khaidukov Yuri
C	                  Budapest, 2003. April-May
C
C ***************************************************************** 
C
C Geometry:
C
C
C               incident        reflected                    
C                          
C                        \    /    
C                         \  /
C                      FI (\/
C      Z=0>           -------------  
C           covering  _____________         [D(1),K(1,I,J)]  
C                                  >Layer#1 [D(2),K(2,I,J)]
C                 1.  .............     
C                           .
C                           .
C                     .............
C Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]
C       I              
C          substrate  _____________         [D(NL),K(NL,I,J)]
C                            `                 ^
C                              `            infinit or finit
C                             refracted
C
C 
C  Variables of system:
C
C  INPUT:
C
C                           covering   layer #L     substrate
C
C            thickneses:         D(1)     D(L)        D(NL)
C
C        susceptibility:
C          (nuclear+electronic)
C                                K(1)     K(L)        K(NL)
C
C         where  L=1..NL  I,J=1,2,3 
C
C  OUTPUT:
C
C         The 2x2 complex reflectivity (or transmitivity) matrix:  R
C
C ******************************************************************
c       subroutine optic(b_ew,mlay,b_Cm,MAXGRP,GEOSTR,SFI,Kmatrix,
c     &                      chilay,roughlay,VKD,Rmatrix)
C
C       
C
       implicit none
C   input:
       logical    b_Cm
       integer    mlay,MAXGRP,GEOSTR
       real*8     SFI,roughlay,VKD
       complex*16 Kmatrix 
       dimension  b_Cm(mlay),GEOSTR(0:2*MAXGRP),Kmatrix(2,2,mlay),
     &            roughlay(mlay),VKD(mlay)


C      NL=mlay: number of layers  (in period)( not expicitly used)
C      output:       Rmatrix(2,2)
       complex*16 Rmatrix(2,2)
C      other variables:
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,Lprev,POINTER,NLOG
       real*4     absCmatr,absMatr
       real*8     DL 
       complex*16 C0,C1,CI,M(4,4),ML(4,4),MS(4,4),KL(2,2),
     &            KLprev(2,2)
       logical    b_odz,b_first,b_grp,both_dgnl,prev_dgnl
c--------------------------------------------------------------------
       parameter  (C0=(0.D0,0.D0), C1=(1.D0,0.D0), CI=(0.D0,1.D0))

c      print *,b_Cm	 
c      print *,SFI
c      print *,MAXGRP
c      print *,GEOSTR
c      print *,chilay
c      print *,VKD

       b_first     =.true.
       POINTER=0                                     
       do GRP=1,MAXGRP      ! loop for the groups
C       To set the characteristic matrix to unit matrix
        do I=1,4
         do J=1,4
          ML(I,J)=C0
         end do
         ML(I,I)=C1
        end do

        b_grp=.false.
C
        LMIN =POINTER+1
        LMAX =POINTER+GEOSTR(2*GRP)
        n_rep=GEOSTR(2*GRP-1)
C
        do L=LMIN,LMAX
         DL=VKD(L)
         if(DL.ne.0.) then
          if(DL.lt.0)DL=1.0d30
          b_odz=.false.
          b_grp=.true.
          if(b_Cm(L))then
           KL(1,1)=Kmatrix(1,1,L)
           KL(1,2)=Kmatrix(1,2,L)
           KL(2,1)=Kmatrix(2,1,L)
           KL(2,2)=Kmatrix(2,2,L)

           absCmatr=dreal( KL(1,2)*conjg( KL(1,2))+
     &                    KL(2,1)*conjg( KL(2,1)))
           if(absCmatr.lt.1.e-15) b_odz=.true.
          else
           KL(1,1)=Kmatrix(1,1,L)
           KL(1,2)=Kmatrix(1,2,L)
           KL(2,1)=Kmatrix(2,1,L)
           KL(2,2)=Kmatrix(2,2,L)
           b_odz=.true.
          end if          

          call genM(b_odz,SFI,DL,KL,M)   
c        if(b_ew) write(6,'(a)') 'genM'
c        if(b_ew) write(6,'(4g15.6)')M

C --------------------Roughness calculation of Y. Khaidukov:---------------
C
	  if(roughlay(L).gt.0.) then
           if(n_rep.gt.1.and.L.eq.Lmin) then  ! In case of repeating layers
	    Lprev=Lmax			      ! we are more interested in the 
	   else                               ! information about roughnesses
                              		      ! in repeated ones. 
	    Lprev=L-1			      ! #Khaidukov
	   endif  ! n_rep.gt.1.and.L.eq.Lmin

	   do I=1,2
	    do J=1,2 
	     if (Lprev.eq.0) then 
	      KLprev(I,J)=C0         ! In case of 1st layer KLprev is for vacuum
	      prev_dgnl=.true.       ! This variable for check the diagonality of prev.
	     endif
                  
             if (Lprev.gt.0) then	   
              prev_dgnl=.not.b_Cm(Lprev)
              KLprev(I,J)=Kmatrix(I,J,Lprev)
	     endif

            end do  ! J
	   end do   ! I
C 
           absMatr=dreal(
     &              (KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+
     &              (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1))))        


           if(prev_dgnl.and.b_odz) then	      ! If susceptibility of both layers
            both_dgnl=.true.                  ! are diagonal we give true value
           elseif (absMatr.lt.1.e-15)	then  ! for roughness subroutine
	    both_dgnl=.true.
           else
	    both_dgnl=.false.
           endif

c           call roughnessN(both_dgnl,roughlay(L),SFI,KLprev,KL,M)
c        if(b_ew) write(6,'(a)') ' roughness'
c        if(b_ew) write(6,'(4g15.6)')M
          endif ! Roughness  
C --------------------end of Roughness calculation ---------------


c        if(b_ew) write(6,'(a)') 'bmat4'
c        if(b_ew) write(6,'(4g15.6)')ML	          
          call mat4(M,ML,ML) 

         endif ! VKD(L)>0.         
        end do ! L

C     For periodic multilayers the int. propagation matrix is (ML)**n_rep, 
C     where n_rep is the number of periods.
C
C        
        if(n_rep.gt.1.and.b_grp)then
         do I=1,4
          do J=1,4
           M(I,J)=ML(I,J)
          end do
         end do
C        
         NLOG=alog(float(n_rep))/alog(2.0)
C
         do I=1,NLOG
          call mat4(ML,ML,ML)
c        if(b_ew) write(6,'(a)') 'NLOG'
c        if(b_ew) write(6,'(4g15.6)')ML
         end do

         do I=1,n_rep-2**NLOG
          call mat4(M,ML,ML)
         end do
C
        end if  ! n_rep>1

        if(b_first) then
         b_first=.false.
         do I=1,4
          do J=1,4
           MS(I,J)=ML(I,J)
          end do
         end do
        else
         call mat4(ML,MS,MS)
        end if         
C
        POINTER=POINTER+GEOSTR(2*GRP)
       end do ! GRP
C
C     Now we have the integreted propagation matrix of the structure: ML
C     Calculation of reflectivity matrix (2x2):
C
c       if(b_ew) write(6,'(4g15.6)')MS
	call refl(MS,Rmatrix)

	return
	end




       subroutine optic(b_ew,mlay,b_Cm,MAXGRP,GEOSTR,SFI,Cmatrix,
     &                      chilay,roughlay,VKD,Rmatrix)
C
C ******************************************************************    
C
C                              OPTICS
C
C          Reflectivity calculation of anizotropic multilayers
C          in the Mossbauer case. 1mrad<FI<10mrad, K~1.E-5. 
C
C          (method of G. H. Borzbov et. al. - L. Deak et. al.)
C
C                         Laszlo Deak
C
C                         Budapest, 1995. July
C                         Mainz, 2002. October
C
C                         Khaidukov Yuri
C	                  Budapest, 2003. April-May
C
C ***************************************************************** 
C
C Geometry:
C
C
C               incident        reflected                    
C                          
C                        \    /    
C                         \  /
C                      FI (\/
C      Z=0>           -------------  
C           covering  _____________         [D(1),K(1,I,J)]  
C                                  >Layer#1 [D(2),K(2,I,J)]
C                 1.  .............     
C                           .
C                           .
C                     .............
C Z=NP*Sum(D(L)) NL.  _____________Layer#NL [D(NL-1),K(NL-1,I,J)]
C       I              
C          substrate  _____________         [D(NL),K(NL,I,J)]
C                            `                 ^
C                              `            infinit or finit
C                             refracted
C
C 
C  Variables of system:
C
C  INPUT:
C
C                           covering   layer #L     substrate
C
C            thickneses:         D(1)     D(L)        D(NL)
C
C        susceptibility:
C          (nuclear+electronic)
C                                K(1)     K(L)        K(NL)
C
C         where  L=1..NL  I,J=1,2,3 
C
C  OUTPUT:
C
C         The 2x2 complex reflectivity (or transmitivity) matrix:  R
C
C ******************************************************************
c       subroutine optic(b_ew,mlay,b_Cm,MAXGRP,GEOSTR,SFI,Cmatrix,
c     &                      chilay,roughlay,VKD,Rmatrix)
C
C       
C
       implicit none
C   input:
       logical   b_ew,b_Cm
       integer   mlay,MAXGRP,GEOSTR
       real      SFI,roughlay,VKD
       complex*8 Cmatrix,chilay,Rmatrix

       dimension  b_Cm(mlay),GEOSTR(0:2*MAXGRP),Cmatrix(2,2,mlay),
     &            chilay(mlay),roughlay(mlay),VKD(mlay),
     &            Rmatrix(2,2)

C      NL=mlay: number of layers  (in period)( not expicitly used)
C      output:       Rmatrix(2,2)
       complex*16 R(2,2)
C      other variables:
       integer    I,J,L,n_rep,GRP,LMIN,LMAX,Lprev,POINTER,NLOG
       real*4     absCmatr,absMatr
       real*8     sinFI, DL 
       complex*16 C0,C1,CI,M(4,4),ML(4,4),MS(4,4),KL(2,2),
     &            KLprev(2,2),UnMat(2,2) 
       logical    b_odz,b_first,b_grp,both_dgnl,prev_dgnl
       parameter  (C0=(0.D0,0.D0), C1=(1.D0,0.D0), CI=(0.D0,1.D0))
 
       UnMat(1,1)=C1
       UnMat(1,2)=C0	 !Unit matrix
       UnMat(2,1)=C0
       UnMat(2,2)=C1

c      print *,b_Cm	 
c      print *,SFI
c      print *,MAXGRP
c      print *,GEOSTR
c      print *,chilay
c      print *,VKD
c      read(5,'(a)')
	 
       sinFI=sin(dble(SFI)) ! the double precision grazing angle 
C
       b_first     =.true.
       POINTER=0                                     
       do GRP=1,MAXGRP      ! loop for the groups
C       To set the characteristic matrix to unit matrix
        do I=1,4
         do J=1,4
          ML(I,J)=C0
         end do
         ML(I,I)=C1
        end do
        b_grp=.false.
C
        LMIN =POINTER+1
        LMAX =POINTER+GEOSTR(2*GRP)
        n_rep=GEOSTR(2*GRP-1)
C
        do L=LMIN,LMAX
         if(VKD(L).gt.0.) then
          b_odz=.false.
          b_grp=.true.
          DL=VKD(L)
          if(b_Cm(L))then
           KL(1,1)=Cmatrix(1,1,L)+chilay(L)
           KL(1,2)=Cmatrix(1,2,L)
           KL(2,1)=Cmatrix(2,1,L)
           KL(2,2)=Cmatrix(2,2,L)+chilay(L)
           absCmatr=dreal( KL(1,2)*conjg( KL(1,2))+
     &                    KL(2,1)*conjg( KL(2,1)))
           if(absCmatr.lt.1.e-15) b_odz=.true.
          else
           KL(1,1)=chilay(L)
           KL(1,2)=C0
           KL(2,1)=C0
           KL(2,2)=chilay(L)
           b_odz=.true.
          end if          

          call genM(b_odz,sinFI,DL,KL,M)   
c        if(b_ew) write(6,'(a)') 'genM'
c        if(b_ew) write(6,'(4g15.6)')M
C
C Roughness calculation of Y. Khaidukov:
C
	  if(roughlay(L).gt.0.) then
           if(n_rep.gt.1.and.L.eq.Lmin) then  ! In case of repeating layers
	    Lprev=Lmax			      ! we are more interested in the 
	   else                               ! information about roughnesses
                              		      ! in repeated ones. 
	    Lprev=L-1			      ! #Khaidukov
	   endif  ! n_rep.gt.1.and.L.eq.Lmin

	   do I=1,2
	    do J=1,2 
	     if (Lprev.eq.0) then 
	      KLprev(I,J)=C0         ! In case of 1st layer KLprev is for vacuum
	      prev_dgnl=.true.       ! This variable for check the diagonality of prev.
	     endif
                  
             if (Lprev.gt.0) then	   
              prev_dgnl=.not.b_Cm(Lprev)
	      if(b_Cm(Lprev))then 
               KLprev(I,J)=Cmatrix(I,J,Lprev)+chilay(Lprev)*UnMat(I,J)  
              else
               KLprev(I,J)=chilay(Lprev)*UnMat(I,J)
              endif          
	     endif

            end do  ! J
	   end do   ! I
C 
           absMatr=real(dble(
     &              (KLprev(1,2)-KL(1,2))*conjg((KLprev(1,2)-KL(1,2)))+
     &              (KLprev(2,1)-KL(2,1))*conjg((KLprev(2,1)-KL(2,1)))))         


           if(prev_dgnl.and.b_odz) then	      ! If susceptibility of both layers
            both_dgnl=.true.                  ! are diagonal we give true value
           elseif (absMatr.lt.1.e-15)	then  ! for roughness subroutine
	    both_dgnl=.true.
           else
	    both_dgnl=.false.
           endif

           call roughness(both_dgnl,roughlay(L),sinFI,KLprev,KL,M)
c        if(b_ew) write(6,'(a)') ' roughness'
c        if(b_ew) write(6,'(4g15.6)')M
          endif ! Roughness  
C   ***********************	
c        if(b_ew) write(6,'(a)') 'bmat4'
c        if(b_ew) write(6,'(4g15.6)')ML	          
          call mat4(M,ML,ML) 
c        if(b_ew) write(6,'(a)') 'mat4'
c        if(b_ew) write(6,'(4g15.6)')ML	 
         endif ! VKD(L)>0.         
        end do ! L

C     For periodic multilayers the int. propagation matrix is (ML)**n_rep, 
C     where n_rep is the number of periods.
C
C        
        if(n_rep.gt.1.and.b_grp)then
         do I=1,4
          do J=1,4
           M(I,J)=ML(I,J)
          end do
         end do
C        
         NLOG=alog(float(n_rep))/alog(2.0)
C
         do I=1,NLOG
          call mat4(ML,ML,ML)
c        if(b_ew) write(6,'(a)') 'NLOG'
c        if(b_ew) write(6,'(4g15.6)')ML
         end do

         do I=1,n_rep-2**NLOG
          call mat4(M,ML,ML)
c        if(b_ew) write(6,'(a)') '1,n_rep-2**NLOG'
c        if(b_ew) write(6,'(4g15.6)')ML
         end do
C
        end if  ! n_rep>1

        if(b_first) then
         b_first=.false.
         do I=1,4
          do J=1,4
           MS(I,J)=ML(I,J)
          end do
         end do
        else
         call mat4(ML,MS,MS)
        end if         
C
        POINTER=POINTER+GEOSTR(2*GRP)
       end do ! GRP
C
C     Now we have the integreted propagation matrix of the structure: ML
C     Calculation of reflectivity matrix (2x2):
C
c        if(b_ew) write(6,'(4g15.6)')MS
	call refl(MS,R)
C
        Rmatrix(1,1)=R(1,1)
        Rmatrix(1,2)=R(1,2)
        Rmatrix(2,1)=R(2,1)
        Rmatrix(2,2)=R(2,2)
C
	return
	end
C


C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
	subroutine refl(M,R)
C
C *******************************************************************
C
C                 Calculation of reflectivity matrix (2X2)
C
C ******************************************************************
C
      implicit none
C
	complex*16 M(4,4),R(2,2),AA,BB,CC,DD
	complex*16 R1(2,2),R2(2,2),R11(2,2)
	integer    I,J
C
C    Definition of 2x2 block matrices:
C
	do I=1,2
	  do J=1,2
	    AA= M(I,J)
  	    BB= M(I,J+2)
	    CC= M(I+2,J)
	    DD= M(I+2,J+2)
            R1(I,J)= AA-BB-CC+DD
            R2(I,J)= AA+BB-CC-DD
	  end do
	end do
C
	call inv2(R1,R11)
C
	call mat2(R11,R2,R)
C
	return
	end
C +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
	subroutine genM(b_odz,sinFI,DL,KL,M)
C
C ******************************************************************
C
C            Definition of the integral propagation matrix  
C                   (see  Eq. (3.20) in the paper)
C
C *****************************************************************
      implicit none
      logical    b_odz
      real*8     DL,sinFI
      complex*16 M,KL
      dimension  M(4,4),KL(2,2)

      integer    I,J
      real*8      aimFFF,sin2FI,aLIMIT
      complex*16 exppF,expmF,FL,invF,shF,M12,M21,FF,
     &           detFF,TrFF,TrFL,exppFL,expmFL,shFL,chFL,
     &           FFF,sinFFF,FF1,C1,C0,CI
      dimension  exppF(2,2),expmF(2,2),FL(2,2),           
     &           invF(2,2),shF(2,2),M12(2,2),M21(2,2),FF(2,2)

      parameter( C0=(0.D0,0.D0),CI=(0.D0,1.D0),C1=(1.D0,0.D0),
     &           aLIMIT=2.D1)

C     Definition of F and X ( Eq. (3.20) L.Deak et al, Phys. Rev B 1996)

      sin2FI = sinFI*sinFI
C
      FF(1,1)=-sin2FI-KL(1,1)
      FF(1,2)=-KL(1,2)
      FF(2,1)=-KL(2,1)
      FF(2,2)=-sin2FI-KL(2,2)
C
C        b_odz==(FF(2,1).eq.C0).and.(FF(1,2).eq.C0)
      if(b_odz)then
       FF(1,1)=sqrt(FF(1,1))
       FF(2,2)=sqrt(FF(2,2))
      else
       call sqrt2(FF,FF)
      endif
C
      do I=1,2
       do J=1,2
        FL(I,J)=DL*FF(I,J)
       end do
      end do
C
      do I=1,2
       do J=1,2
        exppF(I,J) =FL(I,J)
        M(I,J)     =C0
        M(I+2,J+2) =C0
        M(I,J+2)   =C0
        M(I+2,J)   =C0
       end do
      end do
C        b_odz==(FL(2,1).eq.C0).and.(FL(1,2).eq.C0)
      if(b_odz)then
       do J=1,2
        FF1   =FF(J,J)
        FFF   =FL(J,J)*CI        
        aimFFF=dimag(FFF)
        if(aimFFF.gt.aLIMIT)then
         M(J,J)    = C1
         M(J+2,J+2)= C1
         M(J,J+2)  =-CI*FF1/sinFI       
         M(J+2,J)  = CI/FF1*sinFI      ! aimFFF -> +infinit
C         write(*,*)'+inf'
        else
         if(aimFFF.lt.-aLIMIT)then
          M(J,J)    = C1
          M(J+2,J+2)= C1
          M(J,J+2)  = CI*FF1/sinFI
          M(J+2,J)  =-CI/FF1*sinFI     ! aimFFF -> -infinit
C          write(*,*)'-inf'
         else
          sinFFF    = sin(FFF)
          M(J,J)    = cos(FFF)
          M(J+2,J+2)= M(J,J)
          M(J,J+2)  =-sinFFF*FF1/sinFI
          M(J+2,J)  = sinFFF/FF1*sinFI ! general case
C          write(*,*)'general'
         end if
        end if
       end do 
C      
      else
C
       call inv2(FF,invF)
       call exp2(exppF)
       call inv2(exppF,expmF)
C
       do I=1,2
        do J=1,2
         M(I,J)    = 0.5D0*(exppF(I,J)+expmF(I,J))
         M(I+2,J+2)= M(I,J)
         shF(I,J)  = 0.5D0*(exppF(I,J)-expmF(I,J))
        end do
       end do
C
       call mat2(FF,shF,M12)
       call mat2(invF,shF,M21)
C
       do I=1,2
        do J=1,2
         M(I,J+2) = -M12(I,J)/sinFI*CI
         M(I+2,J) =  M21(I,J)*sinFI*CI
        end do
       end do
C
      endif ! b_odz == KL diagonal
C      
      return
      end

	subroutine roughness(both_dgnl,sigma,A0,A1,A2,M)
C ******************************************************************

C  This subroutine updates integrated matrix of distibution with roughness on
C	 the top border of a given layer. 
C      M->Mupd, where Mupd=exp(sigma**2)*[W1,W2]*0.5*M. For the details see 
C      R. Rohlsberger, Hyperfine Inreractions 123/124 (1999) 301-325
C      ------------------------------------------------------------
C	 Differential matrix of distribution is  represented like
C		      0		  I*Ao+Ai/Ao
C      Wi   =	  
C                    I*Ao		0
     	      
C      ---------------------------------------------------------------     
       implicit none

C      Input variables	
       logical    both_dgnl
       real*4     sigma
       real*8     A0
       complex*16 A1(2,2),A2(2,2),M(4,4)

C      Output
       complex*16 Mupd(4,4)

C      Other varaibles
       real*8     sigma2
       complex*16 exp_Dp(2,2),exp_Dm(2,2),exp_scalar(4),C1,C0,
     &            dA_scal(2),C_scal(2),C(2,2),dA(2,2)
       integer    I,J,K

C      Matrixes
       complex*16 TMP(2,2),C2(2,2)

       parameter  (C1=(1.D0,0.D0))
       parameter  (C0=(0.0,0.0))	
  
       sigma2=sigma
       sigma2=sigma2*sigma2

       do I=1,4
        do J=1,4
         Mupd(I,J)=C0
        end do
       end do
     
       if(both_dgnl) then
	do I=1,2
         dA_scal(I)      = A2(I,I)-A1(I,I)
         C_scal(I)       = 2.D0*(2.D0*A0*A0+A2(I,I)+A1(I,I)) ! C=2*(2*A0*A0+A1+A2)
         exp_scalar(I)   = dA_scal(I)*(C1/C_scal(I))*
     &                     (-exp(-0.5D0*sigma2*C_scal(I))+C1)
         exp_scalar(I)   = exp(exp_scalar(I))
         exp_scalar(I+2) = C1/exp_scalar(I)
	end do ! I

C        do I=1,4
C         do J=1,4
C          Mupd(I,J) =  exp_scalar(J)*M(I,J)
C         end do
C	end do

        Mupd(1,1) =  exp_scalar(1)*M(1,1)     ! instead of the above loop it is better to use
        Mupd(2,2) =  exp_scalar(2)*M(2,2)     ! the direct definitions, because we have only
        Mupd(3,1) =  exp_scalar(1)*M(3,1)     ! 8 complex products insted of 16
        Mupd(4,2) =  exp_scalar(2)*M(4,2)     ! # L. Deak

        Mupd(1,3) =  exp_scalar(3)*M(1,3)
        Mupd(2,4) =  exp_scalar(4)*M(2,4)
        Mupd(3,3) =  exp_scalar(3)*M(3,3)
        Mupd(4,4) =  exp_scalar(4)*M(4,4)

       elseif(.not.both_dgnl)  then             
        C(1,1)=2.D0*(2.D0*A0*A0+A1(1,1)+A2(1,1))
        C(2,2)=2.D0*(2.D0*A0*A0+A1(2,2)+A2(2,2))             ! C=2*(2*A0*A0+A1+A2)
        C(1,2)=2.D0*(A1(1,2)+A2(1,2))
        C(2,1)=2.D0*(A1(2,1)+A2(2,1))

	do I=1,2
	 do J=1,2
          dA(I,J)=A2(I,J)-A1(I,J)                ! A=A2-A1
          TMP(I,J)=-0.5D0*sigma2*C(I,J)          ! TMP=-0.5*sigma**2*C
         end do
        end do

        call exp2(TMP)                           ! TMP=exp(-0.5*sigma**2*C)
        call inv2(C,C2)                          ! C2=1/C
        call mat2(dA,C2,C2)                      ! C2=dA*1/C

        TMP(1,1)= C1-TMP(1,1)
        TMP(1,2)=-TMP(1,2)
        TMP(2,1)=-TMP(2,1)                       ! TMP=I-exp(-0.5*sigma**2*C)
        TMP(2,2)= C1-TMP(2,2)

        call mat2(C2,TMP,exp_Dp)                 ! expDp=dA*1/C*(I-exp(-0.5*sigma**2*C))
        call exp2(exp_Dp)                        ! expDp=exp(dA*1/C*(I-exp(-0.5*sigma**2*C)))
        call inv2(exp_Dp,exp_Dm)

        do I=1,2             
         do J=1,2
	  do K=1,2
           Mupd(I,J)     = Mupd(I,J)    +  M(I,K)*exp_Dp(K,J)
           Mupd(I,J+2)   = Mupd(I,J+2)  +  M(I,K+2)*exp_Dm(K,J)
           Mupd(I+2,J)   = Mupd(I+2,J)  +  M(I+2,K)*exp_Dp(K,J)
           Mupd(I+2,J+2) = Mupd(I+2,J+2)+  M(I+2,K+2)*exp_Dm(K,J)	  
          end do
         end do
        end do

       end if                                    ! both_dgnl

       do I=1,4
        do J=1,4
         M(I,J)=Mupd(I,J)
        end do
       end do
      
       return
       end




