      subroutine x_scale(mscale)
      implicit none
      include 'comglb.for'
      include 'comdat.for'
      include 'comthe.for' 
    
      real x_exp,xb_exp,dx_exp,xb_the,dx_the,x
      integer mscale,nexp,nthe,k,i
      common/ascale/x_exp(max8),nexp,xb_exp,dx_exp,nthe,xb_the,dx_the

      if(.not.b_data) then
       if(mscale.eq.2) then
        write(nwr,'(a)')' **warning** scale=2 requires data; set to 1'
        mscale=1
       end if
      end if

      goto (100,200,1000),mscale
      
 100  continue
c     scale of experimental points 
      x=xb_exp-dx_exp
      do k=1,nexp
       x=x+dx_exp
       x_exp(k)=x
      end do
      goto 1000
      
 200  continue
c     scale of experimental points 
c     data for time or angle array taken from data file
      do i=1,nexp
       x_exp(i)=real_fr(mxpt+i)
      end do

 1000  continue
      return
      end
      



      subroutine data2dread(n1,info)
      implicit none
      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'
c      include 'comscd.for'


      integer   n1,info,icdum
      character*132 chnext,chcom,ch132,cp132,querytype,chardata*80,
     &              carray*4,chl*24,chr*24,form*7,ch1*1,chf*4,
     &              ch6*6,ch2*2,dacom*4
      integer     ldacom,iplace,iextra,irow
      real        out
      parameter   (icdum = i_stmp-24-5*33-8-80-48-32-16)
      common/stmp/ ldacom(8),iplace(8),iextra(8),
     &             chnext,chcom,ch132,cp132,querytype,dacom(8),
     &             chardata(4),chl,chr,form,ch1,chf(32),ch6,ch2,
     &             out(32),irow(16),carray(icdum)
c      logical     b_dat
c      dimension   b_dat(max8)
      real        array,h
      common/plot/array(MDBPLFT*2)
c      equivalence (array(1),b_dat(1))
      integer      i,ip,ipos,ir,ifound,ih,j,j1,jj1,jj2,k,nt,nj,irn

c     write(6,'(a,5i7)') '  iarray_sp,nstorFR=',iarray_sp,nstorFR
c     only even number of channels are handled
c      write(6,'(a,i4,2x,a)')'dataread n1,readform=',
c     &  n1,readform

      do k=1,8
       ldacom(k)=0
       iplace(k)=0
       iextra(k)=0
      end do

      ip=1
      ih=0
      nt=0
c      write(6,'(2a)')'cdata_str=', cdata_str    ! from data file
      ch132=cdata_str
      do while(ip.gt.0)
       call nextchar(ch132,ih,ipos,cp132,ip)
       ch132=cp132
       ih=ip
       nt=nt+1
c      write(6,'(i5,2x,a)') ip,cp132(1:24)

       if(nt.eq.8.or.ip.eq.0)then
        ip=0
        dacom(nt)=' '
        ldacom(nt)=ip
       else
        dacom(nt)=cp132(1:ip)
        ldacom(nt)=ip
        end if
       end do
       nt=nt-1
c      write(6,'(a,10a6)') ' dacom=',(dacom(i),i=1,nt)
c      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,nt)

c      write(6,'(2a)') 'from th data_str=',data_str            ! from fr_theory
      ch132=data_str
      ip=1
      ih=0
      ir=0
      nj=0
      do while(ip.gt.0)
       call nextchar(ch132,ih,ipos,cp132,ip)
       ch132=cp132
       ih=ip
       nj=nj+1
       ifound=10
       if(nj.eq.8) ip=0
       if(ip.gt.0) then
        ifound=0
c       write(6,'(i5,2x,a)') ip,cp132(1:24)
        do k=1,nt
c        write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' dacom(k)=',
c     &                   dacom(k),cp132(1:ip)
         if(cp132(1:ip).eq.dacom(k)) then
          ir=ir+1
          iplace(ir)=k
          ifound=1
         end if
        end do
       end if
       if(ifound.eq.0) then
        do k=1,nt
         if(cp132(1:1).eq.'d'.and.cp132(2:2).eq.dacom(k)) then
c         write(6,'(a,i2,a,a4,2x,a)') 'found=0 k=',k,
c     &   ' dacom(k)=',dacom(k),cp132(1:2)
          iextra(ir)=k
          ifound=1
         end if
c        write(6,'(a,2i5)') 'k,ifound=',k,ifound
        end do
       end if
       if(ifound.eq.0) then
        info=23
        infotext(1)='effi/data/read_data/format'
        infotext(3)='expected data format not on data file'
        infotext(4)='format: '//cdata_str(:12)//'expected format: '
     &    //data_str
        infotext(5)=' '
        goto 250
       end if
      end do
c      write(6,'(a,i4)')   ' return, ifound=',ifound
c      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,8)
c      write(6,'(a,10i5)') ' iplace=',(iplace(i),i=1,8)
c      write(6,'(a,10i5)') ' iextra=',(iextra(i),i=1,8)

c     reading of data type n=1,2,...,8
c     storing data of type istortype=1...8
      ip=-1
      do k=1,ir
       j=nt-iplace(k)
       ip=ip+1
       jj1=j1+ip*nchannelsp
       if(iextra(k).gt.0) then
        ip=ip+1
       end if
      end do
c      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp
      nuofdatas=(ip+1)*int((nchannelsp+1)/2)
c      write(6,'(a,6i6)') ' nuofdatas=',nuofdatas
      if(n1.eq.0) return

      k=nchannelsp*nt
c     write(6,'(a,6i6)') ' n1,nt,k,nchannelsp=',n1,nt,k,nchannelsp
      i=index(readform,'free')
      if(i.gt.0)then
       ch132=readform(2:i)
       call trlch(i+1,ch132,irn,out) 
       do i=1,irn
        irow(i)=out(i)
       end do
            
       j=0
       do while(j.lt.k) 
        read(n1,'(a)',end=50,err=240)ch132
        call trlch(80,ch132,ipos,out)
        do ip=1,irn
         array(ip+j)=out(irow(ip))
        end do
        j=j+irn
       end do
      else
c      write(6,'(a,a)') ' readform=',readform
       read(n1,readform,end=50,err=240) (array(i),i=1,k)
      end if
      goto 60
 50   info=25
      infotext(3)='read found EOF'
      infotext(4)=' '
      goto 250
 60   continue
 
      ip=-1
      j1=2*(iarray_sp+nstorFR)
      do k=1,ir
       j=nt-iplace(k)
       ip=ip+1
       jj1=j1+ip*nchannelsp
c       write(6,'(a,6i7)') ' ir,iplace(k),nt,j,jj1,iextra(k)=',
c     &                 ir,iplace(k),nt,j,jj1,iextra(k)
       do i=1,nchannelsp
        real_fr(jj1+i)=array(nt*i-j)
       end do

c       write(6,'(8f10.2)')(real_fr(jj1+i),i=1,8)
       if(iextra(k).gt.0) then
        ip=ip+1
        jj2=j1+ip*nchannelsp
c       write(6,'(a,6i7)') ' ip,iplace(k),nt,j,jj2=',
c     &                 ip,iplace(k),nt,j,jj2
        do i=1,nchannelsp
         h=real_fr(jj1+i)
         if(h.gt.0) then
          real_fr(jj2+i)=sqrt(h)
         else
          real_fr(jj2+i)=1.
         end if
        end do
       end if
      end do
c      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp

      goto 250
 240  continue
c     read error format?
      info=24
      infotext(3)='read error of data file, identified format:'
      infotext(4)=readform
      infotext(5)=' '
 250  continue
      return
      end

      subroutine punch2d(nout,info)

      include 'comglb.for'
      include 'compar.for'
      include 'comdat.for'
      include 'comdas.for'
      include 'comthe.for'
      include 'comscd.for'

      integer     icdum
      real        out
      character   carray*4,ch132*132,cp132*132,cpunch*132,
     &            iform*132,k2form*8,stringnumber*40,chl*24,chr*24,
     &            form*7,su*2
      parameter   (icdum =i_stmp-7*infplot-32-4*33-22)
      common/stmp/iplace(infplot),lname(infplot),jp(infplot),out(32),
     &            ch132,cp132,iform,cpunch,stringnumber,
     &            chl,chr,k2form(2*infplot),
     &            carray(icdum)

      integer     ifeder,ltext,idumpl,int3d,npnt3d,ncolor,
     &            npntplot,nchanplot,maxn6,max8subn,logx,logy,logf
      character   axesname*24,
     &            namechan*4,kform*8,chdum*4,axisformat*16,
     &            title*132,plotstrdef*80,plotstrpu*132
      real        plotarray,xyzdz
      parameter   (max8subn=maxsub*max8,maxn6=max8*6,
     &            idumpl=MDBPLFT*2-140*maxn-8*39-maxsub-5*infplot-120)
      common/plot/plotarray(maxn6+max8subn),
     &            xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),
     &            int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),
     &            npntplot(infplot),nchanplot(infplot),ncolor(maxsub),
     &            n_subspectra,logx,logy,logf,
     &            namechan(infplot),kform(infplot),axisformat(3),
     &            axesname(3),title,plotstrdef,plotstrpu,
     &            chdum(idumpl)
c                 chardum[14964]
      character*132 cpunchsu,cpunchw,cpunchstrj

      k=1
      do while(kform(k).ne.' '.and.k.lt.infplot)
       k2form(k)=kform(k)
c       write(6,'(a)')kform(k)
       k=k+1
      end do
      k=k-1
      do i=1,k
       k2form(k+i)=kform(k)
      end do


c      do ii=1,infplotarray*2
c       scratch(ii)=plotarray(ii)
c      end do
      do k=1,infplot
       l=index(namechan(k),' ')
       lname(k)=l-1
       if(lname(k).le.0) lname(k)=4
      end do

      cpunch=plotstrpu
      call stringlength(cpunch,l)
      do k=1,l
       if(cpunch(k:k).eq.',')cpunch(k:k)=' '
      end do
      nsequence=1
 100  continue
c      write(6,'(2a)') 'print  100:',cpunch(1:60)
      jka=index(cpunch,'(')
      jkz=index(cpunch,')')
      cpunchstrj=' '
      if(jka.gt.0.and.jkz.gt.0) then
       cpunchstrj=cpunch(jka:jkz)
       if(jka.gt.1)then
        if(cpunch(jka-1:jka-1).eq.'d')cpunchstrj='d'//cpunch(jka:jkz)
       end if
       nsequence=0
       cpunchw=cpunch(jka+1:jkz-1)
       cp132=cpunch(jkz+1:)
       cpunch=cp132
      else
       cpunchstrj=cpunch
       cpunchw=cpunch
       cpunch=' '
      end if

      do k=1,8
       iplace(k)=0
      end do

      su=namechan(mplot+1)  
c     write(6,'(3a)')'namechan(mplot+1)=',namechan(mplot+1)  
      ir=0

 200  continue
c      write(6,'(3a)') ' 200: cpunchw=',cpunchw(1:30)
      isu=index(cpunchw,su)
      if(isu.gt.0) then
       ch132=cpunchw(1:isu-1)
       cp132=cpunchw(isu:)
       cpunchw=cp132
c       write(6,'(3a)') 'isu.gt.0: cpunchw=',cpunchw(1:30)
       ipw=0
       k=1
       do while(k.le.mplot.and.ipw.eq.0)
        ipw=index(cpunchw,namechan(k)(1:lname(k)))
c       write(6,'(i4,3a)') ipw,'=ipw: cpunchw,namechan(k)=',
c     &       cpunchw(1:30),namechan(k)(1:lname(k))
        k=k+1
       end do
       if(ipw.gt.0) then
        cp132=cpunchw(ipw:)
        cpunchsu=cpunchw(1:ipw-1)
        cpunchw=cp132
c        write(6,'(3a)') 'ipw.gt.0: cpunchw,cpunchsu=',
c     &    cpunchw(1:30),cpunchsu(1:30)
       else
        cpunchsu=cpunchw
        cpunchw=' '
c       write(6,'(3a)') 'ipw.eq.0: cpunchw,cpunchsu=',
c     &    cpunchw(1:30),cpunchsu(1:30)
       end if
      else
       ch132=cpunchw
c      write(6,'(3a)') 'isu.eq.0: cpunchw=',cpunchw(1:30)
       cpunchsu=' '
       cpunchw=' '
      end if

      ifound=0
      ip=1
      ih=0
 210  continue
      call nextchar(ch132,ih,ipos,cp132,ip)
      ch132=cp132
      ih=ip
c      write(6,'(a,i5,2x,a)') 'ip,cp132(1:24)=',ip,cp132(1:24)

      if(ip.gt.0) then
       do k=1,infplot
c       k=0
c       do while(ifound.eq.0.and.k.lt.infplot)
c        k=k+1
c        write(6,'(i4,a,i2,a,a4,2x,a)') ifound,' k=',k,' namechan(k)=',
c     &          namechan(k)(1:lname(k)),cp132(1:ip)
        if(namechan(k)(1:lname(k)).eq.cp132(1:ip)) then
c         write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' namechan(k)=',
c     &                   namechan(k),cp132(1:ip)
c          write(6,'(a)') cpunchw(1:80)
         ir=ir+1
         iplace(ir)=k
         ifound=1
        end if
       end do
c       write(6,'(a,10i4)') ' ir,ifound=',ir,ifound
       if(ifound.eq.0) then
        write(nwr,'(3a)')
     &         '**error** ',cp132(1:ip),' is not a data type'
       end if
       goto 210
      end if
c      write(6,'(a)') cpunchsu(1:80)
      nch=132
      isu=index(cpunchsu,'su')
      if(isu.gt.0) cpunchsu(isu:isu+1)=' '
      call panum(cpunchsu,n_subspectra,1)
c      write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,10)
c      write(6,'(a,10i4)') ' ir,mplot=',ir,mplot
      do k=1,npanum(2)
       iplace(ir+k)=mplot+npanum(2+k)
      end do
      ir=ir+npanum(2)
c      write(6,'(2a)') 'cpunchw=',cpunchw(1:60)
      if(cpunchw.ne.' ') goto 200

      if(ir.eq.0) goto 1000
      write(nout,'(a)') title

c       write(6,'(a,20i3)') ' nseq=0,iplace=',(iplace(i),i=1,ir)
        ipk=iplace(1)
        ch132=k2form(ipk)
        call stringlength(ch132,il)
        iform='('//ch132(1:il)
        if=il+1
        do k=2,ir
         ipk=iplace(k)
         ch132=k2form(ipk)
c        write(6,'(a,2x,a)') 'ipk,k2form',ipk,k2form(ipk)
         call stringlength(ch132,il)
         iform(if+1:if+1+il)=','//ch132(1:il)
         if=if+1+il
        end do 
        iform(if+1:if+1)=')'
        lfr=if+1
        call stringlength(cpunchstrj,lpw)
        write(nout,'(a,2x,a)') iform(:lfr),cpunchstrj(:lpw)
        write(nwr,'(17x,a,2x,a)') iform(:lfr),cpunchstrj(:lpw)
        form='i5'
        ip1=iplace(1)
        rn=nchanplot(ip1)
        call trlnu(form,rn,chr,ii,chl,il)
        stringnumber='nu_channels='//chl(1:il)
        write(nout,'(a)') stringnumber

        do k=1,ir
         jp(k)=(iplace(k)-1)*max8
c        write(6,'(a,3i5,2x,f15.6)') ' ir,iplace(k),j,plotarray(j+1)=',
c     &                 ir,iplace(k),jp(k),plotarray(jp(k)+1)-1.
        end do
        do i=1,nchanplot(iplace(1))
         write(nout,iform) (plotarray(jp(k)+i),k=1,ir)
        end do
        write(nout,'(a)') (axesname(i),i=1,3)
       if(cpunch.ne.' ') goto 100
 1000  continue
      write(nout,'(a2)')'##'
      return
      end

      subroutine testplot
      include 'comglb.for'
      integer  idum
      common/plot/ idum(MDBPLFT*2)
      return
      end
