
      subroutine thstr_22indexrefl(l_jth,cmch,nhelpentry)

c     n_ik(E) refraction index (static) 
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth     
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo


      if(cmch.eq.'name')then
       nhelpentry='2x2 refraction index reflection'
c      names for child theories , mthchild=1 <= max_nth 
       nameth(1)='2x2 refraction index (static)'
       namepg(1)='2x2_refraction_index_static   plrs,1 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=7 <=max_nth
       ntheory(1)='stroboscopic reflection spectrum_32'
       ntheory(2)='Nuclear double FG scattering_31'
       ntheory(3)='Nuclear double GF scattering_32'
       ntheory(4)='time differential reflection spectrum_3'
       ntheory(5)='time integral - rocking curve-Fourier_3'
       ntheory(6)='time integral - rocking curve_3'
       ntheory(7)='time integral - rocking curve_fi_3'
     
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(7))l_jth=1
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth  
       return
      end if


       call conmatpar('coll',jc,jm,jp,jv,chth)

       if(l_jth.eq.1) then
 
        thco(jc+1)='flag_SAMP  i_pos=1    include=y  0 '
                 ! discrete (1) , continuous(0) LG-curves
        thco(jc+2)='flag_Voigt   i_pos=2    include=n   0 '
        jc=jc+2            

c       comment on the 2 instead of 1 (flag_Voigt is omitted):
c       flag_Voigt is still in use in the Mossbauer=> the position
c       of constants in the .par file are the same as in Mossbauer.
       end if

c                     123456789012345678901234567 
            
       ntrmt(jm+1)='A_thickness  intensity'
       ctrmt(jm+1)='effective thickness by the f-factor at the site'
        thpa(jp+1)='Axf             , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='Axf                     1     1  '
                         
       ntrmt(jm+2)='position   matrix=(1,1)   include=y'
       ctrmt(jm+2)='position of the spectrum'
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1'
        thvr(jv+2)='is_shift                2    1  '
                         
       ntrmt(jm+3)='broadening   matrix=(2,2)   include=[n]'
       ctrmt(jm+3)='broadening of the lines of the spectrum'
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1'
        thvr(jv+3)='G_width                 3      1 0 '
        thvr(jv+4)='L_width                 4      0 1 '
       jm=jm+3
       jp=jp+4       
       jv=jv+4
       call conmatpar('layn',jc,jm,jp,jv,chth)

      return
      end

      subroutine thstr_22indexreflnosampl(l_jth,cmch,nhelpentry)

c     n_ik(E) refraction index (static) 
c     level 3 theory
c     the routine "2x2_refraction_index_static" is called by case=2
c     flag_sampl=0 and flag_Voigt=1  == aLORGAUS() is called   
c     aLORGAUS() does not store on array_fr()
  
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth 
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='2x2 refraction index offspec'
c      names for child theories , mthchild=1 <= max_nth
       nameth(1)='2x2 refraction index (static)'
       namepg(1)='2x2_refraction_index_static   plrs,2 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='time integral - offspecular_3'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=1
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth  
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

       thco(jc+1)='flag_SAMP   i_pos=1   include=n  0 '
                 ! discrete (1) , continuous(0) LG-curves
       thco(jc+2)='flag_Voigt  i_pos=2    include=n  0 '
       jc=jc+2            

c      comment on the 2 instead of 0 (flags_ are omitted):
c      flags are in use in Mossbauer, etc => the position
c      of constants in the .par file are in the same order as
c      in Mossbauer, etc.
        
c                     123456789012345678901234567 
            
       ntrmt(jm+1)='A_thickness  intensity'
       ctrmt(jm+1)='effective thickness by the f-factor at the site'
        thpa(jp+1)='Axf             , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='Axf                     1     1  '
                         
       ntrmt(jm+2)='position  matrix=(1,1)   include=y'
       ctrmt(jm+2)='position of the spectrum'
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1'
        thvr(jv+2)='is_shift                2    1  '
                         
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]'
       ctrmt(jm+3)='broadening of the lines of the spectrum'
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1'
        thvr(jv+3)='G_width                 3      1 0 '
        thvr(jv+4)='L_width                 4      0 1 '
       jm=jm+3
       jp=jp+4       
       jv=jv+4
       call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end

      subroutine thstr_22indextrm(l_jth,cmch,nhelpentry)

c     n_ik(E) refraction index (static) 
c     level 3 theory

      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer jc,jm,jp,jv,l_jth 
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='2x2 refraction index transmission' 
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='2x2 refraction index (static)'
       namepg(1)='2x2_refraction_index_static   plrs,1 '
       nameth(2)='2x2 refraction index (f,t,spinham)'
       namepg(2)='2x2_refraction_index_static   plrs,1 '
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=3 <=max_nth
       ntheory(1)='Nuclear double FG scattering_32'
       ntheory(2)='Nuclear double GF scattering_31'
       ntheory(3)='time differential transmission spectrum_31'

c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(3))l_jth=2       
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct='handbook=nucleus.hdb   list=3  chth='//chth  
       return
      end if

      call conmatpar('coll',jc,jm,jp,jv,chth)

       thco(jc+1)='flag_SAMP   i_pos=1    include=y  0 '
                 ! discrete (1) , continuous(0) LG-curves
       thco(jc+2)='flag_Voigt  i_pos=2    include=n  0 '
       jc=jc+2            

c      comment on the 2 instead of 1 (flag_Voigt is omitted):
c      flag_Voigt is still in use in Mossbauer,etc. => the position
c      of constants in the .par file are in the same order as 
c      in Mossbauer,etc.
        
            
       ntrmt(jm+1)='t_eff   intensity'
       ctrmt(jm+1)='effective thickness by the f-factor at the site'
        thpa(jp+1)='mg/cm2xf         , 1.0  0.0 0.0  0.1'
        thvr(jv+1)='mg/cm2xf                1     1  '
                         
       ntrmt(jm+2)='position  matrix=(1,1)   include=y'
       ctrmt(jm+2)='position of the spectrum'
        thpa(jp+2)='is_shift         , 0.0  0.0 0.0  0.1'
        thvr(jv+2)='is_shift                2    1  '
                         
       ntrmt(jm+3)='broadening  matrix=(2,2)   include=[n]'
       ctrmt(jm+3)='broadening of the lines of the spectrum'
        thpa(jp+3)='G_width          , 0.0  0.0 0.0  0.1'
        thpa(jp+4)='L_width          , 0.0  0.0 0.0  0.1'
        thvr(jv+3)='G_width                 3      1 0 '
        thvr(jv+4)='L_width                 4      0 1 '
       jm=jm+3
       jp=jp+4       
       jv=jv+4
       call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end

