      subroutine frstr_neutron(l_nfrtheo,lstruct1,lstruct2,
     &                                   cmch,nhelpentry)
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
      
      integer l_nfrtheo,lstruct1,lstruct2
      character*132 nhelpentry,cmch*4,chth*8
      integer igo,jc,jm,jp,jv,jdevice,ldevice
       
     
      if(cmch.eq.'name') then
c####################################################
       nhelpentry  ='Neutron spectrum' 
       ntheory(1)='Neutron source'
       n_device=1
       ndevice(1)='scatterer'
c####################################################
       return
      end if

 
      chth='fr'//nhelpentry(1:6)
      nstruct=' '

      ldevice=lstruct1    
      if(m_device.gt.0)then
       jdevice=mdevf-1+m_device
       if(lstruct1.ge.m_device)ldevice=m_device
       if(lstruct1.gt.jdevice)ldevice=lstruct1-(mdevf-1)
      end if
      goto(100,200)ldevice+1
c------------------------------------------------------------------------
 100  continue
c     common/acstrf/acsp,
c                   dwba,channels,scale,unit_sclB,unit_sclN,
c                   ch_v,v_beg,v_end,theta1,lambda
c                   v=q        for neutronrock
c                   v=theta2   for neutronoffspecular,neutronOffspecRoughness

      
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if
      
c------------------------------------------------------------------------      

c      common/avsptrf/avsp,aintensity,background,
c                     Pxsi_b,Peta_b,Pzeta_b,
c     &               Pxsi_a,Peta_a,Pzeta_a,

c                     q_shift,q_min,phi_z            rock
c                     theta2_shift,fr_offspec,xi     off-spec
c                     theta2_shift,fr_offspec,xi,Ao  off-spec(roughness)

      call conmatpar('coll',jc,jm,jp,jv,chth)
c                    1        0         012345
      ntrmt(jm+1)='intensity  matrix=(1,1)   include= y '
      ctrmt(jm+1)='total intensity of reflected neutrons'
       thpa(jp+1)='intensity                 1.00e+6  0.0 0.0 1.0e4'
       thvr(jv+1)='intensity                 1   1   '

      ntrmt(jm+2)='background  matrix=(1,1)   include= y '
      ctrmt(jm+2)='background of reflected neutrons per channel'
       thpa(jp+2)='background                0.00  0.0 0.0 1.0'
       thvr(jv+2)='background                2   1   '

      ntrmt(jm+3)='Poincare_beam   matrix=(3,3) from_data=[n]'
      ctrmt(jm+3)='Poincare vector of the neutron beam'
       thpa(jp+3)='Pxsi_b                    0.0  0.0 1.0  0.05'
       thpa(jp+4)='Peta_b                    0.0  0.0 0.0  0.05'
       thpa(jp+5)='Pzeta_b                   1.0  0.0 0.0  0.05'
       thvr(jv+3)='Pxsi_b                    3    1 0 0 '
       thvr(jv+4)='Peta_b                    4    0 1 0 '
       thvr(jv+5)='Pzeta_b                   5    0 0 1 '

      ntrmt(jm+4)='Poincare_analyser  matrix=(3,3) from_data=[n]'
      ctrmt(jm+4)='Poincare vector of the neutron analyser'
       thpa(jp+6)='Pxsi_a                   0.0  0.0 1.0  0.05'
       thpa(jp+7)='Peta_a                   0.0  0.0 0.0  0.05'
       thpa(jp+8)='Pzeta_a                  0.0  0.0 0.0  0.05'
       thvr(jv+6)='Pxsi_a                   6    1 0 0 '
       thvr(jv+7)='Peta_a                   7    0 1 0 '
       thvr(jv+8)='Pzeta_a                  8    0 0 1 '
      jm=jm+4
      jp=jp+8
      jv=jv+8
      
      strcmt(1)='scatterer   n_set=[sc]       [1]   1 '      
      strcmt(2)='two letters for the name of the scaterer '
      strcmt(3)='scatterer consists of incoherent parts '
      strcmt(4)='theory/'//chth//'/neutron scattering/go'
      strcmt(5)='theory/'//chth//'/layer/scatterer'
      call conmatpar('dev1',jc,jm,jp,jv,chth)

      return
c-------------------------------------------------------------------------
 200  continue
      if(lstruct2.gt.0) goto 210
      
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if
      call conmatpar('coll',jc,jm,jp,jv,chth)
      
c      common/vfr1trf/ inc_frac,Hext,theta_He,phi_He
       strcmt(1)=
     &   'incoherent_part_layer n_device=[sr] mijk=co;sw;su [3] 3'
       strcmt(2)='two letters for incoherent part of the scatterer'
       strcmt(3)='number of layers of the scatterer '
       strcmt(4)=' '
       strcmt(5)='theory/'//chth//'/scatterer/layer'

c                    1        0         012345
       ntrmt(jm+1)='H_extern    matrix=(3,3)   include=[n]'
       ctrmt(jm+1)='external mag. field ||z at the scatterer'
        thpa(jp+1)='Hext-z               0.00  0.0 0.0  1.0'
        thpa(jp+2)='theta_He             90.0  0.0 0.0  1.0'
        thpa(jp+3)='phi_He                0.0  0.0 0.0  1.0'
        thvr(jv+1)='Hext-z                  2    1 0 0 '
        thvr(jv+2)='theta_He                3    0 1 0 '
        thvr(jv+3)='phi_he                  4    0 0 1 '

       ntrmt(jm+2)='incoherent_fract  matrix=(1,1)   include= y'
       ctrmt(jm+2)='area fraction treated incoherently'
        thpa(jp+4)='inc_frac                , 1.0  0.0 0.0  0.01'
        thvr(jv+4)='inc_frac                , 1  1 '
       jm=jm+2
       jp=jp+4
       jv=jv+4

      call conmatpar('dev2',jc,jm,jp,jv,chth)
      return
      
 210  continue
      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if
      
c     common/acfr2trf/ rep.grp
      call conmatpar('coll',jc,jm,jp,jv,chth)

      thco(jc+1)='rep.grp       i_pos=1  include= y  1.1 '
              ! layer belongs to a group which repeat with period
      jc=jc+1
      
c------------------------------------------------------------------------
c     common/avfr2trf/avfr2,thicklay,B_eff,theta_B,phi_B,
c                      ar_scatldens,ai_scatldens,roughness,eta_domai     

c                    1        0         012345
      ntrmt(jm+1)='thickn_lay    matrix=(1,1)   include= y'
      ctrmt(jm+1)='thickness of the layer'
       thpa(jp+1)='thicklay             , 10.0  0.0 0.0  0.1'
       thvr(jv+1)='thicklay                1    , 1  '
c                     1        0         012345
      ntrmt(jm+2)='B_average    matrix=(3,3)   include=[n] '
      ctrmt(jm+2)=' B_average of the layer  '
       thpa(jp+2)='B_eff                 0.00  0.0 0.0  0.1'  
       thpa(jp+3)='theta_B               0.0   0.0 0.0  0.1'  
       thpa(jp+4)='phi_B                 0.0   0.0 0.0  0.1'  
       thvr(jv+2)='B_eff                   2    1 0 0'
       thvr(jv+3)='theta_B                 3    0 1 0'
       thvr(jv+4)='phi_B                   4    0 0 1'  
     
      ntrmt(jm+3)='scatl_density  matrix=(2,2)   include= y'
      ctrmt(jm+3)='scattering length density of the layer  '
       thpa(jp+5)='r_scatldens               -14.8592  0.0 0.0  0.1'
       thpa(jp+6)='i_scatldens              , 0.67783  0.0 0.0  0.1'
       thvr(jv+5)='r_scatldens              5    1 0'
       thvr(jv+6)='i_scatldens              6    0 1 '
     
      ntrmt(jm+4)='roughness   matrix=(1,1)   include=[n]'
      ctrmt(jm+4)='roughness of the layer  '
       thpa(jp+7)='roughness               , 0.0  0.0 0.0  0.1'
       thvr(jv+7)='roughness                7    1 '
      jm=jm+4
      jp=jp+7
      jv=jv+7
      if(l_nfrtheo.eq.2) then
c       offspecular theory requires the size of domains 
       ntrmt(jm+1)='domain_fraction    matrix=(1,1)   include=[n]'
       ctrmt(jm+1)='fraction of + domain of 1. layer  '
        thpa(jp+1)='eta_domain        , 0.50  0.0 0.0  0.02'
        thvr(jv+1)='eta_domain              8    1 '
       jm=jm+1
       jp=jp+1
       jv=jv+1
      end if
      strcmt(1)='no_further_layer_variables n_device=ab  0 0 '
      call conmatpar('lay2',jc,jm,jp,jv,chth)

      return
      end
      

      subroutine thstr_neutron(l_jth,cmch,nhelpentry)

c     case neutronrock
c          neutronoffspecular
c         neutronOffspecRoughness
c     for neutron scattering
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for' 
      
      integer l_jth,mthchild,mthparent,k
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='Neutron source (distribute)'
c      names for child theories , mthchild=2 <= max_nth 
       nameth(1)='Neutron specular scattering'
       nameth(2)='Neutron offspecular scattering'      
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Neutron source'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=2
       return
      end if

      return
      end

      subroutine thstr_neutronspec(l_jth,cmch,nhelpentry)
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'

      integer l_jth,mthchild,mthparent,k,jc,jm,jp,jv
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='Neutron rocking'
c      names for child theories , mthchild=1 <= max_nth 
       nameth(1)='Neutron rocking curve'
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Neutron specular scattering'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=1
       return
      end if

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

c      common/acstrf/acsp,dwba,Q_scale,channels,anglepair,
c     &              unit_sclB,unit_sclN,lambda,q_ch,q_beg,q_end

       call conmatpar('coll',jc,jm,jp,jv,chth)
        
       thco(jc+1)='nu_channels   i_pos=3  from_data=y 1024 '
                 ! channel number of the spectrum
       thco(jc+2)='Q_scale       i_pos=2  from_data=[y] 1 '
                 ! determines function for channel to velocity scale
       
c                  1                  012345
       thco(jc+3)='unit_sclB       i_pos=5  include= y  0.291E-05' 
                          ! 1.0e-9 !Now B is to be written in kOe 
                 ! 
       thco(jc+4)='unit_sclN       i_pos=6   include= y  0.126E-04'  
                          !1.0e-6 Now Nb in 10^-6 A^-2
                          ! scattering length  multiplied by
       jc=jc+4
       thco(jc+1)='nu_q_values      i_pos=8  include= y      128 '
       thco(jc+2)='q_begin          i_pos=9  from_data=[n]  0.07  '
       thco(jc+3)='q_end            i_pos=10  from_data=[n]   0.7 '
        
       jc=jc+3
            
c      common/avsptrf/avsp,aintensity,background,
c                     Pxsi_b,Peta_b,Pzeta_b,
c                     Pxsi_a,Peta_a,Pzeta_a,

c                     q_shift,q_min,phi_z            rock
        
       ntrmt(jm+1)='calibration  matrix=(1,1) from_data=[y]'
       ctrmt(jm+1)='frame parameter q-shift'
        thpa(jp+1)='q_shift                 0.0 0.0 0.0 0.1'
        thvr(jv+1)='q_shift                 1     1  '
      
       ntrmt(jm+2)='orientation   matrix=(2,2) from_data=[y]'
       ctrmt(jm+2)='q_min, phi_z of the scatterer plane'
        thpa(jp+2)='q_min                   1.00  0.0 0.0  0.01'
        thpa(jp+3)='phi_z                   0.00  0.0 0.0  1.0'
        thvr(jv+2)='q_min                   2    1 0'
        thvr(jv+3)='phi_z                   3    0 1'
       jm=jm+2
       jp=jp+3
       jv=jv+3
   
      call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end

      subroutine thstr_neutronoffspec(l_jth,cmch,nhelpentry)
      implicit none
      include 'comglb.for'
      include 'comstr.for'
      include 'comcvm.for'
  
      integer l_jth,mthchild,mthparent,k,jc,jm,jp,jv
      character nhelpentry*132,chth*8,cmch*4
      logical name_eq_ntheo

      if(cmch.eq.'name')then
       nhelpentry='Neutron offspecular-diffuse'
c      names for child theories , mthchild=1 <= max_nth 
       nameth(1)='Neutron offspecular'
       return
      else if(cmch.eq.'theo') then
c      look for mthchild theory fitting to ntheory,mthparent=1 <=max_nth
       ntheory(1)='Neutron offspecular scattering'
c      if(name_eq_ntheo(mthparent))l_jth=mthchild
       if(name_eq_ntheo(1))l_jth=1
       return
      end if 

      chth='th'//nhelpentry(1:6)

      if(cmch.eq.'hdbk') then
       nstruct=' '
       return
      end if

c      common/acstrf/acsp,
c                   ,channels,scale,unit_sclB,unit_sclN,
c                   ch_v,v_beg,v_end,d_theta1,d_theta2,lambda,aver_points

c                   v=q        for neutronrock
c                   v=theta2   for neutronoffspecular,neutronOffspecRoughness

      call conmatpar('coll',jc,jm,jp,jv,chth)
       
       thco(jc+1)='DWBA            i_pos=1 include= y       1 '
       thco(jc+2)='scale           i_pos=2  from_data=[y]   1 '
                 ! determines function for channel to velocity scale
       thco(jc+3)='nu_channels     i_pos=3  from_data=y 1024 '
                 ! channel number of the spectrum
       thco(jc+4)='show_angles     i_pos=4   from_data=[n]  0 '       
c                  1                  012345
       thco(jc+5)='unit_sclB       i_pos=5  include=y 0.291E-05' 
c                  1.0e-9 !Now B is to be written in kOe 
       thco(jc+6)='unit_sclN        i_pos=6 include=y 0.126E-04'  
c                1.0e-6 Now Nb in 10^-6 A^-2
c                scattering length  multiplied by
       
       thco(jc+7)='lambda            i_pos=7 include=y  1.0'
       jc=jc+7
            
c      common/avsptrf/avsp,aintensity,background,
c                     Pxsi_b,Peta_b,Pzeta_b,
c                     Pxsi_a,Peta_a,Pzeta_a,

c                     theta2_shift,fr_offspec,xi          offspecular
       ntrmt(jm+1)='calibration  matrix=(1,1)   include= y'
       ctrmt(jm+1)='frame parameter theta2-shift'
        thpa(jp+1)='theta2_shift            0.0 0.0 0.0 0.1'
        thvr(jv+1)='theta2_shift             1     1  '
  
c       ntrmt(jm+2)='fraction     matrix=(1,1)   include= y'
c       ctrmt(jm+2)='fraction of off-specular intensity'
c        thpa(jp+2)='fr_offspec              0.10  0.0 0.0  1.0'
c        thvr(jv+2)='fr_offspec               2    1'
       jm=jm+1
       jp=jp+1
       jv=jv+1

       ntrmt(jm+1)='inout_correlation  matrix=(2,2)   include= y'
       ctrmt(jm+1)='correlation length in xi off A0'
        thpa(jp+1)='xi[A]                   1.0e4  0.0 0.0  1.0'
        thpa(jp+2)='Ao                      100.0 0.0 0.0  1.0'
        thvr(jv+1)='xi[A]                    3    1  0'
        thvr(jv+2)='Ao                       4    0  1'
       jm=jm+1
       jp=jp+2
       jv=jv+2

      call conmatpar('layn',jc,jm,jp,jv,chth)
      return
      end

